C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
C .                                                               .
C .   TEST FOR THE KANTBP PROGRAM. THIS TEST IS DESIGNED TO       .
C .   CALCULATE THE REFLECTION AND TRANSMISSION MATRICES FOR AN   .
C .   2D-MODEL OF PAIR PARTICLES CONNECTED BY OSCILLATOR          .
C .   INTERACTION POTENTIAL AS THROUGHOUT NONSYMMETRIC AS WELL    .
C .   AS LONG-RANGE REPULSIVE COULOMB LIKE BARRIERS.              .
C .                                                               .
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
      PARAMETER (MTOT=10000,MITOT=30000,MZTOT=90000,NMESH=7,MDIM=4)
      IMPLICIT REAL*8 (A-H,O-Y), COMPLEX*16 (Z)
      DIMENSION TOT(MTOT),ITOT(MITOT),ZTOT(MZTOT)
      DIMENSION RMESH(NMESH),NDIL(MDIM),THRSHL(MDIM)
      CHARACTER*70 TITLE
      CHARACTER*55 FNOUT,POTEN,FMATR,EVWFN
      COMMON /CHARGE/ S1,S2,S3,Q1,Q2,XMIN
C
C      SET INITIAL VALUES OF SOME CONSTANTS AND VARIABLES
C                  FOR SCATTERING PROBLEM
C
      NAMELIST /PARAS/ TITLE,IPTYPE,ISC,IDIM,NPOL,SHIFT,IPRINT,
     1                 IPRSTP,RMESH,NDIR,NDIL,NMDIL,THRSHL,IBOUND,
     2                 FNOUT,IOUT,POTEN,IOUP,FMATR,IOUM,EVWFN,IOUF
C
      Q1 = 1D0/10
      Q2 = Q1
      XMIN = 0.1D0
      DM1 = 1.D0
      DM2 = 3.D0
      DM12 = DM1 + DM2
      S1 = DM2 / DM12
      S3 = DM1 / DM12
      S2 = DSQRT(DM1 * DM2) / DM12
C
      IN = 5
      OPEN(UNIT=IN,FILE='SQRTBT.INP',STATUS='UNKNOWN',FORM='FORMATTED')
      READ (IN,PARAS)
      WRITE(* ,1000) TITLE
C
C      INITIALIZE ARRAYS HH AND QQ
C
      NMDIL = 0
      IF (NMDIL .EQ. 0) THEN
         CALL POTCUL(TOT,MTOT,ITOT,MITOT,MDIM,NPOL,RMESH,NMESH,
     ,               POTEN,IOUP)
         NMDIL = 1
      END IF
C
      CALL KANTBP(TITLE,IPTYPE,ISC,NROOT,MDIM,IDIM,NPOL,RTOL,NITEM,
     1            SHIFT,IPRINT,IPRSTP,NMESH,RMESH,NDIR,NDIL,NMDIL,
     2            THRSHL,IBOUND,FNOUT,IOUT,POTEN,IOUP,FMATR,IOUM,
     3            EVWFN,IOUF,TOT,ITOT,ZTOT,MTOT,MITOT,MZTOT)
C
 1000 FORMAT(/1X,'PROBLEM: ',A70/1X,8('*')/)
      STOP
      END
C
      SUBROUTINE POTCUL(TOT,MTOT,ITOT,MITOT,MDIM,NPOL,RMESH,NMESH,
     1                  POTEN,IOUP)
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
C .                                                                   .
C .   P R O G R A M                                                   .
C .                  TO CALCULATE THE POTENTIAL MATRIX ELEMENTS       .
C .                  VV AND QQ OF DIMENSION MDIM X MDIM BY MEANS      .
C .                  OF THE CODE ODPEVP                               .
C .                                                                   .
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION TOT(MTOT),ITOT(MITOT),RMESH(NMESH),RMESH2(11)
      CHARACTER*70 TITLE
      CHARACTER*55 FNOUT1,FMATR1,EVWFN1,POTEN
      COMMON /CHARGE/ S1,S2,S3,Q1,Q2,XMIN
      DATA ZERO / 0.D0 /, ONE / 1.D0 / , TWO / 2.D0 /
      OPEN (UNIT=IOUP,STATUS='UNKNOWN',FILE=POTEN,FORM='UNFORMATTED')
C
      NPOL1 = 4
      RTOL = 1.D-10
      NITEM = 100
      IPRINT = 0
      IPRSTP = 1
C
      NMESH2 = 3
      X0 = DSQRT(2.D0 * MDIM - 1)
      X02 = X0 ** 2
      X = X0 + 0.1D0
  124 Y = DSQRT(X ** 2 - X02)
      EPS0 = DEXP(-0.5D0 * X * Y) * ((X + Y) / X0) ** (X02 / 2)
      IF (EPS0 .LE. RTOL) GO TO 123
      X = X + 1
      GO TO 124
C
  123 RMESH2(1) = - X
      RMESH2(2) = 64.D0
      RMESH2(3) =  X
C
      TITLE = 'PARAMETRIC DIFFERENTIAL EQUATION'
      IBOUND = 1
      FNOUT1 = 'ODPEVP.LPR'
      IOUT1 = 80
      OPEN (UNIT = IOUT1,STATUS = 'UNKNOWN',FILE = FNOUT1)
      FMATR1 = 'ODPEVP.MAT'
      IOUM1 = 120
      IOUF = 0
      ICHK = 1
      EVWFN1 = 'ODPEVP.WFN'
      SHIFTT = -1.1D0
C
      A = 4.D0/3.0D0
   11 B = A - ONE
      C = B + B + B
      EPSY = DABS(C - ONE)
      IF (EPSY .EQ. ZERO) GO TO 11
C
      NNODE  = NPOL + 1
      NNODES = NNODE
      NGQ    = NNODE
C
C      SET GAUSSIAN QUADRATURE NODES AND WEIGHTS
C
      IXG = 1
      IWG = IXG + NGQ
C
      CALL GAULEG(-ONE,ONE,TOT(IXG),TOT(IWG),NGQ,EPSY)
C
C      *****************************************************
C      ***                                               ***
C      ***   N O D A L  G E N E R A T I N G  P H A S E   ***
C      ***                                               ***
C      *****************************************************
C
      IGRID = IWG + NGQ
      NELEM = 0
C
      CALL FEGRID(RMESH,NMESH,TOT(IGRID),NGRID,NELEM,NPOL)
C
C      GENERATE AND STORE NODAL DATA
C
      INODE  = 1
      INODES = INODE   +  NNODE  *  NELEM
C
      CALL NODGEN(ITOT(INODE),NNODE,ITOT(INODES),NNODES,1,NELEM,
     1            IPRINT,IOUT1)
C
      ILASTI = INODES  +  NNODES * NELEM
C
      IUPOT   = IGRID  +  NGRID
      IQPOT   = IUPOT  +  MDIM   * MDIM   * NGQ
      IVV     = IQPOT  +  MDIM   * MDIM   * NGQ
      IQQ     = IVV    +  MDIM   * MDIM
      IEIGV   = IQQ    +  MDIM   * MDIM
      IXNODE  = IEIGV  +  MDIM
      ILASTT  = IXNODE +  NNODE
C
      MTOTT   = MTOT  - ILASTT - 1
      MITOTT  = MITOT - ILASTI - 1
      IXNODEM = IXNODE + NNODE - 1
C
      CALL VQAS0W(PARAM,12,MDIM,TOT(IVV),TOT(IQQ),.TRUE.,RTOL,RMATCH)
C
      DO 110 L = 1 , NELEM
C
        IL = (L - 1) * NNODE
        DO LL = 1 , NNODE
          IJ                   = IL + LL
          NE                   = ITOT(IJ)
          TOT(IXNODE + LL - 1) = TOT(IGRID + NE - 1)
        END DO
C
        DETJ = (TOT(IXNODEM) - TOT(IXNODE)) / TWO
        DETI = (TOT(IXNODEM) + TOT(IXNODE)) / TWO
C
        DO 50 IG = 1 , NGQ
C
          PARAM = DETJ * TOT(IXG + IG - 1) + DETI
C
          IF (SHIFTT .EQ. 0) SHIFTT = -0.11D0
C
          IF(DABS(PARAM) .LE. RMATCH) THEN
            SHIFTT = SHIFTT - 0.1D0
            CALL ODPEVP(TITLE,PARAM,TOT(IVV),TOT(IQQ),TOT(IEIGV),MDIM,
     1                NPOL1,RTOL,NITEM,SHIFTT,ICHK,IPRINT,IPRSTP,NMESH2,
     2                RMESH2,IBOUND,FNOUT1,IOUT1,FMATR1,IOUM1,EVWFN1,
     3                IOUF,TOT(ILASTT),ITOT(ILASTI),MTOTT,MITOTT)
            DO I = 1 , MDIM
              IEG = IEIGV - 1 + I
              IHH = IVV - 1 + MDIM * (I - 1) + I
              TOT(IHH) = TOT(IHH) + TOT(IEG)
            END DO
          ELSE
            CALL VQAS0W(PARAM,12,MDIM,TOT(IVV),TOT(IQQ),.FALSE.,
     1                  RTOL,RMATCH)
          ENDIF
C
          IQU = MDIM * MDIM * (IG - 1)
C
          DO 170 I = 1 , MDIM
C
            DO 140 J = I , MDIM
C
              IJ     = MDIM * (J - 1) + I
              IJV    = IVV - 1 + IJ
              IJQ    = IQQ - 1 + IJ
              IJUPOT = IUPOT - 1 + IQU + IJ
              IJQPOT = IQPOT - 1 + IQU + IJ
              TOT(IJUPOT) = TOT(IJV)
              TOT(IJQPOT) = TOT(IJQ)
C
  140       CONTINUE
C
  170     CONTINUE
C
   50   CONTINUE
C
        WRITE(IOUP)L,(((TOT(IUPOT-1+MDIM*MDIM*(IG-1)+MDIM*(J-1)+I),
     1                               J=I  ,MDIM),I=1,MDIM),IG=1,NGQ),
     1               (((TOT(IQPOT-1+MDIM*MDIM*(IG-1)+MDIM*(J-1)+I),
     1                               J=I+1,MDIM),I=1,MDIM),IG=1,NGQ)
C
  110 CONTINUE
C
      PARAM = TOT(IGRID + NGRID - 1)
      IF (SHIFTT .EQ. 0) SHIFTT = -0.11D0
C
      IF(DABS(PARAM) .LE. RMATCH) THEN
        CALL ODPEVP(TITLE,PARAM,TOT(IVV),TOT(IQQ),TOT(IEIGV),MDIM,
     1            NPOL1,RTOL,NITEM,SHIFTT,ICHK,IPRINT,IPRSTP,NMESH2,
     2            RMESH2,IBOUND,FNOUT1,IOUT1,FMATR1,IOUM1,EVWFN1,
     3            IOUF,TOT(ILASTT),ITOT(ILASTI),MTOTT,MITOTT)
        DO I = 1 , MDIM
          IEG = IEIGV - 1 + I
          IHH = IVV - 1 + MDIM * (I - 1) + I
          TOT(IHH) = TOT(IHH) + TOT(IEG)
        END DO
      ELSE
        CALL VQAS0W(PARAM,12,MDIM,TOT(IVV),TOT(IQQ),.FALSE.,RTOL,RMATCH)
      ENDIF
C
      WRITE(IOUP) NGRID,((TOT(IVV-1+MDIM*(J-1)+I),J=I  ,MDIM),I=1,MDIM),
     1                  ((TOT(IQQ-1+MDIM*(J-1)+I),J=I+1,MDIM),I=1,MDIM)
C
      PARAM = TOT(IGRID)
      IF (SHIFTT .EQ. 0) SHIFTT = -0.11D0
C
      IF(DABS(PARAM) .LE. RMATCH) THEN
        CALL ODPEVP(TITLE,PARAM,TOT(IVV),TOT(IQQ),TOT(IEIGV),MDIM,
     1            NPOL1,RTOL,NITEM,SHIFTT,ICHK,IPRINT,IPRSTP,NMESH2,
     2            RMESH2,IBOUND,FNOUT1,IOUT1,FMATR1,IOUM1,EVWFN1,
     3            IOUF,TOT(ILASTT),ITOT(ILASTI),MTOTT,MITOTT)
        DO I = 1 , MDIM
          IEG = IEIGV - 1 + I
          IHH = IVV - 1 + MDIM * (I - 1) + I
          TOT(IHH) = TOT(IHH) + TOT(IEG)
        END DO
      ELSE
        CALL VQAS0W(PARAM,12,MDIM,TOT(IVV),TOT(IQQ),.FALSE.,RTOL,RMATCH)
      ENDIF
C
      WRITE(IOUP)     1,((TOT(IVV-1+MDIM*(J-1)+I),J=I  ,MDIM),I=1,MDIM),
     1                  ((TOT(IQQ-1+MDIM*(J-1)+I),J=I+1,MDIM),I=1,MDIM)
C
      CLOSE(IOUP)
C
      RETURN
      END
C
      SUBROUTINE KANTBP(TITLE,IPTYPE,ISC,NROOT,MDIM,IDIM,NPOL,RTOL,
     1                  NITEM,SHIFT,IPRINT,IPRSTP,NMESH,RMESH,NDIR,NDIL,
     2                  NMDIL,THRSHL,IBOUND,FNOUT,IOUT,POTEN,IOUP,FMATR,
     3                  IOUM,EVWFN,IOUF,TOT,ITOT,ZTOT,MTOT,MITOT,MZTOT)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                                                                      C
C             #     #    #    #     # ####### ######  ######           C
C             #    #    # #   ##    #    #    #     # #     #          C
C             #   #    #   #  # #   #    #    #     # #     #          C
C             ####    ####### #  #  #    #    ######  ######           C
C             #   #   #     # #   # #    #    #     # #                C
C             #    #  #     # #    ##    #    #     # #                C
C             #     # #     # #     #    #    ######  #                C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                                                                      C
C                    version  3.0  from  05.05.2014                    C
C                                                                      C
C                                                                      C
C                              written  by                             C
C                                                                      C
C                                                                      C
C                A.A. GUSEV, O. CHULUUNBAATAR, S.I. VINITSKY           C
C                                                                      C
C                   JOINT INSTITUTE FOR NUCLEAR RESEARCH,              C
C                    DUBNA, 141980 MOSCOW REGION, RUSSIA               C
C                                                                      C
C                           A.G. ABRASHKEVICH                          C
C                                                                      C
C                   IBM TORONTO LAB, 8200 WARDEN AVENUE,               C
C                       MARKHAM, ON L6G 1C7, CANADA                    C
C                                                                      C
C----------------------------------------------------------------------C
C                                                                      C
C                                                                      C
C  Program KANTBP calculates energy values, reflection and             C
C  transmission matrices, and corresponding wave functions in a        C
C  coupled-channel approximation of the adiabatic approach. In this    C
C  approach, a multi-dimensional Schrodinger equation is reduced to    C
C  a system of the coupled second-order ordinary differential          C
C  equations on the finite interval with homogeneous boundary          C
C  conditions of the third type. The resulting system of equations     C
C  which contains the potential matrix elements and first-derivative   C
C  coupling terms is solved using high-order accuracy approximations   C
C  of the finite element method.                                       C
C                                                                      C
C----------------------------------------------------------------------C
C                                                                      C
C                                                                      C
C                        I N P U T  D A T A                            C
C                        ------------------                            C
C                                                                      C
C TITLE   CHARACTER  title of the run to be printed on the output      C
C                    listing. The title should be no longer than       C
C                    70 characters.                                    C
C IPTYPE  INTEGER    IPTYPE contains information about type of the     C
C                    problem solved. If IPTYPE = 0 the program         C
C                    calculates the eigenvalue problem; otherwise,     C
C                    it calculates the scattering problem.             C
C ISC     INTEGER    flag for performing the calculation of the        C
C                    reflection and transmission matrices:             C
C                    = 1 -- calculation of the reflection and          C
C                    transmission matrices is carried out only with    C
C                    direction <--;                                    C
C                    = 2 -- calculation of the reflection and          C
C                    transmission matrices is carried out only with    C
C                    direction -->;                                    C
C                    = 3 -- calculation of the reflection and          C
C                    transmission matrices is carried out with both    C
C                    directions <-- and -->. Also all properties of    C
C                    the reflection and transmission matrices are      C
C                    verified.                                         C
C NROOT   INTEGER    number of eigenvalues (energy levels) and         C
C                    eigenvectors (radial wave functions) required.    C
C                    NROOT should be equals to 1 in case of IBOUND > 4 C
C                    and not used for the scattering problem.          C
C MDIM    INTEGER    maximum number of coupled differential equations. C
C IDIM    INTEGER    dimension of the envelope space and always should C
C                    be equal to 1 for the scattering problem.         C
C NPOL    INTEGER    order of finite-element shape functions           C
C                    (interpolating Lagrange polynomials).             C
C                    Usually set to 6.                                 C
C RTOL    REAL*8     convergence tolerance on eigenvalues (1.D-06 or   C
C                    smaller). This value is not used for the          C
C                    scattering problem.                               C
C NITEM   INTEGER    maximum number of iterations permitted (usually   C
C                    set to 16). This value is not used for the        C
C                    scattering problem.                               C
C SHIFT   REAL*8     For the eigenvalue problem, SHIFT contains the    C
C                    energy spectrum. If SHIFT = 0 the value of the    C
C                    energy shift is determined automatically by the   C
C                    program; otherwise, the NROOT eigenvalues and     C
C                    eigenvectors closest to the shift given are       C
C                    calculated (the nonzero value of SHIFT is         C
C                    recommended since it significantly speeds up the  C
C                    calculation). For the scattering problem, SHIFT   C
C                    contains the given double energy spectrum.        C
C IPRINT  INTEGER    level of print:                                   C
C                    = 0 -- minimal level of print. The initial data,  C
C                    short information about the numerical scheme      C
C                    parameters, main flags and keys, and energy       C
C                    values calculated are printed out;                C
C                    = 1 -- radial functions calculated are printed    C
C                    out with step IPRSTP additionally;                C
C                    = 2 -- potential matrix is printed out with step  C
C                    IPRSTP;                                           C
C                    = 3 -- information about nodal point distribution C
C                    is printed out;                                   C
C                    = 4 -- global matrices A and B are printed out    C
C                    additionally;                                     C
C                    = 5 -- the highest level of print. The local      C
C                    stiffness and mass matrices together with all     C
C                    current information about the course of the       C
C                    subspace iteration method solution of the         C
C                    generalized eigenvalue problem are printed out.   C
C IPRSTP  INTEGER    step with which potential matrix and radial wave  C
C                    functions are printed out.                        C
C NMESH   INTEGER    dimension of array RMESH. NMESH always should be  C
C                    odd and > = 3.                                    C
C RMESH   REAL*8     array RMESH contains information about            C
C                    subdivision of interval [Z_MIN,Z_MAX] of          C
C                    hyperradius RHO on subintervals. The whole        C
C                    interval [Z_MIN,Z_MAX] is divided as follows:     C
C                    RMESH(1) = Z_MIN, RMESH(NMESH) = Z_MAX, and the   C
C                    values of RMESH(I) set the number of elements     C
C                    for each subinterval [RMESH(I-1), RMESH(I+1)],    C
C                    where I=2, 4, ... , NMESH-1.                      C
C NDIR    INTEGER    dimension of array NDIL. If NDIR > MDIM the       C
C                    message about the error is printed and the        C
C                    execution of the program is stopped.              C
C NDIL    INTEGER    array NDIL containing information about the set   C
C                    of numbers of coupled differential equations and  C
C                    always should be  NDIL(NDIR) = < MDIM.            C
C NMDIL   INTEGER    key parameter. If NMDIL = 0 the potential matrix  C
C                    elements of radial coupling are calculated and    C
C                    written to file POTEN; otherwise, they are read   C
C                    from file POTEN.                                  C
C THRSHL  REAL*8     array THRSHL of dimension MDIM containing values  C
C                    of the thresholds. This array is not used for the C
C                    eigenvalue problem.                               C
C IBOUND  INTEGER    parameter defining the type of boundary           C
C                    conditions set in the boundary points Z = Z_MIN   C
C                    and Z = Z_MAX:                                    C
C                    = 1 -- the Dirichlet -- Dirichlet boundary        C
C                    conditions;                                       C
C                    = 2 -- the Dirichlet -- Neumann boundary          C
C                    conditions;                                       C
C                    = 3 -- the Neumann -- Dirichlet boundary          C
C                    conditions;                                       C
C                    =  4 -- the Neumann -- Neumann boundary           C
C                    conditions;                                       C
C                    = 6 -- the Dirichlet -- third type boundary       C
C                    conditions (only for NROOT = 1):                  C
C                    at Z = Z_MIN the Dirichlet boundary condition     C
C                    (see the case 2) is used and at Z_MAX the         C
C                    user-supplied subroutine ASYMEV for the           C
C                    calculation of initial value LAMBDA^(0)(Z_MAX);   C
C                    = 8 -- the Neumann -- third type boundary         C
C                    conditions (only for NROOT = 1):                  C
C                    at Z = Z_MIN the Neumann boundary condition (see  C
C                    the case 4) is used and at Z_MAX the same         C
C                    boundary condition is used as in case 6.          C
C                    IBOUND always should be equal to 8 for the        C
C                    scattering problem. In this case user-supplied    C
C                    subroutines ASYMSL AND ASYMSR for the calculation C
C                    of the regular, irregular asymptotic              C
C                    matrix-solutions and their derivatives            C
C                    at Z = Z_MIN and Z = Z_MAX are used.              C
C FNOUT   CHARACTER  name of the output file (up to 55 characters)     C
C                    for printing out the results of the calculation.  C
C                    It is system specific and may include a complete  C
C                    path to the file location.                        C
C IOUT    INTEGER    number of the output logical device for printing  C
C                    out the results of the calculation (usually set   C
C                    to 7).                                            C
C POTEN   CHARACTER  name of the input/output file (up to 55           C
C                    characters) containing potential matrix elements  C
C                    of radial coupling.                               C
C IOUP    INTEGER    number of the logical device for reading/storing  C
C                    data from/into file POTEN.                        C
C FMATR   CHARACTER  name of the scratch file (up to 55 characters)    C
C                    for storing stiffness matrix.                     C
C IOUM    INTEGER    number of the logical device for storing          C
C                    stiffness matrix.                                 C
C EVWFN   CHARACTER  name of the output file (up to 55 characters) for C
C                    storing the results of the calculation, namely,   C
C                    the energy values or reaction matrix,             C
C                    finite-element grid points, and radial wave       C
C                    functions. It is used only if IOUF > 0.           C
C IOUF    INTEGER    number of the logical device for storing data     C
C                    into file EVWFN.                                  C
C TOT     REAL*8     working vector of the DOUBLE PRECISION type.      C
C ITOT    INTEGER    working vector of the INTEGER type.               C
C ZTOT    COMPLEX*16 working vector of the DOUBLE COMPLEX type.        C
C MTOT    INTEGER    dimension of the DOUBLE PRECISION working array   C
C                    TOT. The last address ILAST of array TOT is       C
C                    calculated and then compared with the given value C
C                    of MTOT. If ILAST > MTOT the message about an     C
C                    error is printed and the execution of the program C
C                    is aborted. In the last case, in order to carry   C
C                    out the required calculation it is necessary to   C
C                    increase the dimension MTOT of array TOT to the   C
C                    quantity ILAST taken from the message.            C
C MITOT   INTEGER    dimension of the INTEGER working array ITOT. The  C
C                    last address ILAST of array ITOT is calculated    C
C                    and then compared with the given value of MITOT.  C
C                    If ILAST > MITOT the message about an error is    C
C                    printed and the execution of the program is       C
C                    aborted. In the last case, in order to carry out  C
C                    the required calculation it is necessary to       C
C                    increase the dimension MITOT of array ITOT to the C
C                    quantity ILAST taken from the message.            C
C MZTOT   INTEGER    dimension of the DOUBLE COMPLEX working array     C
C                    ZTOT. The last address ILAST of array ZTOT is     C
C                    calculated and then compared with the given value C
C                    of MZTOT. If ILAST > MZTOT the message about an   C
C                    error is printed and the execution of the program C
C                    is aborted. In the last case, in order to carry   C
C                    out the required calculation it is necessary to   C
C                    increase the dimension MZTOT of array ZTOT to the C
C                    quantity ILAST taken from the message.            C
C                                                                      C
C----------------------------------------------------------------------C
C                                                                      C
C                                                                      C
C                        O U T P U T  D A T A                          C
C                        --------------------                          C
C                                                                      C
C The results of the calculation of energy values or reaction matrix   C
C and radial wave functions are written using unformatted segmented    C
C records into file EVWFN, according to the following operator:        C
C                                                                      C
C     WRITE(IOUF) NDIM,NN,NROOT,NGRID,(EIGV(I),I=1,NROOT),             C
C    1            (XGRID(I),I=1,NGRID),((R(I,J),I=1,NN),J=1,NROOT)     C
C                                                                      C
C or                                                                   C
C                                                                      C
C     WRITE(IOUF) NDIM,NN,NOPEN,NGRID,((RR(I,J),I=1,NOPEN),J=1,NOPEN), C
C    1                                ((TT(I,J),I=1,NOPEN),J=1,NOPEN), C
C    1           (XGRID(I),I=1,NGRID),((R(I,J),I=1,NN),J=1,NOPEN)      C
C                                                                      C
C In the above, parameters presented in the WRITE statement have the   C
C following meaning:                                                   C
C NDIM is the number of equations.                                     C
C NGRID is the number of finite-element grid points.                   C
C NN = NDIM * NGRID, if IBOIND = 4 or 8;                               C
C NN = NDIM * (NGRID - 1), if IBOIND = 3 or 2 or 6;                    C
C NN = NDIM * (NGRID - 2), if IBOIND = 1.                              C
C NROOT is the number of roots (energy levels).                        C
C NOPEN is the number of open channels.                                C
C Array EIGV contains the energy values calculated.                    C
C Arrays RR and TT contain the reflection and transmission matrices    C
C       values calculated, respectively.                               C
C Array XGRID contains the values of the finite-element grid points.   C
C Array R contains NROOT or NOPEN eigenfunctions each per NN elements  C
C       in length stored in the following way: for each of the NGRID   C
C       mesh points per NDIM elements of eigenfunction                 C 
C       (see scheme below):                                            C
C                                                                      C
C        1-st root             2-nd root   . . .       last root       C
C                                                                      C
C                1                     1                      1        C
C                2                     2                      2        C
C    1-st point  .         1-st point  .   . . .   1-st point .        C
C                .                     .                      .        C
C                .                     .                      .        C
C             NDIM                  NDIM                   NDIM        C
C                                                                      C
C                1                     1                      1        C
C                2                     2                      2        C
C    2-nd point  .         2-nd point  .   . . .   2-nd point .        C
C                .                     .                      .        C
C                .                     .                      .        C
C             NDIM                  NDIM                   NDIM        C
C                                                                      C
C                .                     .                      .        C
C                .                     .                      .        C
C                .                     .                      .        C
C                                                                      C
C                1                     1                      1        C
C                2                     2                      2        C
C    last point  .         last point  .   . . .   last point .        C
C                .                     .                      .        C
C                .                     .                      .        C
C             NDIM                  NDIM                   NDIM        C
C                                                                      C
C----------------------------------------------------------------------C
C                                                                      C
C                                                                      C
C                         PUBLISHED PROGRAMS USED                      C
C                         -----------------------                      C
C                                                                      C
C          Program SSPACE to solve the generalized eigenvalue          C
C          problem by the subspace iteration method. Published in:     C
C          K.- J. Bathe, Finite ELement Procedures in Engineering      C
C          Analysis (Prentice-Hall, Englewood Cliffs, NY, 1982)        C
C                                                                      C
C          Program GAULEG to calculate nodes and weights of the        C
C          Gauss-Legendre quadrature. Published in: W.H. Press,        C
C          B.F. Flanery, S.A. Teukolsky, and W.T. Vetterley,           C
C          Numerical Recipes: The Art of Scientific Computing          C
C          (Cambridge University Press, Cambridge, 1986)               C
C                                                                      C
C          Program GAUSSJ to calculate solution of the linear          C
C          equation by Gauss-Jordan elimination. Published in:         C
C          W.H. Press, B.F. Flanery, S.A. Teukolsky, and               C
C          W.T. Vetterley, Numerical Recipes: The Art of Scientific    C
C          Computing (Cambridge University Press, Cambridge, 1986)     C
C                                                                      C
C----------------------------------------------------------------------C
C                                                                      C
      IMPLICIT REAL*8 (A-H,O-Y), COMPLEX*16 (Z)
      DIMENSION TOT(MTOT),ITOT(MITOT),RMESH(NMESH),NDIL(NDIR),
     1          THRSHL(MDIM),ZTOT(MZTOT)
      CHARACTER*70 TITLE,PROBTYPE
      CHARACTER*55 FNOUT,POTEN,FMATR,EVWFN
      DATA ZERO / 0.D0 /, ONE / 1.D0 /
C
C      *******************************************
C      ***                                     ***
C      ***    I N P U T  D A T A  P H A S E    ***
C      ***                                     ***
C      *******************************************
C
C      THE FOLLOWING FILES ARE USED
C
C          IOUT   =  OUTPUT LOGICAL DEVICE NUMBER FOR
C                    PRINTING OUT RESULTS OF THE CALCULATION
C          IOUP   =  INPUT DEVICE WITH POTENTIAL MATRIX ELEMENTS
C          IOUM   =  OUTPUT STIFFNESS MATRIX
C          IOUF   =  OUTPUT LOGICAL DEVICE FOR STORING
C                    RADIAL WAVE FUNCTIONS
C
      OPEN (UNIT=IOUT,STATUS='UNKNOWN',FILE=FNOUT)
      OPEN (UNIT=IOUP,STATUS='UNKNOWN',FILE=POTEN,FORM='UNFORMATTED')
      OPEN (UNIT=IOUM,STATUS='UNKNOWN',FILE=FMATR,FORM='UNFORMATTED')
      IF (IOUF .GT. 0)
     1OPEN (UNIT=IOUF,STATUS='UNKNOWN',FILE=EVWFN,FORM='UNFORMATTED')
C
      IF (IPTYPE .EQ. 0) THEN
        PROBTYPE = 'EIGEN'
      ELSE
        PROBTYPE = 'SCATTER'
      END IF
C
C      THE RELATIVE ERROR OF THE CALCULATION
C
      A = 4.D0/3.0D0
   11 B = A - ONE
      C = B + B + B
      EPSY = DABS(C - ONE)
      IF (EPSY .EQ. ZERO) GO TO 11
C
      DO I = 1 , MTOT
        TOT(I) = ZERO
      END DO
      DO I = 1 , MITOT
        ITOT(I) = 0
      END DO
      DO I = 1 , MZTOT
        ZTOT(I) = ZERO
      END DO
C
C      FORM AND CHECK INPUT DATA
C
      CALL CHECKN(PROBTYPE,SHIFT,THRSHL,RTOL,EPSY,MDIM,NDIR,NDIL,
     1            IDIM,NROOT,IBOUND,IOUT,IOUP,IOUM)
C
      IF (PROBTYPE .EQ. 'EIGEN') THEN
        IF (NROOT .LT. 25) THEN
          NC = MIN0(2 * NROOT,NROOT + 8)
        ELSE
          NC = NROOT + 5
        END IF
        NNC  = NC * (NC + 1) / 2
      END IF
      NNODE  = NPOL + 1
      NGQ    = NNODE
C
C      SET GAUSSIAN QUADRATURE NODES AND WEIGHTS
C
      IXG = 1
      IWG = IXG + NGQ
C
      CALL GAULEG(-ONE,ONE,TOT(IXG),TOT(IWG),NGQ,EPSY)
C
C      *****************************************************
C      ***                                               ***
C      ***   N O D A L  G E N E R A T I N G  P H A S E   ***
C      ***                                               ***
C      *****************************************************
C
      IGRID = IWG + NGQ
      NELEM = 0
C
      CALL FEGRID(RMESH,NMESH,TOT(IGRID),NGRID,NELEM,NPOL)
C
      IF (IPRINT .GE. 0) THEN
        WRITE(IOUT,1000) TITLE
        IF (PROBTYPE .EQ. 'EIGEN') THEN
          WRITE(IOUT,1010) MDIM,NROOT,NELEM,NGRID,NPOL,NGQ,NC,
     1                     IDIM,IBOUND,SHIFT,RTOL
        ELSE
          WRITE(IOUT,1020) MDIM,NELEM,NGRID,NPOL,NGQ,IDIM,
     1                     IBOUND,SHIFT
        END IF
        WRITE(IOUT,1030)
        NO    = 0
        DO 20 I = 3 , NMESH , 2
           NO  = NO + 1
           NM  = IDINT(RMESH(I-1))
           XM  = (RMESH(I) - RMESH(I-2)) / NM
           XS  = XM / NPOL
           WRITE(IOUT,1040) NO,NM,RMESH(I-2),XM,XS,RMESH(I)
   20   CONTINUE
      END IF
C
      DO 300 NDF = 1 , NDIR
C
        NDIM = NDIL(NDF)
        NNODES = NNODE * NDIM
        NSTF   = NNODES * (NNODES + 1) / 2
C
        IF (IPRINT .GE. 0) THEN
          WRITE(IOUT,1060)
          WRITE(IOUT,1090) NDIM, MDIM
          WRITE(*   ,1060)
          WRITE(   *,1090) NDIM, MDIM
        END IF
C
        INODE  = 1
        INODES = INODE   +  NNODE  *  NELEM
C
C      GENERATE AND STORE NODAL DATA
C
        CALL NODGEN(ITOT(INODE),NNODE,ITOT(INODES),NNODES,NDIM,NELEM,
     1              IPRINT,IOUT)
C
        NN    = NDIM * NGRID
        NNE   = NN
        NNM   = NN + 1
C
        IMAXA = INODES +  NNODES * NELEM
        IMHT  = IMAXA  +  NNM
        INHT  = IMHT   +  NNM
        ILAST = INHT   +  NNM
C
        IF (IPRINT .GE. 2) WRITE(IOUT,1070) ILAST
C
        IF (ILAST .GT. MITOT) THEN
           CALL ERRDIM(ILAST - MITOT,1,IOUT)
           WRITE(IOUT,1070) ILAST
        END IF
C
C      SET THE DIRICHLET AND/OR NEUMANN BOUNDARY CONDITIONS
C
        IBOUN = IBOUND
        IF (IBOUND .GE. 6) IBOUN = IBOUN - 4
        CALL BOUNDC(ITOT(INODE),ITOT(INODES),ITOT(IMAXA),ITOT(IMHT),
     1              ITOT(INHT),IBOUN,NNODE,NNODES,NELEM,NDIM,NN,NNE,
     2              IPRINT,IOUT)
C
C      CALCULATE ADDRESSES OF DIAGONAL ELEMENTS
C      IN BANDED STIFFNESS AND MASS MATRICES
C
        CALL MAXHT(ITOT(IMAXA),ITOT(IMHT),ITOT(INODES),NNODES,NELEM,
     1             NN,NNM,NWK,NWM,MK,IPRINT,IOUT)
C
        MMK  = NWK / NN
        IF (IPRINT .GE. 0) WRITE(IOUT,1050) NN,NWK,MK,MMK
C
        NWT = NWK
C
        IF (PROBTYPE .EQ. 'EIGEN') THEN
C
          NWT = 2 * NWK
C
C      **********************************************************
C      ***                                                    ***
C      ***    E L E M E N T  G E N E R A T I N G  P H A S E   ***
C      ***                                                    ***
C      **********************************************************
C
C      CALCULATE AND ASSEMBLE STIFFNESS AND MASS
C      ELEMENT MATRICES INTO THE GLOBAL ONES
C
          IUPOT  = IGRID  +  NGRID
          IQPOT  = IUPOT  +  MDIM   * MDIM   * NGQ
          IVV    = IQPOT  +  MDIM   * MDIM   * NGQ
          IQQ    = IVV    +  MDIM   * MDIM
          IPSI   = IQQ    +  MDIM   * MDIM
          IDPSI  = IPSI   +  NGQ    * NNODE
          IA     = IDPSI  +  NGQ    * NNODE
          IESTFA = IA     +  NWT
          IESTFB = IESTFA +  NSTF
          IESTF  = IESTFB +  NSTF
          IEMSS  = IESTF  +  NNODES * NNODES
          IEST1  = IEMSS  +  NNODES * NNODES
          IEMS1  = IEST1  +  NNODE  * NNODE
          IXNODE = IEMS1  +  NNODE  * NNODE
          IUNODE = IXNODE +  NNODE
          IQNODE = IUNODE +  NNODE
          ILAST  = IQNODE +  NNODE
C
          IF (IPRINT .GE. 2) WRITE(IOUT,1080) ILAST
C
          IF (ILAST .GT. MTOT) THEN
             CALL ERRDIM(ILAST - MTOT,2,IOUT)
             WRITE(IOUT,1080) ILAST
          END IF
C
C      CALCULATE AND ASSEMBLE STIFFNESS MATRIX
C
          CALL ASSMBL(ITOT(IMAXA),TOT(IA),TOT(IESTF),TOT(IEMSS),
     1                TOT(IESTFA),TOT(IESTFB),TOT(IEST1),TOT(IEMS1),
     2                TOT(IGRID),TOT(IUPOT),TOT(IQPOT),TOT(IXNODE),
     3                TOT(IUNODE),TOT(IQNODE),TOT(IPSI),TOT(IDPSI),
     4                TOT(IXG),TOT(IWG),TOT(IVV),TOT(IQQ),ITOT(INODE),
     5                ITOT(INODES),NDIL,NDIR,NMDIL,NELEM,NNODE,NNODES,
     6                NGQ,NN,NNM,NWK,NWM,NWT,NDIM,MDIM,IDIM,NGRID,NSTF,
     7                IPRINT,IOUP,PROBTYPE,SHIFT,IPRSTP,IOUT)
C
C           *****************************************
C           ***                                   ***
C           ***       EIGENVALUE PROBLEM          ***
C           ***                                   ***
C           *****************************************
C
          IB     = IA     +   NWK
          IR     = IB     +   NWK
          IW     = IR     +   NC     * NN
          ITT    = IW     +   NN
          IEI    = ITT    +   NN
          ID     = IEI    +   NC
          IBUP   = ID     +   NC
          IBUPC  = IBUP   +   NC
          IRTOLV = IBUPC  +   NC
          IBLO   = IRTOLV +   NC
          IAR    = IBLO   +   NC
          IBR    = IAR    +   NNC
          IVEC   = IBR    +   NNC
          IEIGV  = IVEC   +   NC     * NC
          ILAST  = IEIGV  +   NROOT
C
          IF (IPRINT .GE. 2) WRITE(IOUT,1080) ILAST
C
          IF (ILAST .GT. MTOT) THEN
             CALL ERRDIM(ILAST - MTOT,3,IOUT)
             WRITE(IOUT,1080) ILAST
          END IF
C
          CALL EVSOLV(ITOT(IMAXA),TOT(IR),TOT(IW),TOT(ITT),TOT(IA),
     1                TOT(IB),TOT(IEI),TOT(IEIGV),TOT(ID),TOT(IBUP),
     2                TOT(IBUPC),TOT(IRTOLV),TOT(IBLO),TOT(IAR),
     3                TOT(IBR),TOT(IVEC),TOT(IGRID),TOT(IVV),TOT(IQQ),
     4                TOT(IPSI),TOT(IDPSI),ITOT(INODE),NGQ,NNODE,
     5                NGRID,NN,NNM,NWK,NWM,NROOT,NC,NNC,NITEM,NELEM,
     6                RTOL,SHIFT,NDIM,MDIM,IDIM,IPRINT,IPRSTP,IOUT,
     7                IOUM,IOUF,IBOUND)
C
        ELSE IF (PROBTYPE .EQ. 'SCATTER') THEN
C
C
C      **********************************************************
C      ***                                                    ***
C      ***    E L E M E N T  G E N E R A T I N G  P H A S E   ***
C      ***                                                    ***
C      **********************************************************
C
C      CALCULATE AND ASSEMBLE STIFFNESS AND MASS
C      ELEMENT MATRICES INTO THE GLOBAL ONES
C
          IUPOT  = IGRID  +  NGRID
          IQPOT  = IUPOT  +  MDIM   * MDIM   * NGQ
          IVV    = IQPOT  +  MDIM   * MDIM   * NGQ
          IQQ    = IVV    +  MDIM   * MDIM
          IPSI   = IQQ    +  MDIM   * MDIM
          IDPSI  = IPSI   +  NGQ    * NNODE
          IESTFA = IDPSI  +  NGQ    * NNODE
          IESTF  = IESTFA +  NSTF
          IEST1  = IESTF  +  NNODES * NNODES
          IEMS1  = IEST1  +  NNODE  * NNODE
          IXNODE = IEMS1  +  NNODE  * NNODE
          IUNODE = IXNODE +  NNODE
          IQNODE = IUNODE +  NNODE
          ILAST  = IQNODE +  NNODE
C
          IF (IPRINT .GE. 2) WRITE(IOUT,1080) ILAST
C
          IF (ILAST .GT. MTOT) THEN
             CALL ERRDIM(ILAST - MTOT,2,IOUT)
             WRITE(IOUT,1080) ILAST
          END IF
C
          NOPEN = 0
          DO I = 1 , NDIM
            IF (SHIFT .LT. THRSHL(I)) GO TO 13
            NOPEN = NOPEN + 1
          END DO
C
C                COMPLEX ARRAY
C
   13     IZ     = 1
          IR     = IZ      +   NWK
          IPIRR  = IR      +   NN    * NOPEN
          IPREG  = IPIRR   +   NDIM  * NOPEN
          IDPIRR = IPREG   +   NDIM  * NOPEN
          IDPREG = IDPIRR  +   NDIM  * NOPEN
          IRR_R  = IDPREG  +   NDIM  * NOPEN
          ITT_R  = IRR_R   +   NOPEN * NOPEN
          IRR_L  = ITT_R   +   NOPEN * NOPEN
          ITT_L  = IRR_L   +   NOPEN * NOPEN
          IWW    = ITT_L   +   NOPEN * NOPEN
          IRR0   = IWW     +   NDIM  * NOPEN
          IFAC   = IRR0    +   NDIM  * NDIM
          IWL    = IFAC    +   NN    * NDIM
          IWR    = IWL     +   NDIM  * NDIM
          ILAST  = IWR     +   NDIM  * NDIM
C
          IF (IPRINT .GE. 2) WRITE(IOUT,1085) ILAST
C
          IF (ILAST .GT. MZTOT) THEN
             CALL ERRDIM(ILAST - MZTOT,5,IOUT)
             WRITE(IOUT,1085) ILAST
          END IF
C
C      CALCULATE AND ASSEMBLE STIFFNESS MATRIX
C
          CALL ASSMBC(ITOT(IMAXA),ZTOT(IZ),TOT(IESTF),
     1                TOT(IESTFA),TOT(IEST1),TOT(IEMS1),
     2                TOT(IGRID),TOT(IUPOT),TOT(IQPOT),TOT(IXNODE),
     3                TOT(IUNODE),TOT(IQNODE),TOT(IPSI),TOT(IDPSI),
     4                TOT(IXG),TOT(IWG),TOT(IVV),TOT(IQQ),ITOT(INODE),
     5                ITOT(INODES),NDIL,NDIR,NMDIL,NELEM,NNODE,NNODES,
     6                NGQ,NN,NNM,NWK,NWM,NWT,NDIM,MDIM,IDIM,NGRID,NSTF,
     7                IPRINT,IOUP,PROBTYPE,SHIFT,IPRSTP,IOUM,IOUT)
C
C           *****************************************
C           ***                                   ***
C           ***       SCATTERING PROBLEM          ***
C           ***                                   ***
C           *****************************************
C
          IF (ISC .EQ. 1 .OR. ISC .EQ. 3) THEN 
C
            IF (IPRINT .GE. 0) THEN
              WRITE(IOUT,1060)
              WRITE(IOUT,1110)
              WRITE(*   ,1060)
              WRITE(*   ,1110)
            END IF
C
            CALL SCSOLC(ITOT(IMAXA),ZTOT(IR),TOT(IQQ),ZTOT(IFAC),
     1                  TOT(IGRID),NGRID,NN,NNM,NWK,SHIFT,THRSHL,NDIM,
     2                  MDIM,IDIM,IPRINT,IPRSTP,IOUT,IOUF,IBOUND,NOPEN,
     3                  ZTOT(IPIRR),ZTOT(IPREG),ZTOT(IDPIRR),
     4                  ZTOT(IDPREG),TOT(IESTFA),ZTOT(IRR_L),
     5                  ZTOT(ITT_L),ZTOT(IWL),ZTOT(IWW),ZTOT(IRR0),
     6                  ZTOT(IZ),ZTOT(IWR),IOUM,1)
C
          END IF
C
          IF (ISC .EQ. 2 .OR. ISC .EQ. 3) THEN 
C
            IF (IPRINT .GE. 0) THEN
              WRITE(IOUT,1060)
              WRITE(IOUT,1120)
              WRITE(*   ,1060)
              WRITE(*   ,1120)
            END IF
C
            CALL SCSOLC(ITOT(IMAXA),ZTOT(IR),TOT(IVV),ZTOT(IFAC),
     1                  TOT(IGRID),NGRID,NN,NNM,NWK,SHIFT,THRSHL,NDIM,
     2                  MDIM,IDIM,IPRINT,IPRSTP,IOUT,IOUF,IBOUND,NOPEN,
     3                  ZTOT(IPIRR),ZTOT(IPREG),ZTOT(IDPIRR),
     4                  ZTOT(IDPREG),TOT(IESTFA),ZTOT(IRR_R),
     5                  ZTOT(ITT_R),ZTOT(IWL),ZTOT(IWW),ZTOT(IRR0),
     6                  ZTOT(IZ),ZTOT(IWR),IOUM,2)
C
          END IF
C
          IF (IPRINT .GE. 0 .AND. ISC .EQ. 3) THEN
            CALL CHECRT(NOPEN,ZTOT(IRR_L),ZTOT(ITT_L),ZTOT(IRR_R),
     1                  ZTOT(ITT_R),ZTOT(IZ),IOUT)
          END IF
C
        END IF
C
  300 CONTINUE
C
      CLOSE (UNIT=IOUP)
      CLOSE (UNIT=IOUM)
      RETURN
 1000 FORMAT(/1X,'PROBLEM: ',A70/1X,8('*')/)
 1010 FORMAT(/15X,'C O N T R O L  I N F O R M A T I O N'/
     *        15X,'------------------------------------'//5X,
     * 'NUMBER OF DIFFERENTIAL EQUATIONS. . . . . (MDIM  ) = ',I6/5X,
     * 'NUMBER OF ENERGY LEVELS REQUIRED. . . . . (NROOT ) = ',I6/5X,
     * 'NUMBER OF FINITE ELEMENTS . . . . . . . . (NELEM ) = ',I6/5X,
     * 'NUMBER OF GRID POINTS . . . . . . . . . . (NGRID ) = ',I6/5X,
     * 'ORDER  OF SHAPE FUNCTIONS . . . . . . . . (NPOL  ) = ',I6/5X,
     * 'ORDER  OF GAUSS-LEGENDRE QUADRATURE . . . (NGQ   ) = ',I6/5X,
     * 'NUMBER OF SUBSPACE ITERATION VECTORS. . . (NC    ) = ',I6/5X,
     * 'DIMENSION OF ENVELOPE SPACE . . . . . . . (IDIM  ) = ',I6/5X,
     * 'BOUNDARY CONDITION CODE . . . . . . . . . (IBOUND) = ',I6/5X,
     * 'SHIFT OF DOUBLE ENERGY SPECTRUM . . . . . (SHIFT ) = ',G14.6/5X,
     * 'CONVERGENCE TOLERANCE . . . . . . . . . . (RTOL  ) = ',G14.6/)
 1020 FORMAT(/15X,'C O N T R O L  I N F O R M A T I O N'/
     *        15X,'------------------------------------'//5X,
     * 'NUMBER OF DIFFERENTIAL EQUATIONS. . . . . (MDIM  ) = ',I6/5X,
     * 'NUMBER OF FINITE ELEMENTS . . . . . . . . (NELEM ) = ',I6/5X,
     * 'NUMBER OF GRID POINTS . . . . . . . . . . (NGRID ) = ',I6/5X,
     * 'ORDER OF SHAPE FUNCTIONS. . . . . . . . . (NPOL  ) = ',I6/5X,
     * 'ORDER OF GAUSS-LEGENDRE QUADRATURE. . . . (NGQ   ) = ',I6/5X,
     * 'DIMENSION OF ENVELOPE SPACE . . . . . . . (IDIM  ) = ',I6/5X,
     * 'BOUNDARY CONDITION CODE . . . . . . . . . (IBOUND) = ',I6/5X,
     * 'DOUBLE ENERGY SPECTRUM. . . . . . . . . . (SHIFT ) = ',G14.6/)
 1030 FORMAT(/4X,
     * 'SUBDIVISION OF RHO-REGION ON THE FINITE-ELEMENT GROUPS:'/4X,
     * '****************************************************** ',//
     *2X,' NO OF  NUMBER OF  BEGIN OF  LENGTH OF    GRID     END OF  '/
     *2X,' GROUP  ELEMENTS   INTERVAL   ELEMENT     STEP    INTERVAL'/
     *2X,' -----  ---------  --------  ---------  --------  --------')
 1040 FORMAT(2X,I4,4X,I6,3X,F10.3,1X,F9.5,1X,F9.5,1X,F10.3)
 1050 FORMAT(//15X,'T O T A L  S Y S T E M  D A T A  '/
     *         15X,'-------------------------------  '//5X,
     * 'TOTAL NUMBER OF ALGEBRAIC EQUATIONS. . . . (NN ) =',I9/5X,
     * 'TOTAL NUMBER OF MATRIX ELEMENTS. . . . . . (NWK) =',I9/5X,
     * 'MAXIMUM HALF BANDWIDTH . . . . . . . . . . (MK ) =',I9/5X,
     * 'MEAN    HALF BANDWIDTH . . . . . . . . . . (MMK) =',I9/)
 1060 FORMAT(/80('*')/)
 1070 FORMAT(/5X,'LAST ADDRESS OF ARRAY ITOT USED = ',I10/)
 1080 FORMAT(/5X,'LAST ADDRESS OF ARRAY TOT USED = ',I10/)
 1085 FORMAT(/5X,'LAST ADDRESS OF ARRAY ZTOT USED = ',I10/)
 1090 FORMAT( 5X,'NDIM, MDIM=',2I10)
 1100 FORMAT(/5X,'TYPE OF CONSIDERING PROBLEM',5X,A70/)
 1110 FORMAT(5X,'CALCULATION OF WAVE FUNCTION WITH DIRECTION <--'/)
 1120 FORMAT(5X,'CALCULATION OF WAVE FUNCTION WITH DIRECTION -->'/)
      END
C
      SUBROUTINE CHECRT(NOPEN,ZR_L,ZT_L,ZR_R,ZT_R,ZR,IOUT)
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
C .                                                                   .
C .   P R O G R A M                                                   .
C .                  TO CHECK THE PROPERTIES OF REFLECTION AND        .
C .                  TRANSMISSION MATRICES                            .
C .                                                                   .
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
      IMPLICIT REAL*8 (A-H,O-Y)
      IMPLICIT COMPLEX*16 (Z)
      DIMENSION ZR_L(NOPEN,NOPEN),ZT_L(NOPEN,NOPEN),ZR(NOPEN,NOPEN)
      DIMENSION ZR_R(NOPEN,NOPEN),ZT_R(NOPEN,NOPEN)
      DATA DZERO / 0.D0 /
C
      WRITE(IOUT,1010)
      WRITE(IOUT,1000)
      WRITE(*   ,1010)
      WRITE(*   ,1000)
C
      ERROR = DZERO
      DO I = 1 , NOPEN
        DO J = 1 , NOPEN
          ZR(I,J) = DZERO
          DO L = 1 , NOPEN
            ZR(I,J) = ZR(I,J)
     1              + DCONJG(ZT_L(L,I)) * ZT_L(L,J)
     2              + DCONJG(ZR_L(L,I)) * ZR_L(L,J)
          END DO
          IF (I .EQ. J) THEN
            ERROR = DMAX1(ERROR,CDABS(ZR(I,J)) - 1)
          ELSE
            ERROR = DMAX1(ERROR,CDABS(ZR(I,J))    )
          END IF
        END DO
      END DO
C
      WRITE(IOUT,1030)
      WRITE(*   ,1030)
      DO I = 1 , NOPEN
        WRITE(IOUT,1020) (DREAL(ZR(I,J)),J=1,NOPEN)
        WRITE(*   ,1020) (DREAL(ZR(I,J)),J=1,NOPEN)
      END DO
      WRITE(IOUT,1130) ERROR
      WRITE(*   ,1130) ERROR
C
      ERROR = DZERO
      DO I = 1 , NOPEN
        DO J = 1 , NOPEN
          ZR(I,J) = DZERO
          DO L = 1 , NOPEN
            ZR(I,J) = ZR(I,J)
     1              + DCONJG(ZT_R(L,I)) * ZT_R(L,J)
     2              + DCONJG(ZR_R(L,I)) * ZR_R(L,J)
          END DO
          IF (I .EQ. J) THEN
            ERROR = DMAX1(ERROR,CDABS(ZR(I,J)) - 1)
          ELSE
            ERROR = DMAX1(ERROR,CDABS(ZR(I,J))    )
          END IF
        END DO
      END DO
C
      WRITE(IOUT,1040)
      WRITE(*   ,1040)
      DO I = 1 , NOPEN
        WRITE(IOUT,1020) (DREAL(ZR(I,J)),J=1,NOPEN)
        WRITE(*   ,1020) (DREAL(ZR(I,J)),J=1,NOPEN)
      END DO
      WRITE(IOUT,1130) ERROR
      WRITE(*   ,1130) ERROR
C
      ERROR = DZERO
      DO I = 1 , NOPEN
        DO J = 1 , NOPEN
          ZR(I,J) = DZERO
          DO L = 1 , NOPEN
            ZR(I,J) = ZR(I,J) + DCONJG(ZT_R(L,I)) * ZR_L(L,J)
     1                        + DCONJG(ZR_R(L,I)) * ZT_L(L,J)
          END DO
          ERROR = DMAX1(ERROR,CDABS(ZR(I,J))    )
        END DO
      END DO
C
      WRITE(IOUT,1050)
      WRITE(*   ,1050)
      DO I = 1 , NOPEN
        WRITE(IOUT,1020) (DREAL(ZR(I,J)),J=1,NOPEN)
        WRITE(*   ,1020) (DREAL(ZR(I,J)),J=1,NOPEN)
      END DO
      WRITE(IOUT,1060)
      WRITE(*   ,1060)
      DO I = 1 , NOPEN
        WRITE(IOUT,1020) (DIMAG(ZR(I,J)),J=1,NOPEN)
        WRITE(*   ,1020) (DIMAG(ZR(I,J)),J=1,NOPEN)
      END DO
      WRITE(IOUT,1130) ERROR
      WRITE(*   ,1130) ERROR
C
      ERROR = DZERO
      DO I = 1 , NOPEN
        DO J = 1 , NOPEN
          ZR(I,J) = DZERO
          DO L = 1 , NOPEN
            ZR(I,J) = ZR_L(J,I)-ZR_L(I,J)
          END DO
          ERROR = DMAX1(ERROR,CDABS(ZR(I,J))    )
        END DO
      END DO
      WRITE(IOUT,1070)
      WRITE(*   ,1070)
      DO I = 1 , NOPEN
        WRITE(IOUT,1020) (DREAL(ZR(I,J)),J=1,NOPEN)
        WRITE(*   ,1020) (DREAL(ZR(I,J)),J=1,NOPEN)
      END DO
      WRITE(IOUT,1080)
      WRITE(*   ,1080)
      DO I = 1 , NOPEN
        WRITE(IOUT,1020) (DIMAG(ZR(I,J)),J=1,NOPEN)
        WRITE(*   ,1020) (DIMAG(ZR(I,J)),J=1,NOPEN)
      END DO
      WRITE(IOUT,1130) ERROR
      WRITE(*   ,1130) ERROR
C
      ERROR = DZERO
      DO I = 1 , NOPEN
        DO J = 1 , NOPEN
          ZR(I,J) = DZERO
          DO L = 1 , NOPEN
            ZR(I,J) = ZR_R(J,I)-ZR_R(I,J)
          END DO
          ERROR = DMAX1(ERROR,CDABS(ZR(I,J))    )
        END DO
      END DO
      WRITE(IOUT,1090)
      WRITE(*   ,1090)
      DO I = 1 , NOPEN
        WRITE(IOUT,1020) (DREAL(ZR(I,J)),J=1,NOPEN)
        WRITE(*   ,1020) (DREAL(ZR(I,J)),J=1,NOPEN)
      END DO
      WRITE(IOUT,1100)
      WRITE(*   ,1100)
      DO I = 1 , NOPEN
        WRITE(IOUT,1020) (DIMAG(ZR(I,J)),J=1,NOPEN)
        WRITE(*   ,1020) (DIMAG(ZR(I,J)),J=1,NOPEN)
      END DO
      WRITE(IOUT,1130) ERROR
      WRITE(*   ,1130) ERROR
C
      ERROR = DZERO
      DO I = 1 , NOPEN
        DO J = 1 , NOPEN
          ZR(I,J) = DZERO
          DO L = 1 , NOPEN
            ZR(I,J) = ZT_R(J,I)-ZT_L(I,J)
          END DO
          ERROR = DMAX1(ERROR,CDABS(ZR(I,J))    )
        END DO
      END DO
      WRITE(IOUT,1110)
      WRITE(*   ,1110)
      DO I = 1 , NOPEN
        WRITE(IOUT,1020) (DREAL(ZR(I,J)),J=1,NOPEN)
        WRITE(*   ,1020) (DREAL(ZR(I,J)),J=1,NOPEN)
      END DO
      WRITE(IOUT,1120)
      WRITE(*   ,1120)
      DO I = 1 , NOPEN
        WRITE(IOUT,1020) (DIMAG(ZR(I,J)),J=1,NOPEN)
        WRITE(*   ,1020) (DIMAG(ZR(I,J)),J=1,NOPEN)
      END DO
      WRITE(IOUT,1130) ERROR
      WRITE(*   ,1130) ERROR
      WRITE(IOUT,1010)
      WRITE(*   ,1010)
C
      RETURN
 1000 FORMAT(/10X,'     C H E C K  P R O P E R T I E S     '/
     *        10X,'----------------------------------------')
 1010 FORMAT(/80('*')/)
 1020 FORMAT(1X,20(1X,G12.6))
 1030 FORMAT(/8X,'  |RR_<-|^2 + |TT_<-|^2  '/
     *       8X,'-------------------------')
 1040 FORMAT(/8X,'  |RR_->|^2 + |TT_->|^2  '/
     *        8X,'-------------------------')
 1050 FORMAT(/8X,'  R E  P A R T:  TT_->^1 * RR_<- + RR_->^1 * TT_<-  '/
     *        8X,'----------------------------------------------------')
 1060 FORMAT(/8X,'  I M  P A R T:  TT_->^1 * RR_<- + RR_->^1 * TT_<-  '/
     *        8X,'----------------------------------------------------')
 1070 FORMAT(/8X,'  R E  P A R T:  RR_<-^T - RR_<-  '/
     *        8X,'----------------------------------')
 1080 FORMAT(/8X,'  I M  P A R T:  RR_<-^T - RR_<-  '/
     *        8X,'----------------------------------')
 1090 FORMAT(/8X,'  R E  P A R T:  RR_->^T - RR_->  '/
     *        8X,'----------------------------------')
 1100 FORMAT(/8X,'  I M  P A R T:  RR_->^T - RR_->  '/
     *        8X,'----------------------------------')
 1110 FORMAT(/8X,'  R E  P A R T:  TT_->^T - TT_<-  '/
     *        8X,'----------------------------------')
 1120 FORMAT(/8X,'  I M  P A R T:  TT_->^T - TT_<-  '/
     *        8X,'----------------------------------')
 1130 FORMAT(/8X,'M A X I M A L  A B S O L U T E  E R R O R =',G12.6)
      END
C
      SUBROUTINE CHECKN(PROBTYPE,SHIFT,THRSHL,RTOL,EPSY,MDIM,NDIR,NDIL,
     1                  IDIM,NROOT,IBOUND,IOUT,IOUP,IOUM)
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
C .                                                                   .
C .   P R O G R A M                                                   .
C .                  TO CHECK ALL INPUT DATA                          .
C .                                                                   .
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION NDIL(NDIR),THRSHL(MDIM)
      CHARACTER*70 PROBTYPE
      IF (NDIR .GT. MDIM .OR. NDIL(NDIR) .GT. MDIM) THEN
           WRITE(IOUT,1120) NDIR,NDIL(NDIR)
           STOP
      END IF
      IF (IBOUND .LT. 1 .OR. IBOUND .GT. 8 .OR.
     1    IBOUND .EQ. 5 .OR. IBOUND .EQ. 7) THEN
           WRITE(IOUT,1130) IBOUND
           STOP
      END IF
      IF (IBOUND .GE. 6 .AND. NROOT .GT. 1 .AND. 
     1    PROBTYPE .EQ. 'EIGEN') THEN
           WRITE(IOUT,1140) IBOUND,NROOT,PROBTYPE
           STOP
      END IF
      IF (IBOUND .LE. 6 .AND. PROBTYPE .EQ. 'SCATTER') THEN
           WRITE(IOUT,1150) IBOUND,PROBTYPE
           STOP
      END IF
      IF (PROBTYPE .EQ. 'SCATTER') THEN
         DO I = 1 , MDIM
           IF (DABS(SHIFT - THRSHL(I)) .LT. EPSY) THEN
             WRITE(IOUT,1160) SHIFT,THRSHL(I),PROBTYPE
             STOP
           END IF
         END DO
      END IF
      IF (PROBTYPE .EQ. 'EIGEN' .AND. RTOL .LT. EPSY) THEN
           WRITE(IOUT,1170) RTOL,EPSY
           RTOL = EPSY
           WRITE(IOUT,1180) RTOL
      END IF
      IF (IDIM .NE. 1 .AND. PROBTYPE .EQ. 'SCATTER') THEN
           WRITE(IOUT,1190) IDIM,PROBTYPE
           STOP
      END IF
      IF (IOUT .EQ. 0) THEN
           IOUT = 7
      END IF
      IF (IOUP .EQ. 0) THEN
           IOUP = 10
      END IF
      IF (IOUM .EQ. 0) THEN
           IOUM = 11
      END IF
      RETURN
 1120 FORMAT(/3X,'*****  KANTBP  ***** ',3X,
     *       'FORBIDDEN VALUE OF NDIR AND NDIL : ',2I4/)
 1130 FORMAT(/3X,'*****  KANTBP  ***** ',3X,
     *       'FORBIDDEN VALUE OF IBOUND : ',I8/)
 1140 FORMAT(/3X,'*****  KANTBP  ***** ',3X,
     *       'FORBIDDEN VALUE OF IBOUND, NROOT, PROBTYPE : ',
     *                                               2I4,2X,A70/)
 1150 FORMAT(/3X,'*****  KANTBP  ***** ',3X,
     *       'FORBIDDEN VALUE OF IBOUND, PROBTYPE : ',I4,2X,A70/)
 1160 FORMAT(/3X,'*****  KANTBP  ***** ',3X,
     *       'FORBIDDEN VALUE OF SHIFT, THRSH, PROBTYPE : ',
     *                                            2G12.4,2X,A70/)
 1170 FORMAT(/3X,'*****  KANTBP  ***** ',3X,
     *       'WARNING: RTOL IS SMALLER THAN EPSY :',2G16.4)
 1180 FORMAT(/10X,'WARNING: HAS CHANGED RTOL : ',G12.4/)
 1190 FORMAT(/3X,'*****  KANTBP  ***** ',3X,
     *       'FORBIDDEN VALUE OF IDIM, PROBTYPE : ',I4,2X,A70/)
      END
C
      SUBROUTINE EVSOLV(MAXA,R,W,TT,A,B,EIG,EIGV,D,BUP,BUPC,RTOLV,BLO,
     1                  AR,BR,VEC,XGRID,VV,QQ,PSI,DPSI,NODE,NGQ,NNODE,
     2                  NGRID,NN,NNM,NWK,NWM,NROOT,NC,NNC,NITEM,NELEM,
     3                  RTOL,SHIFT,NDIM,MDIM,IDIM,IPRINT,IPRSTP,IOUT,
     4                  IOUM,IOUF,IBOUND)
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
C .                                                                   .
C .   P R O G R A M                                                   .
C .                  TO PREPARE INITIAL DATA FOR THE SSPACE PROGRAM,  .
C .                  PRINT OUT THE EIGENSOLUTIONS CALCULATED AND      .
C .                  STORE THE SOLUTIONS OBTAINED INTO THE IOUF FILE, .
C .                  IF NECESSARY                                     .
C .                                                                   .
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(NWK),B(NWK),XGRID(NGRID),MAXA(NNM),R(NN,NC),W(NN),
     1          AR(NNC),BR(NNC),VEC(NC,NC),RTOLV(NC),BUP(NC),BUPC(NC),
     2          BLO(NC),EIG(NC),EIGV(NC),D(NC),TT(NN),VV(MDIM,MDIM),
     3          QQ(MDIM,MDIM),PSI(NNODE,NGQ),DPSI(NNODE,NGQ),
     4          NODE(NNODE,NELEM)
      DATA ZERO / 0.D0 /, ONE / 1.D0 /, TWO / 2.D0 /
C
      IBOUN = IBOUND
      IF (IBOUND .GE. 6) IBOUN = IBOUN - 4
      IFSS = 0
      IFPR = 0
      IRRF = 0
      ISH  = 1
C
      DO I = 1 , NWK
        A(I) = A(I) - SHIFT * B(I)
      END DO
C
      IF (IBOUND .GE. 6) THEN
C
        REWIND IOUM
          WRITE(IOUM) (A(I),I=1,NWK)
        ENDFILE IOUM
        XGI = XGRID(NGRID) ** (IDIM - 1)
        NDM = NDIM * (NDIM + 1) / 2
        NDN = NDM + 1
        NM = NN - NDIM * NNODE
        DETJ = (XGRID(NODE(NNODE,NELEM)) - XGRID(NODE(1,NELEM))) / TWO
C
        L = 0
        DO I = 1 , NDIM
          DO J = I , NDIM
            L = L + 1
            A(NDM + L) = ZERO
            IF (I .EQ. J) A(NDM + L) = ONE
            A(L) = VV(I,J)
            DO K = 1 , NDIM
              A(L) = A(L) + QQ(I,K) * QQ(K,J)
            END DO
          END DO
        END DO
C
        IF (NDIM .EQ. 1) THEN
C
          W(1) = A(1)
          VV(1,1) = ONE
C
        ELSE
C
C      FIND THE MINIMUM SHIFT
C
          SHIFT2 = ZERO
          DO I = 1 , NDIM
            LJ = (I - 1) * (2 * NDIM - I) / 2
            SUM = A(LJ + I)
            DO J = I + 1, NDIM
              L = LJ + J
              SUM = SUM - DABS(A(L))
            END DO
            DO J = 1 , I - 1
              LI = (J - 1) * (2 * NDIM - J) / 2
              L = LI + I
              SUM = SUM - DABS(A(L))
            END DO
            SHIFT2 = DMIN1(SHIFT2,SUM) - ONE
          END DO
          DO I = 1 , NDM
            A(I) = A(I) - SHIFT2 * A(NDM + I)
          END DO
C
          CALL JACOBI(A,A(NDN),VV,W,TT,NDIM,NDM,RTOL,NITEM,IFPR,IOUT)
C
          DO I = 1 , NDIM
            W(I) = W(I) + SHIFT2
          END DO
C
        END IF
C
        CALL ASYMEV(XGRID(NGRID),NDIM,MDIM,SHIFT,DLAM,IOUT)
        DMU = W(1)
C
        ENEROLD = ZERO
        IFPR = - 1
C
        DO ITER = 1 , NITEM
C
          ENEROLD = ENERNEW
          REWIND IOUM
            READ(IOUM) (A(I),I=1,NWK)
          ENDFILE IOUM
C
          CS = XGI * DLAM
          DO I = 1 , NDIM
            II = MAXA(NN - NDIM + I)
            A(II) = A(II) - CS
          END DO
C
          CALL SSPACE(A,B,MAXA,R,EIG,TT,W,AR,BR,VEC,D,RTOLV,BUP,BLO,
     1                BUPC,NN,NNM,NWK,NWM,NROOT,RTOL,NC,NNC,NITEM,IFSS,
     2                IFPR,IRRF,IOUM,SHIFT,IOUT)
C
          ENERNEW = EIG(1)
          REZ = DABS(ENERNEW - ENEROLD)
          REZ = REZ / DABS(ENERNEW + SHIFT)
C
          DLAM1 = ZERO
          DO L = 1 , NGQ
            AS = ZERO
            BS = ZERO
            DO I = 1 , NDIM
              TT(I) = ZERO
              DO J = 1 , NNODE
                IJ = NM + NDIM * (J - 1) + I
                TT(I) = TT(I) + DPSI(J,L) * R(IJ,1)
              END DO
              TT(I) = TT(I) / DETJ
              DO J = 1 , NDIM
                TT(I) = TT(I) - QQ(I,J) * R(NN - NDIM + J,1)
              END DO
              AS = AS + R(NN - NDIM + I,1) * TT(I)
              BS = BS + R(NN - NDIM + I,1) * R(NN - NDIM + I,1)
            END DO
            DLAM1 = DLAM1 + DPSI(L,NGQ) * AS / BS
          END DO
          DLAM1 = DLAM1 / DETJ
C
          SD = DMU - EIG(1) - SHIFT
          SD = SD - DLAM1 - (IDIM - 1) * AS / BS / XGRID(NGRID)
          DLAM = DSIGN(DSQRT(SD),DLAM)
          IF (REZ .LT. RTOL) GO TO 200
C
        END DO
C
        WRITE(   *,1060) REZ
        WRITE(IOUT,1060) REZ
C
      END IF
C
  200 CONTINUE
C
      IF (IBOUND .GE. 6) THEN
C
        REWIND IOUM
          READ(IOUM) (A(I),I=1,NWK)
        ENDFILE IOUM
C
        CS = XGI * DLAM
        DO I = 1 , NDIM
          II = MAXA(NN - NDIM + I)
          A(II) = A(II) - CS
        END DO
C
        IFPR = 0
C
      END IF
C
      CALL SSPACE(A,B,MAXA,R,EIG,TT,W,AR,BR,VEC,D,RTOLV,BUP,BLO,BUPC,
     1            NN,NNM,NWK,NWM,NROOT,RTOL,NC,NNC,NITEM,IFSS,IFPR,
     2            IRRF,IOUM,SHIFT,IOUT)
C
      IF (IBOUND .GE. 6) THEN
C
        WRITE(IOUT,1090) ITER
        WRITE(IOUT,1100)
        WRITE(IOUT,1110) REZ
C
      END IF

      DO 39 J=1 , NC
        EIGV(J) = EIG(J) + SHIFT
   39 CONTINUE
C
C      PRINT THE CALCULATED EIGENVALUES
C
      IF (IPRINT .GE. 0) THEN
        WRITE(IOUT,1010)
        IF (IBOUND .LT. 6) THEN
          WRITE(IOUT,1070)
        ELSE
          WRITE(IOUT,1080)
        END IF
        DO I = 1 , NROOT
          IF (IBOUND .LT. 6) THEN
            WRITE(IOUT,1040) I,EIGV(I)/2
            WRITE(   *,1040) I,EIGV(I)/2
          ELSE
            WRITE(IOUT,1040) I,EIGV(I)/2,DLAM
            WRITE(   *,1040) I,EIGV(I)/2,DLAM
          END IF
        END DO
        WRITE(IOUT,1010)
      END IF
C
C      FIX A SLOPE OF THE RADIAL WAVEFUNCTIONS
C
      DO J = 1 , NROOT
        IF (R(NDIM + 1,J) .LT. ZERO) THEN
          DO I = 1 , NN
             R(I,J) = - R(I,J)
          END DO
        END IF
      END DO
C
C      PRINT THE RADIAL WAVEFUNCTIONS
C
      IF (IPRINT .GE. 1) THEN
        IF (IBOUN .GE. 3) THEN
          KEY=0
        ELSE
          KEY=1
        END IF
        WRITE(IOUT,1050)
        IF (NDIM .GT. 1) THEN
          NDM = NN / NDIM
          DO 42 II = 1 , NDM , IPRSTP
            JL = (II - 1) * NDIM
            WRITE(IOUT,1020) XGRID(II+KEY),
     1                     ((R(JL+IK,JJ),JJ=1,NROOT),IK=1,NDIM)
   42     CONTINUE
        ELSE
          DO 45 II = 1 , NN , IPRSTP
            IF (NROOT .LE. 5) THEN
               WRITE(IOUT,1020) XGRID(II+KEY),(R(II,JJ),JJ=1,NROOT)
            ELSE
               WRITE(IOUT,1030) XGRID(II+KEY),(R(II,JJ),JJ=1,NROOT)
            END IF
   45     CONTINUE
        END IF
        WRITE(IOUT,1010)
      END IF
C
      IF(IOUF .NE. 0) THEN
        WRITE(IOUF) NDIM,NN,NROOT,NGRID,(EIGV(I),I=1,NROOT),
     1              (XGRID(I),I=1,NGRID),((R(I,J),I=1,NN),J=1,NROOT)
      END IF
      RETURN
 1010 FORMAT(/80('*')/)
 1020 FORMAT(1X,F10.4,1X,9(1X,D10.4)/(11X,1X,9(1X,D10.4)))
 1030 FORMAT(1X,F10.4,1X,6(1X,D10.4)/(11X,1X,6(1X,D10.4)))
 1040 FORMAT(10X,I4,14X,2G25.16)
 1050 FORMAT(//8X,'R',8X,'R A D I A L   E I G E N F U N C T I O N S',
     *        /8X,'-',8X,'-----------------------------------------'/)
 1060 FORMAT(3X,'NO CONVERGENCE FOR RTOL',3X,G12.6)
 1070 FORMAT(3X,' R O O T   N U M B E R ',3X,' E I G E N V A L U E '/
     *       3X,'-----------------------',3X,'---------------------')
 1080 FORMAT(3X,' R O O T   N U M B E R ',3X,' E I G E N V A L U E ',
     *       7X,'   L A M B D A  ' /
     *       3X,'-----------------------',3X,'---------------------',
     *       7X,'----------------')
 1090 FORMAT(1H ,32HI T E R A T I O N   N U M B E R ,I4)
 1100 FORMAT(38H RELATIVE TOLERANCE REACHED ON LAMBDA  )
 1110 FORMAT(1H ,7E11.4)
      END
C
      SUBROUTINE SCSOLC(MAXA,R,QQ,FAC,XGRID,NGRID,NN,NNM,NWK,SHIFT,
     1                  THRSHL,NDIM,MDIM,IDIM,IPRINT,IPRSTP,IOUT,IOUF,
     2                  IBOUND,NOPEN,PIRR,PREG,DPIRR,DPREG,QR,RR,TT,WL,
     3                  WW,RR0,ZZ,WR,IOUM,IDIR)
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
C .                                                                   .
C .   P R O G R A M                                                   .
C .                  TO CALCULATE THE REACTION MATRIX AND THE         .
C .                  EIGENSOLUTION AND PRINT OUT THE EIGENSOLUTION    .
C .                  CALCULATED AND STORE THE SOLUTIONS               .
C .                  OBTAINED INTO THE IOUF FILE, IF NECESSARY        .
C .                                                                   .
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION XGRID(NGRID),MAXA(NNM),THRSHL(MDIM),QQ(MDIM,MDIM),
     1          QR(NOPEN)
      COMPLEX*16 R(NN,NOPEN),PIRR(NDIM,NOPEN),RR0(NDIM,NDIM),ZZ(NWK),
     2          PREG(NDIM,NOPEN),DPIRR(NDIM,NOPEN),DPREG(NDIM,NOPEN),
     3          TT(NOPEN,NOPEN),RR(NOPEN,NOPEN),WW(NDIM,NOPEN),
     4          FAC(NN,NDIM),WL(NDIM,NDIM),WR(NDIM,NDIM)
      DATA DZERO / 0.D0 /, ONE / 1.D0 /
C
      REWIND (IOUM)
      READ(IOUM)  (ZZ(I),I=1,(NWK + 1) / 2)
      IF (MOD(NWK,2) .EQ. 1) ZZ(NWK) = ZZ((NWK+1)/2)
      DO J = NWK / 2 , 1 , -1
        ZZ(2 * J    ) = DIMAG(ZZ(J))
        ZZ(2 * J - 1) = DREAL(ZZ(J))
      END DO
C
      PI   = DACOS(-1.D0)
      IFPR = - 1
      ISH  =  1
C
      DO I = 1 , NOPEN
        QR(I) = DSQRT(SHIFT - THRSHL(I))
      END DO
C
      IF (IPRINT .GE. 0) THEN
        WRITE(   *,1100) NOPEN
        WRITE(IOUT,1100) NOPEN
        DO I = 1 , NOPEN
          WRITE(   *,1110) I,QR(I)
          WRITE(IOUT,1110) I,QR(I)
        END DO
      END IF
C
      IF (IDIR .EQ. 1) THEN
C
        CALL ASYMSL(XGRID(1),XGRID(NGRID),NDIM,NOPEN,QR,SHIFT,THRSHL,
     1              WL,WR,PREG,PIRR,DPREG,DPIRR,IOUT)
        XGI   = XGRID(NGRID) ** (IDIM - 1)
        XGI1  = XGRID(1) ** (IDIM - 1)
        KK = NN - NDIM
        KKM = 0
        ISGN = + 1
C
      ELSE IF (IDIR .EQ. 2) THEN
C
        CALL ASYMSR(XGRID(1),XGRID(NGRID),NDIM,NOPEN,QR,SHIFT,THRSHL,
     1              WL,WR,PREG,PIRR,DPREG,DPIRR,IOUT)
        XGI  = XGRID(1) ** (IDIM - 1)
        XGI1  = XGRID(NGRID) ** (IDIM - 1)
        KK = 0
        KKM = NN - NDIM
        ISGN = - 1
C
      END IF
C
      CALL GAUSSC(WL,NDIM,NDIM,RR0,NDIM,NDIM)
C
      DO I = 1 , NDIM
        DO J = 1 , NDIM
          RR0(I,J) = DZERO
          DO L = 1 , NDIM
            RR0(I,J) = RR0(I,J) + WR(I,L) * WL(L,J)
          END DO
        END DO
      END DO
C
      DO I = 1 , NDIM
        DO J = I , NDIM
          RR0(I,J) = (RR0(I,J) + RR0(J,I)) / 2
          RR0(J,I) = RR0(I,J)
        END DO
      END DO
C
      DO I = 1 , NDIM
        DO J = I , NDIM
          L = MAXA(KKM + J) + J - I
          ZZ(L) = ZZ(L) + ISGN * XGI1 * RR0(I,J)
        END DO
      END DO
C
      CALL DECOMC(ZZ,MAXA,NN,ISH,IFPR,IOUT)
      DO I = 1 , NN
        DO J = 1 , NDIM
          FAC(I,J) = DZERO
        END DO
      END DO
C
      DO I = 1 , NDIM
        FAC(KK + I,I) = ISGN * XGI
        CALL REDBAC(ZZ,FAC(1,I),MAXA,NN)
      END DO
C
      L = 0
      DO J = 1 , NDIM
        DO I = J , 1 , -1
          L = L + 1
          ZZ(L) = FAC(KK + I,J)
          WL(I,J) = DZERO
          WL(J,I) = DZERO
          IF (I .EQ. J) MAXA(J) = L
        END DO
        WL(J,J) = ONE
      END DO
      MAXA(NDIM + 1) = L + 1
      CALL DECOMC(ZZ,MAXA,NDIM,ISH,IFPR,IOUT)
C
      DO I = 1 , NDIM
        CALL REDBAC(ZZ,WL(1,I),MAXA,NDIM)
      END DO
C
C      CALCULATE THE WRONSKIAN
C
      DO I = 1 , NDIM
        DO J = 1 , NDIM
          WL(I,J) = WL(I,J) + QQ(I,J)
        END DO
      END DO
C
      DO I = 1 , NDIM
        DO J = 1 , NOPEN
          R (I,J) =   DPIRR(I,J)
          WW(I,J) =   DPREG(I,J)
          DO L = 1 , NDIM
            R (I,J) = R (I,J) - QQ(I,L) * PIRR(L,J)
            WW(I,J) = WW(I,J) - QQ(I,L) * PREG(L,J)
          END DO
        END DO
      END DO
      DO I = 1 , NOPEN
        DO J = 1 , NOPEN
          RR(I,J) = DZERO
          DO K = 1 , NDIM
            RR(I,J) = RR(I,J) + PIRR(K,I) * WW(K,J) - R(K,I) * PREG(K,J)
          END DO
          RR(I,J) = RR(I,J) * XGI
        END DO
      END DO
C
C      PRINT THE WRONSKIAN
C
      IF (IPRINT .GE. 0) THEN
        WRITE(IOUT,1060)
        WRITE(*   ,1060)
        DO I = 1 , NOPEN
          WRITE(IOUT,1020) (DIMAG(RR(I,J)),J=1,NOPEN)
          WRITE(*   ,1020) (DIMAG(RR(I,J)),J=1,NOPEN)
        END DO
      END IF
C
C      CALCULATE THE REFLECTION MATRIX
C
      DO I = 1 , NDIM
        DO J = 1 , NOPEN
          R (I,J) = - DPIRR(I,J)
          WW(I,J) =   DPREG(I,J)
          DO L = 1 , NDIM
            R (I,J) = R (I,J) + WL(I,L) * PIRR(L,J)
            WW(I,J) = WW(I,J) - WL(I,L) * PREG(L,J)
          END DO
        END DO
      END DO
C
      DO I = 1 , NOPEN
        DO J = 1 , NOPEN
          TT(I,J) = DZERO
          RR(I,J) = DZERO
          DO L = 1 , NDIM
            TT(I,J) = TT(I,J) + R (L,I) * R(L,J)
            RR(I,J) = RR(I,J) + R (L,I) * WW(L,J)
          END DO
        END DO
      END DO
C
      L = 0
      DO J = 1 , NOPEN
        DO I = J , 1 , -1
          L = L + 1
          ZZ(L) = TT(I,J)
          IF (I .EQ. J) MAXA(J) = L
        END DO
      END DO
      MAXA(NOPEN + 1) = L + 1
      CALL DECOMC(ZZ,MAXA,NOPEN,ISH,IFPR,IOUT)
C
      DO I = 1 , NOPEN
        CALL REDBAC(ZZ,RR(1,I),MAXA,NOPEN)
      END DO
C
C      PRINT THE CALCULATED REFLECTION MATRIX
C
      IF (IPRINT .GE. 0) THEN
        WRITE(IOUT,1070)
        WRITE(*   ,1070)
        DO I = 1 , NOPEN
          WRITE(IOUT,1020) (DREAL(RR(I,J)),J=1,NOPEN)
          WRITE(*   ,1020) (DREAL(RR(I,J)),J=1,NOPEN)
        END DO
        WRITE(IOUT,1075)
        WRITE(*   ,1075)
        DO I = 1 , NOPEN
          WRITE(IOUT,1020) (DIMAG(RR(I,J)),J=1,NOPEN)
          WRITE(*   ,1020) (DIMAG(RR(I,J)),J=1,NOPEN)
        END DO
      END IF
C
C      CALCULATE THE RADIAL WAVEFUNCTIONS
C
      DO I = 1 , NDIM
        IJ = KK + I
        DO J = 1 , NOPEN
          R(IJ,J) =  PREG(I,J)
          DO L = 1 , NOPEN
            R(IJ,J) = R(IJ,J) + PIRR(I,L) * RR(L,J)
          END DO
        END DO
      END DO
C
      DO I = 1 , NDIM
        DO J = 1 , NOPEN
          WW(I,J) = DZERO
          DO L = 1 , NDIM
            WW(I,J) = WW(I,J) + (WL(I,L) - QQ(I,L)) * R(KK + L,J)
          END DO
        END DO
      END DO
C
      DO II = 1 , NN - NDIM
        I = II
        IF (IDIR .EQ. 2) I = II + NDIM
        DO J = 1 , NOPEN
          R(I,J) = DZERO
          DO L = 1 , NDIM
            R(I,J) = R(I,J) + FAC(I,L) * WW(L,J)
          END DO
        END DO
      END DO
C
C      CALCULATE THE TRANSMISSOIN MATRIX
C
      IF (IDIR .EQ. 1) THEN
C
        CALL ASYMSL(XGRID(1),XGRID(NGRID),NDIM,NOPEN,QR,SHIFT,THRSHL,
     1              WL,WR,PREG,PIRR,DPREG,DPIRR,IOUT)
C
      ELSE IF (IDIR .EQ. 2) THEN
C
        CALL ASYMSR(XGRID(1),XGRID(NGRID),NDIM,NOPEN,QR,SHIFT,THRSHL,
     1              WL,WR,PREG,PIRR,DPREG,DPIRR,IOUT)
C
      END IF
C
      DO I = 1 , NOPEN
        DO J = 1 , NOPEN
          RR0(I,J) = DZERO
          TT (I,J) = DZERO
          DO L = 1 , NDIM
            LL = L
            IF (IDIR .EQ. 2) LL = NN - NDIM + L
            TT (I,J) = TT (I,J) + WL(L,I) * R(LL,J)
            RR0(I,J) = RR0(I,J) + WL(L,I) * WL(L,J)
          END DO
        END DO
      END DO
C
      L = 0
      DO J = 1 , NOPEN
        DO I = J , 1 , -1
          L = L + 1
          ZZ(L) = RR0(I,J)
          IF (I .EQ. J) MAXA(J) = L
        END DO
      END DO
      MAXA(NOPEN + 1) = L + 1
      CALL DECOMC(ZZ,MAXA,NOPEN,ISH,IFPR,IOUT)
C
      DO I = 1 , NOPEN
        CALL REDBAC(ZZ,TT(1,I),MAXA,NOPEN)
      END DO
C
C      PRINT THE CALCULATED TRANSMISSOIN MATRIX
C
      IF (IPRINT .GE. 0) THEN
        WRITE(IOUT,1080)
        WRITE(*   ,1080)
        DO I = 1 , NOPEN
          WRITE(IOUT,1020) (DREAL(TT(I,J)),J=1,NOPEN)
          WRITE(*   ,1020) (DREAL(TT(I,J)),J=1,NOPEN)
        END DO
        WRITE(IOUT,1085)
        WRITE(*   ,1085)
        DO I = 1 , NOPEN
          WRITE(IOUT,1020) (DIMAG(TT(I,J)),J=1,NOPEN)
          WRITE(*   ,1020) (DIMAG(TT(I,J)),J=1,NOPEN)
        END DO
      END IF
C
C      PRINT THE RADIAL WAVEFUNCTIONS
C
      IF (IPRINT .GE. 1) THEN
        WRITE(IOUT,1050)
        IF (NDIM .GT. 1) THEN
          NDM = NN / NDIM
          DO 42 II = 1 , NDM , IPRSTP
            JL = (II - 1) * NDIM
            WRITE(IOUT,1030) XGRID(II),
     1                     ((DREAL(R(JL+IK,JJ)),JJ=1,NOPEN),IK=1,NDIM)
   42     CONTINUE
        ELSE
          DO 45 II = 1 , NN , IPRSTP
            IF (NOPEN .LE. 5) THEN
              WRITE(IOUT,1030)XGRID(II),(DREAL(R(II,JJ)),JJ=1,NOPEN)
            ELSE
              WRITE(IOUT,1040)XGRID(II),(DREAL(R(II,JJ)),JJ=1,NOPEN)
            END IF
   45     CONTINUE
        END IF
        WRITE(IOUT,1055)
        IF (NDIM .GT. 1) THEN
          NDM  = NN / NDIM
          DO 43 II = 1 , NDM , IPRSTP
            JL = (II - 1) * NDIM
            WRITE(IOUT,1030) XGRID(II),
     1                     ((DIMAG(R(JL+IK,JJ)),JJ=1,NOPEN),IK=1,NDIM)
   43     CONTINUE
        ELSE
          DO 46 II = 1 , NN , IPRSTP
            IF (NOPEN .LE. 5) THEN
              WRITE(IOUT,1030)XGRID(II),(DIMAG(R(II,JJ)),JJ=1,NOPEN)
            ELSE
              WRITE(IOUT,1040)XGRID(II),(DIMAG(R(II,JJ)),JJ=1,NOPEN)
            END IF
   46     CONTINUE
        END IF
        WRITE(IOUT,1010)
      END IF
C
      IF(IOUF .NE. 0) THEN
        WRITE(IOUF) NDIM,NN,NOPEN,NGRID,((RR(I,J),I=1,NOPEN),J=1,NOPEN),
     1                                  ((TT(I,J),I=1,NOPEN),J=1,NOPEN),
     1              (XGRID(I),I=1,NGRID),((R(I,J),I=1,NN),J=1,NOPEN)
      END IF
C
      RETURN
 1010 FORMAT(/80('*')/)
 1020 FORMAT(1X,9(1X,G12.6))
 1030 FORMAT(1X,F10.4,1X,9(1X,D10.4)/(11X,1X,9(1X,D10.4)))
 1040 FORMAT(1X,F10.4,1X,6(1X,D10.4)/(11X,1X,6(1X,D10.4)))
 1050 FORMAT(/8X,'Z',8X,' R E  P A R T  O F  F U N C T I O N S '/
     *        8X,'-',8X,'--------------------------------------')
 1055 FORMAT(/8X,'Z',8X,' I M  P A R T  O F  F U N C T I O N S '/
     *        8X,'-',8X,'--------------------------------------')
 1060 FORMAT(/8X,' I M  P A R T  O F  W R O N S K I A N '/
     *        8X,'--------------------------------------')
 1070 FORMAT(/8X,' R E  P A R T  O F  RR  M A T R I X '/
     *        8X,'------------------------------------')
 1075 FORMAT(/8X,' I M  P A R T  O F  RR  M A T R I X '/
     *        8X,'------------------------------------')
 1080 FORMAT(/8X,' R E  P A R T  O F  TT  M A T R I X '/
     *        8X,'------------------------------------')
 1085 FORMAT(/8X,' I M  P A R T  O F  TT  M A T R I X '/
     *        8X,'------------------------------------')
 1100 FORMAT(5X,
     /   'NUMBER OF OPEN CHANNELS. . . . . . . . . (NOPEN) = ',I6)
 1110 FORMAT(5X,
     /   'VALUE OF I-TH MOMENTUM . . . . . . . . . (I,QR ) = ',I6,E12.4)
      END
C
      SUBROUTINE ASSMBC(MAXA,A,ESTF,ESTFA,EST1,EMS1,XGRID,
     1                  UPOT,QPOT,XNODE,UNODE,QNODE,PSI,DPSI,XG,WG,
     2                  H,Q,NODE,NODES,NDIL,NDIR,NMDIL,NELEM,NNODE,
     3                  NNODES,NGQ,NN,NNM,NWK,NWM,NWT,NDIM,MDIM,IDIM,
     4                  NGRID,NSTF,IPRINT,IOUP,PROBTYPE,SHIFT,IPRSTP,
     5                  IOUM,IOUT)
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
C .                                                                   .
C .   P R O G R A M                                                   .
C .                  TO CALCULATE AND ASSEMBLE THE STIFFNESS AND      .
C .                  MASS ELEMENT MATRICES INTO THE GLOBAL            .
C .                  STIFFNESS AND MASS MATRICES                      .
C .                                                                   .
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 A(NWT)
      DIMENSION MAXA(NNM),ESTF(NNODES,NNODES),NDIL(NDIR),ESTFA(NSTF),
     1          EST1(NNODE,NNODE),EMS1(NNODE,NNODE),XGRID(NGRID),
     2          UPOT(MDIM,MDIM,NGQ),QPOT(MDIM,MDIM,NGQ),XNODE(NNODE),
     3          UNODE(NNODE),QNODE(NNODE),PSI(NNODE,NGQ),
     4          DPSI(NNODE,NGQ),XG(NGQ),WG(NGQ),H(MDIM,MDIM),
     5          Q(MDIM,MDIM),NODE(NNODE,NELEM),NODES(NNODES,NELEM)
      CHARACTER*70 PROBTYPE
      DATA ZERO / 0.D0 /
C
      IF (NMDIL .EQ. 0) THEN
C
        CALL HQPOTN(XGRID,XG,NGQ,NGRID,UPOT,QPOT,H,Q,NELEM,NNDIM,MDIM,
     1              IOUT,IOUP,IPRINT,IPRSTP,NNODE,NODE,XNODE)
C
        NMDIL = 1
C
      END IF
C
      DO 15 IG = 1 , NGQ
C
          CALL SHAPEF(XG(IG),UNODE,QNODE,XNODE,NNODE)
C
          DO 14 IN = 1 , NNODE
             PSI (IN,IG) = UNODE(IN)
             DPSI(IN,IG) = QNODE(IN)
   14     CONTINUE
C
   15 CONTINUE
C
      IF (IPRINT .GE. 5) THEN
          WRITE(IOUT,1130)
          DO I = 1 , NGQ
             WRITE(IOUT,1140) (PSI(J,I),J=1,NNODE)
          END DO
          WRITE(IOUT,1150)
      END IF
C
C      BEGIN BIG LOOP ON ELEMENTS
C
      REWIND IOUP
C
C      CALCULATE MASS AND STIFFNESS MATRICES
C
C      INITIALIZE ARRAYS A(NWK), B(NWK)
C
      DO 10 I = 1 , NWT
         A(I) = ZERO
   10 CONTINUE
C
      DO 220 NEL = 1 , NELEM
C
        READ(IOUP) L,(((UPOT(I,J,IG),J=I  ,MDIM),I=1,MDIM),IG=1,NGQ),
     1               (((QPOT(I,J,IG),J=I+1,MDIM),I=1,MDIM),IG=1,NGQ)
C
         DO 40 II = 1 , NNODES
         DO 40 JJ = 1 , NNODES
            ESTF(II,JJ) = ZERO
   40    CONTINUE
C
         DO 50 LL = 1 , NNODE
            NE           = NODE(LL,NEL)
            XNODE(LL)    = XGRID(NE)
   50    CONTINUE
C
         IF (IPRINT .GE. 5) THEN
              WRITE(IOUT,1110) NEL
              WRITE(IOUT,1120) (I,XNODE(I),I=1,NNODE)
              WRITE(IOUT,1150)
         END IF
C
C      CALCULATE ELEMENT MATRICES FOR DIAGONAL
C      ELEMENTS OF MASS AND STIFFNESS MATRICES
C
         DO 100 IA = 1 , NDIM
C
            DO 60 NA = 1 , NNODE
               UNODE(NA) = UPOT(IA,IA,NA)
   60       CONTINUE
C
            CALL EMASSD(XNODE,XG,WG,NGQ,NNODE,EMS1,PSI,IDIM)
            CALL ESTIFD(XNODE,XG,WG,NGQ,NNODE,EST1,UNODE,PSI,DPSI,IDIM)
C
            DO 70 NI = 1  , NNODE
            DO 70 NJ = NI , NNODE
C
               NEI   = (NI - 1) * NDIM + IA
               NEJ   = (NJ - 1) * NDIM + IA
C
               ESTF(NEI,NEJ) = ESTF(NEI,NEJ) + EST1(NI,NJ)
     1                               - SHIFT * EMS1(NI,NJ)
C
   70       CONTINUE
C
            IF (IPRINT .GE. 5) THEN
               WRITE(IOUT,1030) NEL
               DO 80 IP = 1 , NNODE
   80          WRITE(IOUT,1040) (EST1(IP,JP),JP=1,NNODE),
     1                          (EMS1(IP,JP),JP=1,NNODE)
            END IF
C
  100    CONTINUE
C
         IF (IPRINT .GE. 5) THEN
            WRITE(IOUT,1050) NEL
            DO 110 IP = 1 , NNODES
  110       WRITE(IOUT,1020) (ESTF(IP,JP),JP=1,NNODES)
         END IF
C
C      CALCULATE ELEMENT MATRIX FOR NONDIAGONAL
C      ELEMENTS OF STIFFNESS MATRIX
C
         DO 180 IA = 1 , NDIM - 1
         DO 180 IB = IA + 1 , NDIM
C
            DO 140 NAB = 1 , NNODE
               UNODE(NAB)   =   UPOT(IA,IB,NAB)
               QNODE(NAB)   =   QPOT(IA,IB,NAB)
  140       CONTINUE
C
            CALL ESTIFN(XNODE,XG,WG,NGQ,NNODE,EST1,UNODE,QNODE,
     1                  PSI,DPSI,IDIM)
C
            DO 150 NI = 1  , NNODE
            DO 150 NJ = NI , NNODE
C
               NEI  = (NI - 1) * NDIM + IA
               NEJ  = (NJ - 1) * NDIM + IB
C
               ESTF(NEI,NEJ) = ESTF(NEI,NEJ) + EST1(NI,NJ)
C
               IF (NJ .NE. NNODE) THEN
C
                 NEII = NEI + IB - IA
                 NEJJ = NEJ - IB + IA + NDIM
                 ESTF(NEII,NEJJ) = ESTF(NEII,NEJJ) + EST1(NJ+1,NI)
C
               END IF
C
  150       CONTINUE
C
            IF (IPRINT .GE. 5) THEN
               WRITE(IOUT,1070) NEL
               DO 160 IP = 1 , NNODE
  160          WRITE(IOUT,1040) (EST1(IP,JP),JP=1,NNODE)
            END IF
C
  180    CONTINUE
C
         IF (IPRINT .GE. 5) THEN
            WRITE(IOUT,1050) NEL
            DO 190 IP = 1 , NNODES
  190       WRITE(IOUT,1020) (ESTF(IP,JP),JP=1,NNODES)
         END IF
C
         NL  = 0
         DO 210 IL = 1  , NNODES
         DO 210 JL = IL , NNODES
C
            NL        = NL + 1
            ESTFA(NL) = ESTF(IL,JL)
C
  210    CONTINUE
C
C      ASSEMBLE ELEMENT MATRICES INTO GLOBAL
C      STIFFNESS AND MASS MATRICES
C
         CALL ADDVEK(A,NWT,MAXA,NNM,ESTFA,NSTF,NODES(1,NEL),NNODES,1)
C
  220 CONTINUE
C
      REWIND(IOUM)
      WRITE(IOUM) (DREAL(A(I)),I=1,NWT),ZERO
C
      READ(IOUP) L,((UPOT(I,J,1),J=I  ,MDIM),I=1,MDIM),
     1             ((QPOT(I,J,1),J=I+1,MDIM),I=1,MDIM)
      DO I = 1 , MDIM
        DO J = I + 1 , MDIM
          Q(I,J) =   QPOT(I,J,1)
          Q(J,I) = - QPOT(I,J,1)
        END DO
        Q(I,I) = ZERO
      END DO
      READ(IOUP) L,((UPOT(I,J,1),J=I  ,MDIM),I=1,MDIM),
     1             ((QPOT(I,J,1),J=I+1,MDIM),I=1,MDIM)
      DO I = 1 , MDIM
        DO J = I + 1 , MDIM
          H(I,J) =   QPOT(I,J,1)
          H(J,I) = - QPOT(I,J,1)
        END DO
        H(I,I) = ZERO
      END DO
C
      IF (IPRINT .GE. 4) THEN
         WRITE(IOUT,1080) NN,NNM,NWK,NNODE,NNODES,NELEM,NDIM,NGRID
         WRITE(IOUT,1090) NWK
         WRITE(IOUT,1020) (DREAL(A(I)),I=1,NWK)
      END IF
C
      RETURN
 1020 FORMAT(6(2X,D10.4))
 1030 FORMAT(/5X,'ELEMENT STIFFNESS AND MASS MATRICES EST1 & ',
     1            'EMS1 (ELEMENT NO ',I3,' ) :'/)
 1040 FORMAT(5(3X,D12.6))
 1050 FORMAT(/5X,
     * 'ELEMENT STIFFNESS MATRIX ESTF (ELEMENT NO ',I3,' ) :'/)
 1070 FORMAT(/5X,
     * 'ELEMENT STIFFNESS MATRIX EST1 (ELEMENT NO ',I3,' ) :'/)
 1080 FORMAT(//15X,'DIMENSIONS SET IN ASSMBC ARE : ',//5X,
     1 'NN     = ',I5,5X,'NNM    = ',I5,5X,
     2 'NWK    = ',I5,5X,'NNODE  = ',I5,5X/5X,
     3 'NNODES = ',I5,5X,'NELEM  = ',I5,5X,
     4 'NDIM   = ',I5,5X,'NGRID  = ',I5,/)
 1090 FORMAT(//20X,'S T I F F N E S S  M A T R I X  A(',I5,') :'/)
 1110 FORMAT(/10X,'ARRAY XNODE (NEL = ',I3,' )'/)
 1120 FORMAT(5(1X,I2,2X,D10.4))
 1130 FORMAT(/15X,'SHAPE FUNCTIONS PSI(NNODE,NGQ) :'/)
 1140 FORMAT(6(1X,D12.6))
 1150 FORMAT(/)
      END
C
      SUBROUTINE ASSMBL(MAXA,A,ESTF,EMSS,ESTFA,ESTFB,EST1,EMS1,XGRID,
     1                  UPOT,QPOT,XNODE,UNODE,QNODE,PSI,DPSI,XG,WG,
     2                  H,Q,NODE,NODES,NDIL,NDIR,NMDIL,NELEM,NNODE,
     3                  NNODES,NGQ,NN,NNM,NWK,NWM,NWT,NDIM,MDIM,IDIM,
     4                  NGRID,NSTF,IPRINT,IOUP,PROBTYPE,SHIFT,IPRSTP,
     5                  IOUT)
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
C .                                                                   .
C .   P R O G R A M                                                   .
C .                  TO CALCULATE AND ASSEMBLE THE STIFFNESS AND      .
C .                  MASS ELEMENT MATRICES INTO THE GLOBAL            .
C .                  STIFFNESS AND MASS MATRICES                      .
C .                                                                   .
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION MAXA(NNM),A(NWT),ESTF(NNODES,NNODES),NDIL(NDIR),
     1          EMSS(NNODES,NNODES),ESTFA(NSTF),ESTFB(NSTF),
     2          EST1(NNODE,NNODE),EMS1(NNODE,NNODE),XGRID(NGRID),
     3          UPOT(MDIM,MDIM,NGQ),QPOT(MDIM,MDIM,NGQ),XNODE(NNODE),
     4          UNODE(NNODE),QNODE(NNODE),PSI(NNODE,NGQ),
     5          DPSI(NNODE,NGQ),XG(NGQ),WG(NGQ),H(MDIM,MDIM),
     6          Q(MDIM,MDIM),NODE(NNODE,NELEM),NODES(NNODES,NELEM)
      CHARACTER*70 PROBTYPE
      DATA ZERO / 0.D0 /
C
      IF (NMDIL .EQ. 0) THEN
C
        CALL HQPOTN(XGRID,XG,NGQ,NGRID,UPOT,QPOT,H,Q,NELEM,NNDIM,MDIM,
     1              IOUT,IOUP,IPRINT,IPRSTP,NNODE,NODE,XNODE)
C
        NMDIL = 1
C
      END IF
C
      DO 15 IG = 1 , NGQ
C
          CALL SHAPEF(XG(IG),UNODE,QNODE,XNODE,NNODE)
C
          DO 14 IN = 1 , NNODE
             PSI (IN,IG) = UNODE(IN)
             DPSI(IN,IG) = QNODE(IN)
   14     CONTINUE
C
   15 CONTINUE
C
      IF (IPRINT .GE. 5) THEN
          WRITE(IOUT,1130)
          DO I = 1 , NGQ
             WRITE(IOUT,1140) (PSI(J,I),J=1,NNODE)
          END DO
          WRITE(IOUT,1150)
      END IF
C
C      BEGIN BIG LOOP ON ELEMENTS
C
      REWIND IOUP
C
C      CALCULATE MASS AND STIFFNESS MATRICES
C
C      INITIALIZE ARRAYS A(NWK), B(NWK)
C
      DO 10 I = 1 , NWT
         A(I) = ZERO
   10 CONTINUE
C
      DO 220 NEL = 1 , NELEM
C
        READ(IOUP) L,(((UPOT(I,J,IG),J=I  ,MDIM),I=1,MDIM),IG=1,NGQ),
     1               (((QPOT(I,J,IG),J=I+1,MDIM),I=1,MDIM),IG=1,NGQ)
C
         DO 40 II = 1 , NNODES
         DO 40 JJ = 1 , NNODES
            ESTF(II,JJ) = ZERO
            EMSS(II,JJ) = ZERO
   40    CONTINUE
C
         DO 50 LL = 1 , NNODE
            NE           = NODE(LL,NEL)
            XNODE(LL)    = XGRID(NE)
   50    CONTINUE
C
         IF (IPRINT .GE. 5) THEN
              WRITE(IOUT,1110) NEL
              WRITE(IOUT,1120) (I,XNODE(I),I=1,NNODE)
              WRITE(IOUT,1150)
         END IF
C
C      CALCULATE ELEMENT MATRICES FOR DIAGONAL
C      ELEMENTS OF MASS AND STIFFNESS MATRICES
C
         DO 100 IA = 1 , NDIM
C
            DO 60 NA = 1 , NNODE
               UNODE(NA) = UPOT(IA,IA,NA)
   60       CONTINUE
C
            CALL EMASSD(XNODE,XG,WG,NGQ,NNODE,EMS1,PSI,IDIM)
            CALL ESTIFD(XNODE,XG,WG,NGQ,NNODE,EST1,UNODE,PSI,DPSI,IDIM)
C
            DO 70 NI = 1  , NNODE
            DO 70 NJ = NI , NNODE
C
               NEI   = (NI - 1) * NDIM + IA
               NEJ   = (NJ - 1) * NDIM + IA
               ESTF(NEI,NEJ) = ESTF(NEI,NEJ) + EST1(NI,NJ)
               EMSS(NEI,NEJ) = EMSS(NEI,NEJ) + EMS1(NI,NJ)
C
               IF (PROBTYPE .EQ. 'SCATTER') THEN
C
                 ESTF(NEI,NEJ) = ESTF(NEI,NEJ) - SHIFT * EMSS(NEI,NEJ)
C
               END IF
C
   70       CONTINUE
C
            IF (IPRINT .GE. 5) THEN
               WRITE(IOUT,1030) NEL
               DO 80 IP = 1 , NNODE
   80          WRITE(IOUT,1040) (EST1(IP,JP),JP=1,NNODE),
     1                          (EMS1(IP,JP),JP=1,NNODE)
            END IF
C
  100    CONTINUE
C
         IF (IPRINT .GE. 5) THEN
            WRITE(IOUT,1050) NEL
            DO 110 IP = 1 , NNODES
  110       WRITE(IOUT,1020) (ESTF(IP,JP),JP=1,NNODES)
            WRITE(IOUT,1060) NEL
            DO 120 IP = 1 , NNODES
  120       WRITE(IOUT,1020) (EMSS(IP,JP),JP=1,NNODES)
         END IF
C
C      CALCULATE ELEMENT MATRICES FOR NONDIAGONAL
C      ELEMENTS OF STIFFNESS MATRIX
C
         IF (NDIM .NE. 1) THEN
C
         DO 180 IA = 1 , NDIM - 1
         DO 180 IB = IA + 1 , NDIM
C
            DO 140 NAB = 1 , NNODE
               UNODE(NAB)   =   UPOT(IA,IB,NAB)
               QNODE(NAB)   =   QPOT(IA,IB,NAB)
  140       CONTINUE
C
            CALL ESTIFN(XNODE,XG,WG,NGQ,NNODE,EST1,UNODE,QNODE,
     1                  PSI,DPSI,IDIM)
C
            DO 150 NI = 1  , NNODE
            DO 150 NJ = NI , NNODE
C
               NEI  = (NI - 1) * NDIM + IA
               NEJ  = (NJ - 1) * NDIM + IB
               ESTF(NEI,NEJ) = ESTF(NEI,NEJ) + EST1(NI,NJ)
C
               IF (NJ .NE. NNODE) THEN
C
                 NEII = NEI + IB - IA
                 NEJJ = NEJ - IB + IA + NDIM
                 ESTF(NEII,NEJJ) = ESTF(NEII,NEJJ) + EST1(NJ+1,NI)
C
               END IF
C
  150       CONTINUE
C
            IF (IPRINT .GE. 5) THEN
               WRITE(IOUT,1070) NEL
               DO 160 IP = 1 , NNODE
  160          WRITE(IOUT,1040) (EST1(IP,JP),JP=1,NNODE)
            END IF
C
  180    CONTINUE
C
         IF (IPRINT .GE. 5) THEN
            WRITE(IOUT,1050) NEL
            DO 190 IP = 1 , NNODES
  190       WRITE(IOUT,1020) (ESTF(IP,JP),JP=1,NNODES)
         END IF
C
         END IF
C
         NL  = 0
         DO 210 IL = 1  , NNODES
         DO 210 JL = IL , NNODES
            NL        = NL + 1
            ESTFA(NL) = ESTF(IL,JL)
C
            IF (PROBTYPE .EQ. 'EIGEN') THEN
C
                ESTFB(NL) = EMSS(IL,JL)
C
            END IF
C
  210    CONTINUE
C
C      ASSEMBLE ELEMENT MATRICES INTO GLOBAL
C      STIFFNESS AND MASS MATRICES
C
         CALL ADDVEC(A,NWT,MAXA,NNM,ESTFA,NSTF,NODES(1,NEL),NNODES,1)
C
         IF (PROBTYPE .EQ. 'EIGEN') THEN
C
           CALL ADDVEC(A,NWT,MAXA,NNM,ESTFB,NSTF,NODES(1,NEL),NNODES,2)
C
         END IF
C
  220 CONTINUE
C
        READ(IOUP) L,((H(I,J),J=I  ,MDIM),I=1,MDIM),
     1               ((Q(I,J),J=I+1,MDIM),I=1,MDIM)
        DO I = 1 , MDIM
          DO J = I + 1 , MDIM
            H(J,I) =   H(I,J)
            Q(J,I) = - Q(I,J)
          END DO
          Q(I,I) = ZERO
        END DO
C
      IF (IPRINT .GE. 4) THEN
         WRITE(IOUT,1080) NN,NNM,NWK,NNODE,NNODES,NELEM,NDIM,NGRID
         WRITE(IOUT,1090) NWK
         WRITE(IOUT,1020) (A(I),I=1,NWK)
         IF (PROBTYPE .EQ. 'EIGEN') THEN
           WRITE(IOUT,1100) NWK
           WRITE(IOUT,1020) (A(I),I=NWK+1,2*NWK)
         END IF
      END IF
C
      RETURN
 1020 FORMAT(6(2X,D10.4))
 1030 FORMAT(/5X,'ELEMENT STIFFNESS AND MASS MATRICES EST1 & ',
     1            'EMS1 (ELEMENT NO ',I3,' ) :'/)
 1040 FORMAT(5(3X,D12.6))
 1050 FORMAT(/5X,
     * 'ELEMENT STIFFNESS MATRIX ESTF (ELEMENT NO ',I3,' ) :'/)
 1060 FORMAT(/5X,
     *      'ELEMENT MASS MATRIX EMSS (ELEMENT NO ',I3,' ) :'/)
 1070 FORMAT(/5X,
     * 'ELEMENT STIFFNESS MATRIX EST1 (ELEMENT NO ',I3,' ) :'/)
 1080 FORMAT(//15X,'DIMENSIONS SET IN ASSMBL ARE : ',//5X,
     1 'NN     = ',I5,5X,'NNM    = ',I5,5X,
     2 'NWK    = ',I5,5X,'NNODE  = ',I5,5X/5X,
     3 'NNODES = ',I5,5X,'NELEM  = ',I5,5X,
     4 'NDIM   = ',I5,5X,'NGRID  = ',I5,/)
 1090 FORMAT(//20X,'S T I F F N E S S  M A T R I X  A(',I5,') :'/)
 1100 FORMAT(//20X,'M A S S  M A T R I X  B(',I5,') :'/)
 1110 FORMAT(/10X,'ARRAY XNODE (NEL = ',I3,' )'/)
 1120 FORMAT(5(1X,I2,2X,D10.4))
 1130 FORMAT(/15X,'SHAPE FUNCTIONS PSI(NNODE,NGQ) :'/)
 1140 FORMAT(6(1X,D12.6))
 1150 FORMAT(/)
      END
C
      SUBROUTINE EMASSD(XNODE,XG,WG,NGQ,NNODE,EMSS,PSI,IDIM)
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
C .                                                                   .
C .   P R O G R A M                                                   .
C .                  TO CALCULATE AN ELEMENT MASS MATRIX              .
C .                                                                   .
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION XNODE(NNODE),EMSS(NNODE,NNODE),XG(NGQ),WG(NGQ),
     1          PSI(NNODE,NGQ)
      DATA ZERO / 0.D0 /, TWO / 2.D0 /
C
C      INITIALIZE ELEMENT ARRAY
C
      DO 10 I = 1 , NNODE
      DO 10 J = 1 , NNODE
         EMSS(I,J) = ZERO
   10 CONTINUE
C
C      FORM JACOBI DETERMINANT
C
      DETJ = (XNODE(NNODE) - XNODE(1)) / TWO
      DETI = (XNODE(NNODE) + XNODE(1)) / TWO 
C
C      BEGIN INTEGRATION POINT LOOP
C
      DO 50 IG = 1 , NGQ
C
        RG = DETJ * XG(IG) + DETI
        RR = RG ** (IDIM-1)
C
        DO 40 I = 1 , NNODE
        DO 40 J = I , NNODE
C
          EMSS(I,J) = EMSS(I,J)
     1              + PSI(I,IG) * PSI(J,IG) * RR * WG(IG) * DETJ
          EMSS(J,I) = EMSS(I,J)
C
   40  CONTINUE
C
   50 CONTINUE
      RETURN
      END
C
      SUBROUTINE ESTIFD(XNODE,XG,WG,NGQ,NNODE,EST,POT,PSI,DPSI,IDIM)
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
C .                                                                   .
C .   P R O G R A M                                                   .
C .                  TO CALCULATE AN ELEMENT STIFFNESS MATRIX         .
C .                  FOR DIAGONAL PART                                .
C .                                                                   .
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION XNODE(NNODE),EST(NNODE,NNODE),XG(NGQ),WG(NGQ),
     1          PSI(NNODE,NGQ),DPSI(NNODE,NGQ),POT(NNODE)
      DATA ZERO / 0.D0 /, TWO / 2.D0 /
C
C      INITIALIZE ELEMENT ARRAY
C
      DO 10 I = 1 , NNODE
      DO 10 J = 1 , NNODE
C
         EST(I,J) = ZERO
C
   10 CONTINUE
C
C      FORM JACOBI DETERMINANT
C
      DETJ = (XNODE(NNODE) - XNODE(1)) / TWO
      DETI = (XNODE(NNODE) + XNODE(1)) / TWO
C
C      BEGIN INTEGRATION POINT LOOP
C
      DO 50 IG = 1 , NGQ
C
        RG = DETJ * XG(IG) + DETI
        RR = RG ** (IDIM - 1)
C
        DO 40 I = 1 , NNODE
        DO 40 J = I , NNODE
C
         EST(I,J) = EST(I,J) + (PSI(I,IG) * PSI(J,IG) * POT(IG)
     1            + DPSI(I,IG) * DPSI(J,IG) / DETJ / DETJ)
     2            * RR * WG(IG) * DETJ
         EST(J,I) = EST(I,J)
C
   40   CONTINUE
C
   50 CONTINUE
      RETURN
      END
C
      SUBROUTINE ESTIFN(XNODE,XG,WG,NGQ,NNODE,EST,UPOT,QPOT,PSI,DPSI,
     1                  IDIM)
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
C .                                                                   .
C .   P R O G R A M                                                   .
C .                  TO CALCULATE AN ELEMENT STIFFNESS MATRIX         .
C .                  FOR NONDIAGONAL PART                             .
C .                                                                   .
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION XNODE(NNODE),EST(NNODE,NNODE),XG(NGQ),WG(NGQ),
     1          PSI(NNODE,NGQ),DPSI(NNODE,NGQ),UPOT(NNODE),QPOT(NNODE)
      DATA ZERO / 0.D0 /, TWO / 2.D0 /
C
C      INITIALIZE ELEMENT ARRAY
C
      DO 10 I = 1 , NNODE
      DO 10 J = 1 , NNODE
C
         EST(I,J) = ZERO
C
   10 CONTINUE
C
C      FORM JACOBI DETERMINANT
C
      DETJ = (XNODE(NNODE) - XNODE(1)) / TWO
      DETI = (XNODE(NNODE) + XNODE(1)) / TWO
C
C      BEGIN INTEGRATION POINT LOOP
C
      DO 50 IG = 1 , NGQ
C
        RG = DETJ * XG(IG) + DETI
        RR = RG ** (IDIM-1)
C
        DO 40 I = 1 , NNODE
        DO 40 J = 1 , NNODE
C
          EST(I,J) = EST(I,J) +  RR * QPOT(IG) * (PSI(I,IG) * DPSI(J,IG)
     1             - DPSI(I,IG) * PSI (J,IG)) / DETJ * WG(IG) * DETJ
          EST(I,J) = EST(I,J) + PSI(I,IG) * UPOT(IG) * PSI(J,IG)
     1             * WG(IG) * DETJ * RR
   40   CONTINUE
C
   50 CONTINUE
      RETURN
      END
C
      SUBROUTINE HQPOTN(XGRID,XG,NGQ,NGRID,UPOT,QPOT,H,Q,NELEM,NDIM,
     1                  MDIM,IOUT,IOUP,IPRINT,IPRSTP,NNODE,NODE,XNODE)
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
C .                                                                   .
C .   P R O G R A M                                                   .
C .                  TO CALCULATE POTENTIAL CURVES AND MATRIX         .
C .                  ELEMENTS AND WRITE TO FILE IOUP                  .
C .                                                                   .
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION QPOT(MDIM,MDIM,NGQ),UPOT(MDIM,MDIM,NGQ),XGRID(NGRID),
     1          NODE(NNODE,NELEM),XNODE(NNODE),H(MDIM,MDIM),
     2          Q(MDIM,MDIM),XG(NGQ)
      DATA ZERO / 0.D0 /, TWO / 2.D0 /
C
      REWIND IOUP
      LC = 0
C
      DO 110 L = 1 , NELEM
C
        DO  LL = 1 , NNODE
          NE           = NODE(LL,L)
          XNODE(LL)    = XGRID(NE)
        END DO
C
        DETJ = (XNODE(NNODE) - XNODE(1)) / TWO
        DETI = (XNODE(NNODE) + XNODE(1)) / TWO
C
C      BEGIN INTEGRATION POINT LOOP
C
        DO 50 IG = 1 , NGQ
C
          RG = DETJ * XG(IG) + DETI
C
          CALL POTCAL(RG,H,Q,MDIM,IOUT)
C
          DO 170 I = 1 , MDIM
C
            DO 140 J = I , MDIM
C
              UPOT(I,J,IG) = H(I,J)
              UPOT(J,I,IG) = H(I,J)
C
              IF (I .EQ. J) THEN
C
                QPOT(I,I,IG) = ZERO
C
              ELSE
C
                QPOT(I,J,IG) =  Q(I,J)
                QPOT(J,I,IG) = -Q(I,J)
C
              END IF
C
  140       CONTINUE
C
  170     CONTINUE
C
C     PRINT POTENTIAL MATRIX ELEMENTS IN THE NGRID POINTS
C
          IF (IPRINT .GE. 2) THEN
            IF (LC / IPRSTP * IPRSTP .EQ. LC) THEN
              IF (MDIM .GT. 1) THEN
                WRITE(IOUT,1000)
                WRITE(IOUT,1010)  LC,RG
                DO 363 I = 1 , MDIM
 363            WRITE(IOUT,1020) (UPOT(I,J,IG),J=1,MDIM)
                WRITE(IOUT,1030)  LC,RG
                DO 364 I = 1 , MDIM
 364            WRITE(IOUT,1020) (QPOT(I,J,IG),J=1,MDIM)
              ELSE
                WRITE(IOUT,1040)
                WRITE(IOUT,1050) RG,UPOT(1,1,IG)
              END IF
            END IF
          END IF
C
          LC = LC + 1
C
   50   CONTINUE
C
        WRITE(IOUP) L,(((UPOT(I,J,IG),J=I  ,MDIM),I=1,MDIM),IG=1,NGQ),
     1                (((QPOT(I,J,IG),J=I+1,MDIM),I=1,MDIM),IG=1,NGQ)
C
  110 CONTINUE
C
         CALL POTCAL(XGRID(NGRID),H,Q,MDIM,IOUT)
         WRITE(IOUP) NGRID,((H(I,J),J=I  ,MDIM),I=1,MDIM),
     1                     ((Q(I,J),J=I+1,MDIM),I=1,MDIM)
         CALL POTCAL(XGRID(1    ),H,Q,MDIM,IOUT)
         WRITE(IOUP)      1,((H(I,J),J=I  ,MDIM),I=1,MDIM),
     1                     ((Q(I,J),J=I+1,MDIM),I=1,MDIM)
C
      ENDFILE IOUP
C
      RETURN
 1000 FORMAT(//10X,'P O T E N T I A L  M A T R I C E S  V(I,J)',
     * ' A N D  Q(I,J):')
 1010 FORMAT(/5X,'V-MATRIX AT THE POINT NO = ',I5,
     * '  AND HYPERRADIUS RHO = ',F11.5)
 1020 FORMAT(6(2X,D10.4))
 1030 FORMAT(/5X,'Q-MATRIX AT THE POINT NO = ',I5,
     * '  AND HYPERRADIUS RHO = ',F11.5)
 1040 FORMAT(//10X,'P O T E N T I A L  M A T R I X  V(1,1):'//
     *        4(4X,'RHO',5X,'V(1,1)',2X))
 1050 FORMAT(4(1X,F7.3,2X,D10.4))
      END
C
      SUBROUTINE ADDVEC(A,NWT,MAXA,NNM,STIFF,NSTF,NODE,NNODE,KOD)
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
C .                                                                   .
C .   P R O G R A M                                                   .
C .                  TO ASSEMBLE ELEMENT VECTOR STIFF INTO GLOBAL     .
C .                  VECTOR A USING A COMPACT STORAGE FORM            .
C .                                                                   .
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(NWT),MAXA(NNM),STIFF(NSTF),NODE(NNODE)
      NS = 0
      IF (KOD .NE. 1) NS = NWT / 2
      NDF = 0
      DO 20 I = 1 , NNODE
         NI = NODE(I)
         IF (NI .GT. 0) THEN
            MNI = MAXA(NI)
            MI  = I
            DO 10 J = 1 , NNODE
               NJ = NODE(J)
               IF (NJ .GT. 0) THEN
                  NIJ = NI - NJ
                  IF (NIJ .GE. 0) THEN
                     MIJ  = MNI + NIJ
                     MNIJ = MI
                     IF (J .GE. I) MNIJ = J + NDF
                     A(MIJ + NS) = A(MIJ + NS) + STIFF(MNIJ)
                  END IF
               END IF
               MI = MI + NNODE - J
   10       CONTINUE
         END IF
         NDF = NDF + NNODE - I
   20 CONTINUE
      RETURN
      END
C
      SUBROUTINE ADDVEK(A,NWT,MAXA,NNM,STIFF,NSTF,NODE,NNODE,KOD)
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
C .                                                                   .
C .   P R O G R A M                                                   .
C .                  TO ASSEMBLE ELEMENT VECTOR STIFF INTO GLOBAL     .
C .                  VECTOR A USING A COMPACT STORAGE FORM            .
C .                                                                   .
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION MAXA(NNM),STIFF(NSTF),NODE(NNODE)
      COMPLEX*16 A(NWT)
      NS = 0
      IF (KOD .NE. 1) NS = NWT / 2
      NDF = 0
      DO 20 I = 1 , NNODE
         NI = NODE(I)
         IF (NI .GT. 0) THEN
            MNI = MAXA(NI)
            MI  = I
            DO 10 J = 1 , NNODE
               NJ = NODE(J)
               IF (NJ .GT. 0) THEN
                  NIJ = NI - NJ
                  IF (NIJ .GE. 0) THEN
                     MIJ  = MNI + NIJ
                     MNIJ = MI
                     IF (J .GE. I) MNIJ = J + NDF
                     A(MIJ + NS) = A(MIJ + NS) + STIFF(MNIJ)
                  END IF
               END IF
               MI = MI + NNODE - J
   10       CONTINUE
         END IF
         NDF = NDF + NNODE - I
   20 CONTINUE
      RETURN
      END
C
      SUBROUTINE BOUNDC(NODE,NODES,MAXA,MHT,NHT,IBOUND,NNODE,NNODES,
     1                  NELEM,NDIM,NN,NNE,IPRINT,IOUT)
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
C .                                                                   .
C .   P R O G R A M                                                   .
C .                  TO SET THE DIRICHLET AND NEUMANN BOUNDARY        .
C .                  CONDITIONS                                       .
C .                                                                   .
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION MAXA(1),MHT(1),NHT(1),NODE(NNODE,NELEM),
     1          NODES(NNODES,NELEM)
C
C      ESTABLISH BOUNDARY CONDITIONS
C
      GO TO (10,40,60,80),IBOUND
C
C      DIRICHLET - DIRICHLET BOUNDARY CONDITIONS
C
   10 IK    = 0
      NEL   = 1
      DO 20 IL = 1 , NDIM
         IK      = IK + 1
         NHT(IK) = NODES(IL,NEL)
   20 CONTINUE
      NEL  = NELEM
      DO 30 IL = 1 , NDIM
         IK       = IK + 1
         ILL      = NDIM * (NNODE - 1)
         NHT(IK)  = NODES(IL + ILL,NEL)
   30 CONTINUE
      GO TO 200
C
C      DIRICHLET - NEUMANN BOUNDARY CONDITIONS
C
   40 IK   = 0
      NEL  = 1
      DO 50 IL = 1 , NDIM
         IK       = IK + 1
         NHT(IK)  = NODES(IL,NEL)
   50 CONTINUE
      GO TO 200
C
C      NEUMANN - DIRICHLET BOUNDARY CONDITIONS
C
   60 IK    = 0
      NEL   = NELEM
      DO 70 IL = 1 , NDIM
         IK       = IK + 1
         ILL      = NDIM * (NNODE - 1)
         NHT(IK)  = NODES(IL + ILL,NEL)
   70 CONTINUE
      GO TO 200
C
C      NEUMANN - NEUMANN BOUNDARY CONDITION
C
   80 GO TO 300
C
  200 CONTINUE
C
C      ELIMINATE CORRESPONDING COLUMNS AND ROWS FOR THE
C      IMPLEMENTATION OF THE DIRICHLET BOUNDARY CONDITIONS
C      AND SET A NEW NUMERATION OF NODES
C
      DO 210 IL = 1 , NNE
         MAXA(IL) = IL
         MHT (IL) = 0
  210 CONTINUE
C
      DO 220 I = 1 , IK
         J        = NHT(I)
         MHT(J)   = 1
  220 CONTINUE
C
      DO 230 NEL = 1 , NELEM
      DO 230   I = 1 , NNODES
         K  = NODES(I,NEL)
         IF (K .EQ. 0) GO TO 230 !!! ADDING CHUKA FOR COMPAQ FORTRAN
         IF (MHT(K) .NE. 0) NODES(I,NEL) = 0
  230 CONTINUE
C
      DO 240 I = 1 , IK
         J       = NHT(I)
         MAXA(J) = 0
  240 CONTINUE
C
      NN  = 0
      DO 250 I = 1 , NNE
         MHT(I)   = 0
         IF (MAXA(I) .NE. 0) THEN
             NN       = NN + 1
             NHT(NN)  = I
             MHT(I)   = NN
         END IF
  250 CONTINUE
C
      DO 270 NEL = 1 , NELEM
         DO 260 I = 1 , NNODES
            K   = NODES(I,NEL)
            IF (K .NE. 0) THEN
               NODES(I,NEL) = MHT(K)
            END IF
  260    CONTINUE
  270 CONTINUE
C
  300 CONTINUE
C
      IF (IPRINT .GE. 3) THEN
         WRITE(IOUT,1020) NNODE,NELEM
         DO 320 NEL = 1 , NELEM
  320    WRITE(IOUT,1030) (NODES(IP,NEL),IP=1,NNODES)
         WRITE(IOUT,1040)
      END IF
      RETURN
 1020 FORMAT(//3X,'NODAL ARRAY NODES (',I3,',',I3,
     1       ') MODIFY ACCORDING TO DIRICHLET CONDITION :'/)
 1030 FORMAT(12I6)
 1040 FORMAT(/)
      END
C
      SUBROUTINE COLMHT(MHT,NNM,NNODE,NODE)
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
C .                                                                   .
C .   P R O G R A M                                                   .
C .                  TO CALCULATE COLUMN HEIGHTS                      .
C .                                                                   .
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION MHT(NNM),NODE(NNODE)
      NMAX = 1000000
      DO 10 I = 1 , NNODE
         NDI = NODE(I)
         IF (NDI .NE. 0) THEN
            IF ((NDI - NMAX) .LT. 0) NMAX = NDI
         END IF
   10 CONTINUE
      DO 20 I = 1 , NNODE
         NDI = NODE(I)
         IF (NDI .NE. 0) THEN
            NDIF = NDI - NMAX
            IF (NDIF .GT. MHT(NDI)) MHT(NDI) = NDIF
         END IF
   20 CONTINUE
      RETURN
      END
C
      SUBROUTINE ERRDIM(N,I,IOUT)
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
C .                                                                   .
C .   P R O G R A M                                                   .
C .                  TO PRINT MESSAGES WHEN HIGH-SPEED STORAGE        .
C .                  IS EXCEEDED                                      .
C .                                                                   .
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
      GO TO (1,2,3,4,5,6),I
    1 WRITE(IOUT,1010)
      WRITE(IOUT,1100) N
      STOP
    2 WRITE(IOUT,1020)
      GO TO 10
    3 WRITE(IOUT,1030)
      GO TO 10
    4 WRITE(IOUT,1040)
   10 WRITE(IOUT,1110) N
      STOP
    5 WRITE(IOUT,1020)
      GO TO 20
    6 WRITE(IOUT,1040)
      GO TO 20
   20 WRITE(IOUT,1120) N
      STOP
      RETURN
 1010 FORMAT(//3X,'*****   ERRDIM  ***** ',
     *       //3X,'NOT ENOUGH STORAGE FOR NODAL POINT DATA'/)
 1020 FORMAT(//3X,'*****   ERRDIM  ***** ',
     *       //3X,'NOT ENOUGH STORAGE FOR ASSEMBLAGE OF GLOBAL ',
     *            'STIFFNESS AND MASS MATRICES '/)
 1030 FORMAT(//3X,'*****   ERRDIM  ***** ',
     *       //3X,'NOT ENOUGH STORAGE FOR EIGENVALUE',
     *            ' PROBLEM SOLUTION PHASE'/)
 1040 FORMAT(//3X,'*****   ERRDIM  ***** ',
     *       //3X,'NOT ENOUGH STORAGE FOR SCATTERING',
     *            ' PROBLEM SOLUTION PHASE'/)
 1100 FORMAT(/3X,'STORAGE OF ARRAY ITOT IS EXCEEDED BY ',I9/)
 1110 FORMAT(/3X,'STORAGE OF ARRAY TOT IS EXCEEDED BY ',I9/)
 1120 FORMAT(/3X,'STORAGE OF ARRAY ZTOT IS EXCEEDED BY ',I9/)
      END
C
      SUBROUTINE FEGRID(RMESH,NMESH,RGRID,NGRID,NELEM,NPOL)
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
C .                                                                   .
C .   P R O G R A M                                                   .
C .                  TO CALCULATE NODAL POINTS RGRID(NGRID)           .
C .                                                                   .
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION RMESH(NMESH),RGRID(1)
      NG = 0
      NL = 0
      DO 20 I = 3 , NMESH, 2
          XM  = RMESH(I) - RMESH(I-2)
          XS  = XM / IDINT(RMESH(I-1)) / DFLOAT(NPOL)
          NM  = IDINT(XM / XS + 0.000000000001)
          NL  = NL + IDINT(RMESH(I-1))
          DO 10 J = 1 , NM
              NG            = NG + 1
                RGRID(NG)     = RMESH(I-2) + (J-1) * XS
   10     CONTINUE
   20 CONTINUE
      NELEM        = NL
      NGRID        = NG + 1
      RGRID(NGRID) = RMESH(NMESH)
      RETURN
      END
C
      SUBROUTINE MAXHT(MAXA,MHT,NODES,NNODES,NELEM,NN,NNM,NWK,NWM,
     1                 MK,IPRINT,IOUT)
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
C .                                                                   .
C .   P R O G R A M                                                   .
C .                  TO CALCULATE ADDRESSES OF DIAGONAL ELEMENTS      .
C .                  IN BANDED MATRIX                                 .
C .                                                                   .
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION MAXA(NNM),MHT(NNM),NODES(NNODES,NELEM)
C
C      CALCULATE COLUMN HEIGHTS
C
      DO 10 IL = 1 , NN
         MHT (IL) = 0
         MAXA(IL) = 0
   10 CONTINUE
C
      DO 20 NEL = 1 , NELEM
         CALL COLMHT(MHT,NNM,NNODES,NODES(1,NEL))
   20 CONTINUE
C
C      SET ADDRESSES OF DIAGONAL ELEMENTS IN MAXA
C
      MAXA(1) = 1
      MAXA(2) = 2
      MK      = 0
      DO 30 IL = 1 , NN
         IF (MHT(IL) .GT. MK) MK = MHT(IL)
         MAXA(IL+1) = MAXA(IL) + MHT(IL) + 1
   30 CONTINUE
C
      MK   = MK + 1
      NNM  = NN + 1
      NWK  = MAXA(NNM) - 1
      NWM  = NWK
C
      IF (IPRINT .GE. 3) THEN
         WRITE(IOUT,1010) NNM
         WRITE(IOUT,1020) (MAXA(I),I=1,NNM)
         WRITE(IOUT,1030)
      END IF
C
      IF (IPRINT .GE. 3) THEN
 1010 FORMAT(/3X,'ADDRESSES OF DIAGONAL ELEMENTS SET IN PROFILE ',
     * 'MATRIX MAXA(',I5,') :'/)
 1020 FORMAT(10I7)
 1030 FORMAT(/)
      END IF
      RETURN
      END
C
      SUBROUTINE NODGEN(NODE,NNODE,NODES,NNODES,NDIM,NELEM,IPRINT,IOUT)
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
C .                                                                   .
C .   P R O G R A M                                                   .
C .                  TO CALCULATE THE NODAL POINT DISTRIBUTION        .
C .                                                                   .
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION NODE(NNODE,NELEM),NODES(NNODES,NELEM)
C
C      NUMERATE THE NODES
C
      DO I = 1 , NNODES
        DO J = 1 , NELEM
          NODES(I,J) = 0
          IF (I .LE. NNODE) NODE(I,J) = 0
        END DO
      END DO
C
      DO 10 NI = 1 , NNODE
         NODE(NI,1) = NI
   10 CONTINUE
C
      DO 30 NEL = 2 , NELEM
         DO 20 ND = 1 , NNODE
            NODE(ND,NEL) = NODE(NNODE,NEL-1) + ND - 1
   20    CONTINUE
   30 CONTINUE
C
C      GENERATE NODAL NUMBERS FOR MULTICHANNEL CASE
C
      DO 50 NEL = 1 , NELEM
      DO 50 NL  = 1 , NNODE
         DO 40 KL = 1 , NDIM
            IL = (NL - 1) * NDIM + KL
            JL = NODE(NL,NEL) * NDIM + KL - NDIM
            NODES(IL,NEL) = JL
   40    CONTINUE
   50 CONTINUE
C
      IF (IPRINT .GE. 3) THEN
         WRITE(IOUT,1000)
         WRITE(IOUT,1010) NNODE,NELEM
         DO 160 NEL = 1 , NELEM
  160    WRITE(IOUT,1020) NEL,(NODE(IP,NEL),IP=1,NNODE)
         WRITE(IOUT,1030) NNODE,NELEM
         DO 170 NEL = 1 , NELEM
  170    WRITE(IOUT,1040) (NODES(IP,NEL),IP=1,NNODES)
         WRITE(IOUT,1050)
      END IF
      RETURN
 1000 FORMAT(//15X,'N O D A L   D A T A   I N F O R M A T I O N '/
     *         15X,'------------------------------------------- '/)
 1010 FORMAT(/20X,'NODAL ARRAY NODE (',I2,' , ',I4,') :'/)
 1020 FORMAT(5X,'ELEMENT NO ',I5,5X,10I5)
 1030 FORMAT(//20X,'NODAL ARRAY NODES (',I4,' , ',I4,') :'/)
 1040 FORMAT(12I6)
 1050 FORMAT(/)
      END
C
      SUBROUTINE SHAPEF(X,PSI,DPSI,XNODE,NPOL1)
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
C .                                                                   .
C .   P R O G R A M                                                   .
C .                  TO CALCULATE SHAPE FUNCTIONS PSI(I) AND THEIR    .
C .                  DERIVATIVES DPSI(I) WITH RESPECT TO THE MASTER   .
C .                  ELEMENT COORDINATE AT A SPECIFIED VALUE OF X     .
C .                                                                   .
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION PSI(NPOL1),DPSI(NPOL1),XNODE(NPOL1)
      DATA ZERO / 0.D0 /, ONE / 1.D0 /, TWO / 2.D0 /
      NPOL  = NPOL1 - 1
      HNODE = TWO / DFLOAT(NPOL)
      DO 10 IP = 1 , NPOL1
          XNODE(IP) = - ONE + HNODE * (IP - 1)
   10 CONTINUE
      DO 40 NP = 1 , NPOL1
          PSIN       = ONE
          PSI(NP)    = ONE
          DPSI(NP)   = ZERO
          DO 30 IP = 1 , NPOL1
              IF (IP .NE. NP) THEN
                  PSI(NP) = PSI(NP) * (X - XNODE(IP))
                  PSIN    = PSIN * (XNODE(NP) - XNODE(IP))
                  PSID    = ONE
                  DO 20 JP = 1 , NPOL1
                      IF (JP .NE. IP .AND. JP .NE. NP) THEN
                           PSID = PSID * (X - XNODE(JP))
                      END IF
   20             CONTINUE
                  DPSI(NP) = DPSI(NP) + PSID
              END IF
   30     CONTINUE
          PSI(NP)  = PSI(NP)  / PSIN
          DPSI(NP) = DPSI(NP) / PSIN
   40 CONTINUE
      RETURN
      END
C
C     PUBLISHED PROGRAMS
C
      SUBROUTINE GAULEG(X1,X2,X,W,N,EPS)
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
C .                                                                   .
C .   P R O G R A M                                                   .
C .                  TO CALCULATE THE NODES AND WEIGHTS OF THE        .
C .                  GAUSS-LEGENDRE QUADRATURE. PUBLISHED IN:         .
C .                  W.H. PRESS, B.F. FLANERY, S.A. TEUKOLSKY,        .
C .                  AND W.T.VETTERLEY, NUMERICAL RECIPES: THE        .
C .                  ART OF SCIENTIFIC COMPUTING (CAMBRIDGE           .
C .                  UNIVERSITY PRESS, CAMBRIDGE, 1986), CHAP. 4      .
C .                                                                   .
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION X(N),W(N)
      DATA ZERO/0.D0/, QUAT/0.25D0/, HALF/0.5D0/, ONE/1.D0/, TWO/2.D0/
      PI = DACOS(-ONE)
      M=(N+1)/2
      XM=HALF*(X2+X1)
      XL=HALF*(X2-X1)
      DO 12 I = 1 , M
        Z=DCOS(PI*(I-QUAT)/(N+HALF))
    1   CONTINUE
          P1=ONE
          P2=ZERO
          DO 11 J = 1 , N
            P3=P2
            P2=P1
            P1=((TWO*J-ONE)*Z*P2-(J-ONE)*P3)/J
   11     CONTINUE
          PP=N*(Z*P1-P2)/(Z*Z-ONE)
          Z1=Z
          Z=Z1-P1/PP
        IF (ABS(Z-Z1).GT.EPS) GO TO 1
        X(I)=XM-XL*Z
        X(N+1-I)=XM+XL*Z
        W(I)=TWO*XL/((ONE-Z*Z)*PP*PP)
        W(N+1-I)=W(I)
   12 CONTINUE
      RETURN
      END
C
      SUBROUTINE GAUSSC(A,N,NP,B,M,MP)
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
C .                                                                   .
C .   P R O G R A M                                                   .
C                    PROGRAM GAUSSC TO CALCULATE SOLUTION OF THE      .
C .                  LINEAR EQUATION BY GAUSS-JORDAN ELIMINATION.     .
C .                  PUBLISHED IN: W.H. PRESS, B.F. FLANERY,          .
C .                  S.A. TEUKOLSKY, AND W.T. VETTERLEY, NUMERICAL    .
C .                  RECIPES: THE ART OF SCIENTIFIC COMPUTING         .
C .                  (CAMBRIDGE UNIVERSITY PRESS, CAMBRIDGE, 1986),   .
C .                  CHAP. 2                                          .
C .                                                                   .
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
      INTEGER M,MP,N,NP,NMAX
      COMPLEX*16 A(NP,NP),B(NP,MP)
      PARAMETER (NMAX=50)
      INTEGER I,ICOL,IROW,J,K,L,LL,INDXC(NMAX),INDXR(NMAX),IPIV(NMAX)
      COMPLEX*16 BIG,DUM,PIVINV
      DO 11 J=1,N
        IPIV(J)=0
11    CONTINUE
      DO 22 I=1,N
        BIG=0.D0
        DO 13 J=1,N
          IF(IPIV(J).NE.1)THEN
            DO 12 K=1,N
              IF (IPIV(K).EQ.0) THEN
                IF (CDABS(A(J,K)).GE.CDABS(BIG))THEN
                  BIG=CDABS(A(J,K))
                  IROW=J
                  ICOL=K
                ENDIF
              ELSE IF (IPIV(K).GT.1) THEN
                PAUSE 'SINGULAR MATRIX IN GAUSSC'
              ENDIF
12          CONTINUE
          ENDIF
13      CONTINUE
        IPIV(ICOL)=IPIV(ICOL)+1
        IF (IROW.NE.ICOL) THEN
          DO 14 L=1,N
            DUM=A(IROW,L)
            A(IROW,L)=A(ICOL,L)
            A(ICOL,L)=DUM
14        CONTINUE
          DO 15 L=1,M
            DUM=B(IROW,L)
            B(IROW,L)=B(ICOL,L)
            B(ICOL,L)=DUM
15        CONTINUE
        ENDIF
        INDXR(I)=IROW
        INDXC(I)=ICOL
        IF (A(ICOL,ICOL).EQ.0.D0) PAUSE 'SINGULAR MATRIX IN GAUSSC'

        PIVINV=1.D0/A(ICOL,ICOL)
        A(ICOL,ICOL)=1.D0
        DO 16 L=1,N
          A(ICOL,L)=A(ICOL,L)*PIVINV
16      CONTINUE
        DO 17 L=1,M
          B(ICOL,L)=B(ICOL,L)*PIVINV
17      CONTINUE
        DO 21 LL=1,N
          IF(LL.NE.ICOL)THEN
            DUM=A(LL,ICOL)
            A(LL,ICOL)=0.D0
            DO 18 L=1,N
              A(LL,L)=A(LL,L)-A(ICOL,L)*DUM
18          CONTINUE
            DO 19 L=1,M
              B(LL,L)=B(LL,L)-B(ICOL,L)*DUM
19          CONTINUE
          ENDIF
21      CONTINUE
22    CONTINUE
      DO 24 L=N,1,-1
        IF(INDXR(L).NE.INDXC(L))THEN

          DO 23 K=1,N
            DUM=A(K,INDXR(L))
            A(K,INDXR(L))=A(K,INDXC(L))
            A(K,INDXC(L))=DUM
23        CONTINUE
        ENDIF
24    CONTINUE
      RETURN
      END
C
      SUBROUTINE SSPACE(A,B,MAXA,R,EIGV,TT,W,AR,BR,VEC,D,RTOLV,BUP,BLO,
     1                  BUPC,NN,NNM,NWK,NWM,NROOT,RTOL,NC,NNC,NITEM,
     2                  IFSS,IFPR,IRRF,NSTIF,ALPHA,IOUT)
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
C .                                                                   .
C .   P R O G R A M                                                   .
C .        TO SOLVE FOR THE SMALLEST EIGENVALUES AND CORRESPONDING    .
C .        EIGENVECTORS IN THE GENERALIZED EIGENPROBLEM USING THE     .
C .        SUBSPACE ITERATION METHOD.  PUBLISHED IN:                  .
C .        K.- J. BATHE, FINITE ELEMENT PROCEDURES IN ENGINEERING     .
C .        ANALYSIS (PRENTICE-HALL, ENGLEWOOD CLIFFS, NY, 1982)       .
C .                                                                   .
C .   - - INPUT VARIABLES - -                                         .
C .                                                                   .
C .        A(NWK)    = STIFFNESS MATRIX IN COMPACTED FORM (ASSUMED    .
C .                    POSITIVE DEFINITE)                             .
C .        B(NWM)    = MASS MATRIX IN COMPACTED FORM                  .
C .        MAXA(NNM) = VECTOR CONTAINING ADDRESSES OF DIAGONAL        .
C .                    ELEMENTS OF STIFFNESS MATRIX A                 .
C .        R(NN,NC)  = EIGENVECTORS ON SOLUTION EXIT                  .
C .        EIGV(NC)  = EIGENVALUES ON SOLUTION EXIT                   .
C .        TT(NN)    = WORKING VECTOR                                 .
C .        W(NN)     = WORKING VECTOR                                 .
C .        AR(NNC)   = WORKING MATRIX STORING PROJECTION OF K         .
C .        BR(NNC)   = WORKING MATRIX STORING PROJECTION OF M         .
C .        VEC(NC,NC)= WORKING MATRIX                                 .
C .        D(NC)     = WORKING VECTOR                                 .
C .        RTOLV(NC) = WORKING VECTOR                                 .
C .        BUP(NC)   = WORKING VECTOR                                 .
C .        BLO(NC)   = WORKING VECTOR                                 .
C .        BUPC(NC)  = WORKING VECTOR                                 .
C .        NN        = ORDER OF STIFFNESS AND MASS MATRICES           .
C .        NNM       = NN+1                                           .
C .        NWK       = NUMBER OF ELEMENTS BELOW SKYLINE OF            .
C .                    STIFFNESS MATRIX                               .
C .        NWM       = NUMBER OF ELEMENTS BELOW SKYLINE OF            .
C .                    MASS MATRIX                                    .
C .                      I. E. NWM=NWK FOR CONSISTENT MASS MATRIX     .
C .                            NWM=NN  FOR LUMPED MASS MATRIX         .
C .        NROOT     = NUMBER OF REQUIRED EIGENVALUES AND EIGENVECTORS.
C .        RTOL      = CONVERGENCE TOLERANCE ON EIGENVALUES           .
C .                    ( 1.E-06 OR SMALLER)                           .
C .        NC        = NUMBER OF ITERATION VECTORS USED               .
C .                    (USUALLY SET TO MIN(2*NROOT,NROOT+8), BUT NC   .
C .                    CANNOT BE LARGER THAN THE NUMBER OF MASS       .
C .                    DEGREES OF FREEDOM)                            .
C .        NNC       = NC*(NC+1)/2 DIMENSION OF STORAGE VECTORS AR,BR .
C .        NITEM     = MAXIMUM NUMBER OF SUBSPACE ITERATIONS PERMITTED.
C .                    (USUALLY SET TO 16)                            .
C .                    THE PARAMETERS NC AND/OR NITEM MUST BE         .
C .                    INCREASED IF A SOLUTION HAS NOT CONVERGED      .
C .        IFSS      = FLAG FOR STURM SEQUENCE CHECK                  .
C .                      EQ.0  NO CHECK                               .
C .                      EQ.1  CHECK                                  .
C .        IFPR      = FLAG FOR PRINTING DURING ITERATION             .
C .                      LE.0  NO PRINTING                            .
C .                      EQ.1  PRINT                                  .
C .        IRRF      = FLAG FOR STARTING ITERATION VECTORS            .
C .                      EQ.0  PROGRAM ESTABLISH STARTING VECTORS     .
C .                      EQ.1  START FROM VECTORS WRITTEN IN R(NN,NC) .
C .        NSTIF     = SCRATCH FILE TO STORE STIFFNESS MATRIX         .
C .        ALPHA     = ENERGY SPECTRUM SHIFT (IF ALPHA=0 THE SHIFT IS .
C .                    DETERMINED BY THE PROGRAM AND THE STURM SEQU-  .
C .                    ENCE IS CHECKED)                               .
C .        IOUT      = OUTPUT PRINTING FILE                           .
C .                                                                   .
C .   - - OUTPUT - -                                                  .
C .                                                                   .
C .        EIGV(NROOT) = EIGENVALUES                                  .
C .        R(NN,NROOT) = EIGENVECTORS                                 .
C .                                                                   .
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER MAXA(NNM)
      DIMENSION A(NWK),B(NWM),R(NN,NC),TT(NN),W(NN),EIGV(NC),D(NC),
     1          VEC(NC,NC),AR(NNC),BR(NNC),RTOLV(NC),BUP(NC),BLO(NC),
     2          BUPC(NC)
      DATA ZERO / 0.D0 /, ONE / 1.D0 /
C
      ABS(X)  = DABS(X)
      SQRT(X) = DSQRT(X)
C
C          THIS PROGRAM IS USED IN SINGLE PRECISION ARITHMETIC ON
C          CDC EQUIPMENT AND DOUBLE PRECISION ARITHMETIC ON IBM
C          OR UNIVAC MACHINES. ACTIVATE,DEACTIVATE OR ADJUST ABOVE
C          CARDS FOR SINGLE OR DOUBLE PRECISION ARITHMETIC
C
C     SET TOLERANCE FOR JACOBI ITERATION
C
           TOLJ = 1.D-12
C
C     INITIALIZATION
C
      ICONV = 0
      NSCH  = 0
      NSMAX = 12
      N1    = NC+1
      NC1   = NC-1
      IF (ALPHA .EQ. ZERO) IFSS = 1
C
      IF (IFSS .EQ. 0) GOTO 65
      REWIND NSTIF
      WRITE(NSTIF) (A(I),I=1,NWK)
      ENDFILE NSTIF
   65 DO 60 I = 1 , NC
   60 D(I) = ZERO
C
C      ESTABLISH STARTING ITERATION VECTORS
C
      ND = NN / NC
      IF (IRRF .GT.  0) GO TO 55
      IF (NWM  .GT. NN) GO TO 4
      J = 0
      DO 2 I = 1 , NN
      II = MAXA(I)
      R(I,1) = B(I)
      IF (B(I) .GT. ZERO) J = J + 1
    2 W(I) = B(I) / A(II)
      IF (NC .LE. J) GO TO 16
      WRITE(IOUT,1007)
      STOP
    4 DO 10 I = 1 , NN
      II = MAXA(I)
      R(I,1) = B(II)
   10 W(I) = B(II) / A(II)
   16 DO 20 J = 2 , NC
      DO 20 I = 1 , NN
   20 R(I,J) = ZERO
C
      L = NN - ND
      DO 30 J = 2 , NC
      RT = ZERO
      DO 40 I = 1 , L
      IF (W(I) .LT. RT) GO TO 40
      RT = W(I)
      IJ = I
   40 CONTINUE
      DO 50 I = L , NN
      IF (W(I) .LE. RT) GO TO 50
      RT = W(I)
      IJ = I
   50 CONTINUE
      TT(J) = DFLOAT(IJ)
      W(IJ) = ZERO
      L = L - ND
   30 R(IJ,J) = ONE
C
      IF (IFPR. LE. 0) GO TO 55
      WRITE(IOUT,1008)
      WRITE(IOUT,1002) (TT(J),J=2,NC)
C
C     FACT0RIZE MATRIX A INTO (L)*(D)*(L(T))
C
   55 ISH = 1
      CALL DECOMP(A,MAXA,NN,ISH,IFPR,IOUT)
C
C  -   -   -  S T A R T   OF   I T E R A T I O N   L O O P
C
      NITE = 0
  100 NITE = NITE + 1
      IF (IFPR .LE. 0) GO TO 90
      WRITE(IOUT,1010) NITE
C
C     CALCULATE THE PROJECTIONS OF A AND B
C
   90 IJ = 0
      DO 110 J = 1 , NC
      DO 120 K = 1 , NN
  120 TT(K) = R(K,J)
      CALL REDBAK(A,TT,MAXA,NN)
      DO 130 I = J , NC
      ART = ZERO
      DO 140 K = 1 , NN
  140 ART = ART + R(K,I) * TT(K)
      IJ = IJ + 1
  130 AR(IJ) = ART
      DO 150 K = 1 , NN
  150 R(K,J) = TT(K)
  110 CONTINUE
      IJ = 0
      DO 160 J = 1 , NC
      CALL MULT(TT,B,R(1,J),MAXA,NN,NWM)
      DO 180 I = J , NC
      BRT = ZERO
      DO 190 K = 1 , NN
  190 BRT = BRT + R(K,I) * TT(K)
      IJ = IJ + 1
  180 BR(IJ) = BRT
      IF (ICONV .GT. 0) GO TO 160
      DO 200 K = 1 , NN
  200 R(K,J) = TT(K)
  160 CONTINUE
C
C     SOLVE FOR EIGENSYSTEM OF SUBSPACE OPERATORS
C
      IF (IFPR .LE. 0) GO TO 320
      IND = 1
  210 WRITE(IOUT,1020)
      II = 1
      DO 300 I = 1 , NC
      ITEMP = II + NC - I
      WRITE(IOUT,1005) (AR(J),J=II,ITEMP)
  300 II = II + N1 - I
      WRITE(IOUT,1030)
      II = 1
      DO 310 I = 1 , NC
      ITEMP = II + NC - I
      WRITE(IOUT,1005) (BR(J),J=II,ITEMP)
  310 II = II + N1 - I
      IF (IND .EQ. 2) GO TO 350
C
  320 CALL JACOBI(AR,BR,VEC,EIGV,W,NC,NNC,TOLJ,NSMAX,IFPR,IOUT)
C
      IF (IFPR .LE. 0) GO TO 350
      WRITE(IOUT,1040)
      IND = 2
      GO TO 210
C
C     ARRANGE EIGENVALUES IN ASCENDING ORDER
C
  350 IS = 0
      II = 1
      DO 360 I = 1 , NC1
      ITEMP = II + N1 - I
      IF (EIGV(I+1) .GE. EIGV(I)) GO TO 360
      IS = IS + 1
      EIGVT = EIGV(I+1)
      EIGV(I+1) = EIGV(I)
      EIGV(I) = EIGVT
      BT = BR(ITEMP)
      BR(ITEMP) = BR(II)
      BR(II) = BT
      DO 370 K = 1 , NC
      RT = VEC(K,I+1)
      VEC(K,I+1) = VEC(K,I)
  370 VEC(K,I) = RT
  360 II = ITEMP
      IF (IS   .GT. 0) GO TO 350
      IF (IFPR .LE. 0) GO TO 375
      WRITE(IOUT,1035)
      WRITE(IOUT,1006) (EIGV(I),I=1,NC)
C
C     CALCULATE B TIMES APPROXIMATE EIGENVECTORS (ICONV.EQ.0)
C          OR   FINAL EIGENVECTOR APPROXIMATIONS (ICONV.GT.0)
C
  375 DO 420 I = 1 , NN
      DO 422 J = 1 , NC
  422 TT(J) = R(I,J)
      DO 424 K = 1 , NC
      RT = ZERO
      DO 430 L = 1 , NC
  430 RT = RT + TT(L) * VEC(L,K)
  424 R(I,K) = RT
  420 CONTINUE
C
C     CHECK FOR CONVERGENCE OF EIGENVALUES
C
      DO 380 I = 1 , NC
      DIF = ABS(EIGV(I) - D(I))
  380 RTOLV(I) = DIF / ABS(EIGV(I) + ALPHA)
C
      IF (ICONV .GT. 0) GO TO 500
C
      IF (IFPR .LE. 0) GO TO 385
      WRITE(IOUT,1050)
      WRITE(IOUT,1005) (RTOLV(I),I=1,NC)
C
  385 DO 390 I = 1 , NROOT
      IF (RTOLV(I) .GT. RTOL) GO TO 400
  390 CONTINUE
      IF (IFPR .LT. 0) GO TO 395
      WRITE(IOUT,1060) RTOL
  395 CONTINUE
      ICONV = 1
      GO TO 100
  400 IF (NITE .LT. NITEM) GO TO 410
      IF (IFPR .GE. 0) WRITE(IOUT,1070)
      IFSS = 0
      ICONV = 2
      GO TO 100
  410 DO 440 I = 1 , NC
  440 D(I) = EIGV(I)
      GO TO 100
C
C  -   -   -  E N D   O F   I T E R A T I O N   L O O P
C
  500 IF (IFPR .LT. 0) GO TO 525
      WRITE(IOUT,1010)NITE
      WRITE(IOUT,1050)
      WRITE(IOUT,1006) (RTOLV(I),I = 1,NROOT)
  525 CONTINUE
C
      IF (IFPR .LE. 0) GOTO 535
C
      WRITE(IOUT,1110)
      DO 530 J = 1 , NROOT
  530 WRITE(IOUT,1005) (R(K,J),K=1,NN)
C
C     CALCULATE AND PRINT ERROR NORMS
C
  535 IF (IFSS .EQ. 0) GO TO 700
C
      REWIND NSTIF
      READ(NSTIF) (A(I),I=1,NWK)
C
      DO 580 L = 1 , NROOT
      RT = EIGV(L)
      CALL MULT(TT,A,R(1,L),MAXA,NN,NWK)
      VNORM = ZERO
      DO 590 I = 1 , NN
  590 VNORM = VNORM + TT(I) * TT(I)
      CALL MULT(W,B,R(1,L),MAXA,NN,NWM)
      WNORM = ZERO
      DO 600 I = 1 , NN
      TT(I) = TT(I) - RT * W(I)
  600 WNORM = WNORM + TT(I) * TT(I)
      VNORM = SQRT(VNORM)
      WNORM = SQRT(WNORM)
      D(L) = WNORM / VNORM
  580 CONTINUE
      IF (IFPR .LE. 0) GO TO 585
      WRITE(IOUT,1115)
      WRITE(IOUT,1006) (D(I),I=1,NROOT)
  585 CONTINUE
C
C     APPLY STURM SEQUENCE CHECK
C
      DO 587 LI = 1 , NC
  587 D(LI) = MAXA(LI)
      CALL SCHECK(EIGV,RTOLV,BUP,BLO,BUPC,MAXA,NC,NEI,RTOL,SHIFT,
     *            IFPR,IOUT)
C
      WRITE(IOUT,1120) SHIFT + ALPHA
C
      REWIND NSTIF
      READ (NSTIF) (A(I),I=1,NWK)
      IF (NWM .GT. NN) GO TO 645
      DO 640 I = 1 , NN
      II = MAXA(I)
  640 A(II) = A(II) - B(I) * SHIFT
      GO TO 660
  645 DO 650 I = 1 , NWK
  650 A(I) = A(I) - B(I) * SHIFT
C
C     FACTORIZE SHIFTED MATRIX
C
  660 ISH = 1
      DO 687 LI = 1 , NC
  687 MAXA(LI) = D(LI)
      CALL DECOMP(A,MAXA,NN,ISH,IFPR,IOUT)
C
C     COUNT NUMBER OF NEGATIVE DIAGONAL ELEMENTS
C
      NSCH = 0
      DO 664 I = 1 , NN
      II = MAXA(I)
      IF (A(II) .LT. ZERO) NSCH = NSCH + 1
  664 CONTINUE
      IF (NSCH .EQ. NEI) GO TO 670
      NMIS = NSCH - NEI
      WRITE(IOUT,1130) NMIS
      GO TO 700
  670 WRITE(IOUT,1140) NSCH
  700 RETURN
 1002 FORMAT(1H ,8F9.0)
 1005 FORMAT(1H ,7E11.4)
 1006 FORMAT(1H ,7E11.4)
 1007 FORMAT(//63H STOP, NC IS LARGER THAN THE NUMBER OF MASS DEGREES OF
     1 FREEDOM )
 1008 FORMAT(/,' DEGREES OF FREEDOM EXCITED BY UNIT STARTING ITERA'
     1,'TION VECTORS')
 1010 FORMAT(1H ,32HI T E R A T I O N   N U M B E R ,I4)
 1020 FORMAT(28H PROJECTION OF A (MATRIX AR) )
 1030 FORMAT(28H PROJECTION OF B (MATRIX BR) )
 1035 FORMAT(30H EIGENVALUES OF AR-LAMBDA*BR  )
 1040 FORMAT(40H AR AND BR AFTER JACOBI DIAGONALIZATION  )
 1050 FORMAT(43H RELATIVE TOLERANCE REACHED ON EIGENVALUES  )
 1060 FORMAT(30H CONVERGENCE REACHED FOR RTOL  ,E10.4)
 1070 FORMAT(1H ,51H*** NO CONVERGENCE IN MAXIMUM NUMBER OF ITERATIONS
     1            ,9HPERMITTED/35H WE ACCEPT CURRENT ITERATION VALUES/
     2           42H THE STURM SEQUENCE CHECK IS NOT PERFORMED)
 1100 FORMAT(/'    THE CALCULATED EIGENVALUES ARE ',I6)
 1115 FORMAT(/1X,36HPRINT ERROR NORMS ON TNE EIGENVALUES  )
 1110 FORMAT(/, 32H THE CALCULATED EIGENVECTORS ARE  /)
 1120 FORMAT(/23H CHECK APPLIED AT SHIFT   ,E14.7)
 1130 FORMAT(/ 10H THERE ARE ,I4,21H EIGENVALUES MISSING )
 1140 FORMAT( 20H WE FOUND THE LOWEST ,I4,12H EIGENVALUES )
      END
C
      SUBROUTINE MULT(TT,B,RR,MAXA,NN,NWM)
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
C                                                                     .
C     P R O G R A M                                                   .
C                    TO EVALUATE PRODUCT OF B TIMES RR AND STORE      .
C                    RESULT IN TT                                     .
C                                                                     .
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION TT(1),B(1),RR(1),MAXA(1)
      DATA ZERO / 0.D0 /
      IF (NWM .GT. NN) GO TO 20
      DO 10 I = 1 , NN
   10 TT(I) = B(I) * RR(I)
      RETURN
   20 DO 40 I = 1 , NN
   40 TT(I) = ZERO
      DO 100 I  =  1 , NN
      KL = MAXA(I)
      KU = MAXA(I+1)-1
      II = I + 1
      CC = RR(I)
      DO 100 KK = KL , KU
      II = II - 1
  100 TT(II) = TT(II) + B(KK) * CC
      IF (NN .EQ. 1) RETURN
      DO 200 I = 2 , NN
      KL = MAXA(I) + 1
      KU = MAXA(I+1)-1
      IF (KU - KL) 200,210,210
  210 II = I
      AA = ZERO
      DO 220 KK = KL , KU
      II = II - 1
  220 AA = AA + B(KK) * RR(II)
      TT(I) = TT(I) + AA
  200 CONTINUE
      RETURN
      END
C
      SUBROUTINE JACOBI(A,B,X,EIGV,D,N,NWA,RTOL,NSMAX,IFPR,IOUT)
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
C .                                                                   .
C .   P R O G R A M                                                   .
C .                  TO SOLVE THE GENERALIZED EIGENPROBLEM USING      .
C .                  THE GENERALIZED JACOBI ITERATION                 .
C .                                                                   .
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(NWA),B(NWA),X(N,N),EIGV(N),D(N)
      DATA ZERO / 0.D0 /, ONE / 1.D0 /, TWO / 2.D0 /, FOUR / 4.D0 /
      SQRT(Z) = DSQRT(Z)
      ABS(Z) = DABS(Z)
C
C      INITIALIZE EIGENVALUE AND EIGENVECTOR MATRICES
C
      N1 = N +1
      II = 1
      DO 10 I = 1 , N
      IF (A(II) .GT. ZERO .AND. B(II) .GT. ZERO) GOTO 4
      WRITE(IOUT,2020) II,A(II),B(II)
      STOP
    4 D(I) = A(II) / B(II)
      EIGV(I) = D(I)
   10 II = II + N1 - I
      DO 30 I = 1 , N
      DO 20 J = 1 , N
   20 X(I,J) = ZERO
   30 X(I,I) = ONE
      IF (N .EQ. 1) RETURN
C
C     INITIALIZE SWEEP COUNTER AND BEGIN ITERATION
C
      NSWEEP = 0
      NR = N - 1
   40 NSWEEP = NSWEEP +1
      IF (IFPR .EQ. 1) WRITE(IOUT,2000) NSWEEP
C
C     CHECK IF PRESENT OFF -DIAGONAL ELEMENT IS LARGE ENOUGH TO REQUIRE
C     ZEROING
C
      EPS = (1.D-2 ** NSWEEP)
      DO 210 J = 1 , NR
      JP1 = J + 1
      JM1 = J - 1
      LJK = JM1 * N - JM1 * J / 2
      JJ = LJK +J
      DO 210 K = JP1 , N
      KP1 = K + 1
      KM1 = K - 1
      JK = LJK + K
      KK = KM1 * N - KM1 * K / 2 + K
      XPROF1 = ABS(A(JK)) / SQRT(ABS(A(JJ) * A(KK)))
      XPROF2 = ABS(B(JK)) / SQRT(ABS(B(JJ) * B(KK)))
      IF (XPROF1 .LT. EPS .AND. XPROF2 .LT. EPS) GO TO 210
C
C     IF ZEROING IS REQUIRED,CALCULATE THE ROTATION MATRIX ELEMENTS CA
C     AND CG
C
      AKK = A(KK) * B(JK) - B(KK) * A(JK)
      AJJ = A(JJ) * B(JK) - B(JJ) * A(JK)
      AB  = A(JJ) * B(KK) - A(KK) * B(JJ)
      CHECK = (AB * AB + FOUR * AKK * AJJ) / FOUR
      IF (CHECK) 50,60,60
   50 WRITE(IOUT,2020)
      STOP
   60 SQCH = SQRT(CHECK)
      D1 = AB / TWO + SQCH
      D2 = AB / TWO - SQCH
      DEN = D1
      IF (ABS(D2) .GT. ABS(D1)) DEN = D2
      IF (DEN) 80,70,80
   70 CA = ZERO
      CG =  -A(JK) / A(KK)
      GO TO 90
   80 CA = AKK / DEN
      CG =  -AJJ / DEN
C
C     PERFORM THE GENERALIZED ROTATION TO ZERO OF THE PRESENT OFF
C     -DIAGONAL ELEMENT
C
   90 IF (N - 2) 100,190,100
  100 IF (JM1 - 1) 130,110,110
  110 DO 120 I = 1 , JM1
      IM1 = I - 1
      IJ = IM1 * N - IM1 * I / 2 + J
      IK = IM1 * N - IM1 * I / 2 + K
      AJ = A(IJ)
      BJ = B(IJ)
      AK = A(IK)
      BK = B(IK)
      A(IJ) = AJ + CG * AK
      B(IJ) = BJ + CG * BK
      A(IK) = AK + CA * AJ
  120 B(IK) = BK + CA * BJ
  130 IF (KP1 - N) 140,140,160
  140 LJI = JM1 * N - JM1 * J / 2
      LKI = KM1 * N - KM1 * K / 2
      DO 150 I = KP1 , N
      JI = LJI + I
      KI = LKI + I
      AJ = A(JI)
      BJ = B(JI)
      AK = A(KI)
      BK = B(KI)
      A(JI) = AJ + CG * AK
      B(JI) = BJ + CG * BK
      A(KI) = AK + CA * AJ
  150 B(KI) = BK + CA * BJ
  160 IF (JP1 - KM1) 170,170,190
  170 LJI = JM1 * N - JM1 * J / 2
      DO 180 I = JP1 , KM1
      JI = LJI + I
      IM1 = I - 1
      IK = IM1 * N - IM1 * I / 2 + K
      AJ = A(JI)
      BJ = B(JI)
      AK = A(IK)
      BK = B(IK)
      A(JI) = AJ + CG * AK
      B(JI) = BJ + CG * BK
      A(IK) = AK + CA * AJ
  180 B(IK) = BK + CA * BJ
  190 AK = A(KK)
      BK = B(KK)
      A(KK) = AK + TWO * CA * A(JK) + CA * CA * A(JJ)
      B(KK) = BK + TWO * CA * B(JK) + CA * CA * B(JJ)
      A(JJ) = A(JJ) + TWO * CG * A(JK) + CG * CG * AK
      B(JJ) = B(JJ) + TWO * CG * B(JK) + CG * CG * BK
      A(JK) = ZERO
      B(JK) = ZERO
C
C     UPDATE THE EIGENVECTOR MATRIX AFTER EACH ROTATION
C
      DO 200 I = 1 , N
      XJ = X(I,J)
      XK = X(I,K)
      X(I,J) = XJ + CG * XK
  200 X(I,K) = XK + CA * XJ
  210 CONTINUE
C
C     UPDATE THE EIGENVALUES AFTER EACH SWEEP
C
      II = 1
      DO 220 I = 1 , N
      IF (A(II) .GT. ZERO .AND. B(II) .GT. ZERO) GOTO 215
      WRITE(IOUT,2020) II,A(II),B(II)
      STOP
  215 EIGV(I) = A(II) / B(II)
  220 II = II  +  N1  - I
      IF (IFPR .LE. 0) GO TO 230
      WRITE(IOUT,2030)
      WRITE(IOUT,2010) (EIGV(I),I=1,N)
C
C     CHECK FOR CONVERGENCE
C
  230 DO 240 I = 1 , N
      TOL = RTOL * D(I)
      DIF = ABS(EIGV(I) - D(I))
      IF (DIF .GT. TOL) GO TO 280
  240 CONTINUE
C
C     CHECK ALL OFF -DIAGONAL ELEMENTS TO SEE IF ANOTHER SWEEP IS
C     REQUIRED
C
      EPS = RTOL
      DO 250 J = 1 , NR
      JM1 = J - 1
      JP1 = J + 1
      LJK = JM1 * N - JM1 * J / 2
      JJ = LJK + J
      DO 250 K = JP1 , N
      KM1 = K - 1
      JK = LJK + K
      KK = KM1 * N - KM1 * K / 2 + K
      XPROF3 = ABS(A(JK)) / SQRT(ABS(A(JJ) * A(KK)))
      XPROF4 = ABS(B(JK)) / SQRT(ABS(B(JJ) * B(KK)))
      IF (XPROF3 .LT. EPS .AND. XPROF4 .LT. EPS) GO TO 250
      GO TO 280
  250 CONTINUE
C
C     FILL OUT BOTTOM TRIANGLE OF RESULTANT MATRICES AND SCAN SCALE
C     EIGENVECTORS
C
  255 II = 1
      DO 275 I = 1 , N
      BB = SQRT(B(II))
      DO 270 K = 1 , N
  270 X(K,I) = X(K,I) / BB
  275 II = II + N1 - I
      RETURN
C
C     UPDATE D MATRIX AND START NEW SWEEP, IF ALLOWED
C
  280 DO 290 I = 1 , N
  290 D(I) = EIGV(I)
      IF (NSWEEP .LT. NSMAX) GO TO 40
      GO TO 255
 2000 FORMAT(27H SWEEP NUMBER IN *JACOBI* = ,I6)
 2010 FORMAT(1H ,6E20.12)
 2020 FORMAT(25H *** ERROR SOLUTION STOP  /
     1       31H MATRICES NOT POSITIVE DEFINITE/
     2 6H II = ,I6,3X,8HA(II) = ,E20.12,3X,8HB(II) = ,E20.12)
 2030 FORMAT(36H CURRENT EIGENVALUES IN *JACOBI* ARE,/)
      END
C
      SUBROUTINE REDBAK(A,V,MAXA,NN)
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
C .                                                                   .
C .   P R O G R A M                                                   .
C .                  TO REDUCE AND BACK-SUBSTITUTE ITERATION VECTORS  .
C .                                                                   .
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(1),V(1),MAXA(1)
      DATA ZERO / 0.D0 /
      DO 400 N = 1 , NN
      KL = MAXA(N) + 1
      KU = MAXA(N+1) - 1
      IF (KU - KL) 400,410,410
  410 K = N
      C = ZERO
      DO 420 KK = KL , KU
      K = K - 1
  420 C = C + A(KK) * V(K)
      V(N) = V(N) - C
  400 CONTINUE
      DO 480 N = 1 , NN
      K = MAXA(N)
  480 V(N) = V(N) / A(K)
      IF (NN .EQ. 1) RETURN
      N = NN
      DO 500 L = 2 , NN
      KL = MAXA(N) + 1
      KU = MAXA(N+1) - 1
      IF (KU - KL) 500,510,510
  510 K = N
      DO 520 KK = KL , KU
      K = K - 1
  520 V(K) = V(K) - A(KK) * V(N)
  500 N = N - 1
      RETURN
      END
C
      SUBROUTINE SCHECK(EIGV,RTOLV,BUP,BLO,BUPC,NEIV,NC,NEI,RTOL,SHIFT,
     1                  IFPR,IOUT)
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
C .                                                                   .
C .   P R O G R A M                                                   .
C .                  TO EVALUATE SHIFT FOR STURM SEQUENCE CHECK       .
C .                                                                   .
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION EIGV(NC),RTOLV(NC),BUP(NC),BLO(NC),BUPC(NC),NEIV(NC)
      DATA ONE / 1.D0 /
      FTOL = 0.01
      DO 100 I = 1 , NC
      BUP(I) = EIGV(I) * (ONE + FTOL)
  100 BLO(I) = EIGV(I) * (ONE - FTOL)
      NROOT  = 0
      DO 120 I = 1 , NC
  120 IF (RTOLV(I) .LT. RTOL) NROOT = NROOT + 1
      IF (NROOT .GE. 1) GO TO 200
      WRITE(IOUT,1010)
      STOP
C
C      FIND UPPER BOUNDS ON EIGENVALUE CLUSTERS
C
  200 DO 240 I = 1 , NROOT
  240 NEIV(I) = 1
      IF (NROOT .NE. 1) GO TO 260
      BUPC(1) = BUP(1)
      LM      = 1
      L       = 1
      I       = 2
      GO TO 295
  260 L       = 1
      I       = 2
  270 IF (BUP(I-1) .LE. BLO(I)) GO TO 280
      NEIV(L) = NEIV(L) + 1
      I = I + 1
      IF (I .LE. NROOT) GO TO 270
  280 BUPC(L) = BUP(I-1)
      IF (I .GT. NROOT) GO TO 290
      L = L + 1
      I = I + 1
      IF (I .LE. NROOT) GO TO 270
      BUPC(L) = BUP(I-1)
  290 LM = L
      IF (NROOT .EQ. NC) GO TO 300
  295 IF (BUP(I-1) .LE. BLO(I)) GO TO 300
      IF (RTOLV(I) .GT. RTOL) GO TO 300
      BUPC(L) = BUP(I)
      NEIV(L) = NEIV(L) + 1
      NROOT   = NROOT + 1
      IF (NROOT .EQ. NC) GO TO 300
      I = I + 1
      GO TO 295
C
C      FIND SHIFT
C
  300 IF (IFPR .LE. 0) GO TO 305
      WRITE(IOUT,1020)
      WRITE(IOUT,1005) (BUPC(I), I=1,LM)
      WRITE(IOUT,1030)
      WRITE(IOUT,1006) (NEIV(I), I=1,LM)
  305 LL = LM - 1
      IF (LM .EQ. 1) GO TO 310
  330 DO 320 I = 1 , LL
  320 NEIV(L) = NEIV(L) + NEIV(I)
      L = L - 1
      LL = LL - 1
      IF (L .NE. 1) GO TO 330
  310 IF (IFPR .LE. 0) GO TO 315
      WRITE(IOUT,1040)
      WRITE(IOUT,1006) (NEIV(I), I=1,LM)
  315 L = 0
      DO 340 I = 1 , LM
      L = L + 1
      IF (NEIV(I) .GE. NROOT) GO TO 350
  340 CONTINUE
  350 SHIFT = BUPC(L)
      NEI   = NEIV(L)
      RETURN
 1005 FORMAT (1H ,6E20.12)
 1006 FORMAT (1H ,6I20)
 1010 FORMAT (37H ***ERROR  SOLUTION STOP IN *SCHECK*, / 12X,
     1        21HNO EIGENVALUES FOUND., / 1X)
 1020 FORMAT (///,37H UPPER BOUNDS ON EIGENVALUE CLUSTERS  )
 1030 FORMAT (34H NO OF EIGENVALUES IN EACH CLUSTER  )
 1040 FORMAT (42H NO OF EIGENVALUES LESS THAN UPPER BOUNDS  )
      END
C
      SUBROUTINE DECOMP(A,MAXA,NN,ISH,IFPR,IOUT)
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
C .                                                                   .
C .   P R O G R A M                                                   .
C .                  TO CALCULATE (L)*(D)*(L)(T) FACTORIZATION OF     .
C .                  STIFFNESS MATRIX                                 .
C .                                                                   .
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(1),MAXA(1)
      DATA ZERO / 0.D0 /
      ABS(X) = DABS(X)
      IF (NN .EQ. 1) RETURN
      NLOW = 0
      DO 200 N = 1 , NN
      KN = MAXA(N)
      KL = KN + 1
      KU = MAXA(N+1) - 1
      KH = KU - KL
      IF (KH) 304,240,210
  210 K = N - KH
      IC = 0
      KLT = KU
      DO 260 J = 1 , KH
      IC = IC + 1
      KLT = KLT - 1
      KI = MAXA(K)
      ND = MAXA(K+1) - KI - 1
      IF (ND) 260,260,270
  270 KK = MIN0(IC,ND)
      C = ZERO
      DO 280 L = 1 , KK
  280 C = C + A(KI+L) * A(KLT+L)
      A(KLT) = A(KLT) - C
  260 K = K + 1
  240 K = N
      B = ZERO
      DO 300 KK = KL , KU
      K = K - 1
      KI = MAXA(K)
      C = A(KK) / A(KI)
      IF (ABS(C) .LT. 1.D16) GO TO 290
      WRITE(IOUT,2010) N,C
      STOP
  290 B = B + C * A(KK)
  300 A(KK) = C
      A(KN) = A(KN) - B
  304 IF (A(KN)) 310,310,200
  310 NLOW = NLOW + 1
      IF (ISH .EQ. 0) GO TO 320
      IF (A(KN) .EQ. 0) A(KN)=-1.D-16
      GO TO 200
  320 WRITE(IOUT,2000) N,A(KN)
      STOP
  200 CONTINUE
      IF (IFPR .LT. 0) GO TO 205
      WRITE(IOUT,2020) NLOW
  205 CONTINUE
      RETURN
 2000 FORMAT(//48H STOP - STIFFNESS MATRIX NOT POSITIVE DEFINITE  ,//
     1         32H NONPOSITIVE PIVOT FOR EQUATION  ,I6,//
     2         10H PIVOT =  ,E20.12)
 2010 FORMAT (//47H STOP - STURM SEQUENSE CHECK FAILED BECAUSE OF    ,/
     18X,35HMULTIPLIER GROWTH FOR COLUMN NUMBER,I7,//
     212H MULTIPLIER=,E20.8)
 2020 FORMAT(1X,'THERE ARE ',I4,' ROOTS LOWER THEN SHIFT')
      END
C
      SUBROUTINE DECOMC(ZA,MAXA,NN,ISH,IFPR,IOUT)
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
C .                                                                   .
C .   P R O G R A M                                                   .
C .         TO CALCULATE (L)*(D)*(L)(T) FACTORIZATION OF              .
C .         STIFFNESS MATRIX                                          .
C .                                                                   .
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
      IMPLICIT REAL*8 (A-H,O-Y)
      IMPLICIT COMPLEX*16 (Z)
      DIMENSION ZA(1),MAXA(1)
C
      IF (NN .EQ. 1) RETURN
      NLOW = 0
      DO 200 N = 1 , NN
        KN = MAXA(N)
        KL = KN+1
        KU = MAXA(N+1) - 1
        KH = KU - KL
        IF (KH) 200,240,210
  210   K = N - KH
        IC = 0
        KLT = KU
        DO 260 J = 1 , KH
          IC = IC + 1
          KLT = KLT - 1
          KI = MAXA(K)
          ND = MAXA(K+1) - KI - 1
          IF (ND) 260,260,270
  270     KK = MIN0(IC,ND)
          ZC = DCMPLX(0.D0,0.D0)
          DO 280 L = 1 , KK
  280     ZC = ZC + ZA(KI+L) * ZA(KLT+L)
          ZA(KLT) = ZA(KLT) - ZC
  260   K = K + 1
  240   K = N
        ZB = DCMPLX(0.D0,0.D0)
        DO 300 KK = KL , KU
          K = K - 1
          KI = MAXA(K)
          ZC = ZA(KK) / ZA(KI)
          IF (CDABS(ZC) .LT. 1.D16) GO TO 290
          WRITE (IOUT,2010) N,ZC
          STOP
  290     ZB = ZB + ZC * ZA(KK)
  300   ZA(KK) = ZC
        ZA(KN) = ZA(KN) - ZB
  200 CONTINUE
      RETURN
 2010 FORMAT (//47H STOP - STURM SEQUENSE CHECK FAILED BECAUSE OF    ,/
     18X,35HMULTIPLIER GROWTH FOR COLUMN NUMBER,I7,//
     212H MULTIPLIER=,2E20.8)
      END
C
      SUBROUTINE REDBAC(ZA,ZV,MAXA,NN)
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
C .                                                                 .
C .   P R O G R A M                                                 .
C .        TO REDUCE AND BACK-SUBSTITUTE ITERATION VECTORS          .
C .                                                                 .
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
      IMPLICIT REAL*8 (A-H,O-Y)
      IMPLICIT COMPLEX*16 (Z)
      DIMENSION ZA(1),ZV(1),MAXA(1)
      DO 400 N = 1 , NN
        KL = MAXA(N) + 1
        KU = MAXA(N+1) - 1
        IF (KU - KL) 400,410,410
  410   K = N
        ZC = DCMPLX(0.D0,0.D0)
        DO 420 KK = KL , KU
          K = K - 1
  420   ZC = ZC + ZA(KK) * ZV(K)
        ZV(N) = ZV(N) - ZC
  400 CONTINUE
      DO 480 N = 1 , NN
        K = MAXA(N)
  480 ZV(N) = ZV(N) / ZA(K)
      IF (NN .EQ. 1) RETURN
      N = NN
      DO 500 L = 2 , NN
        KL = MAXA(N) + 1
        KU = MAXA(N+1) - 1
        IF (KU - KL) 500,510,510
  510   K = N
        DO 520 KK = KL , KU
          K = K - 1
  520   ZV(K) = ZV(K) - ZA(KK) * ZV(N)
  500 N = N - 1
      RETURN
      END
C
C     USER-SUPPLIED SUBROUTINES
C
      SUBROUTINE ASYMEV(ZMAX,NDIM,MDIM,SHIFT,DLAMBDA,IOUT)
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
C .                                                                   .
C .   P R O G R A M                                                   .
C .                  TO CALCULATE THE INITIAL VALUE DLAMBDA FOR       .
C .                  THE HOMOGENEOUS THIRD TYPE BOUNDARY CONDITION    .
C .                  AT ZMAX                                          .
C .                                                                   .
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
      IMPLICIT REAL*8 (A-H,O-Z)
      RETURN
      END
C
      SUBROUTINE ASYMSL(ZMIN,ZMAX,NDIM,NOPEN,QR,SHIFT,THRSHL,
     1                  PREGL,DREGL,PREGR,PIRRR,DREGR,DIRRR,IOUT)
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
C .                                                                   .
C .   P R O G R A M                                                   .
C .                  TO CALCULATE THE REGULAR, IRREGULAR              .
C .                  ASYMPTOTIC MATRIX SOLUTIONS PREGR, PIRRR         .
C .                  AND THEIR DERIVATIVES DREGR, DIRRR AT ZMAX,      .
C .                  THE REGULAR MATRIX SOLOTION PREGL AND ITS        .
C .                  DERIVATIVE DREGL AT ZMIN                         .
C .                                                                   .
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION  QR(NOPEN),THRSHL(NDIM),FC1(2),FCP1(2),GC1(2),GCP1(2)
      COMPLEX*16 PREGL(NDIM,NDIM),DREGL(NDIM,NDIM),
     1           PREGR(NDIM,NOPEN),PIRRR(NDIM,NOPEN),
     1           DREGR(NDIM,NOPEN),DIRRR(NDIM,NOPEN),ZI
      COMMON /CHARGE/ S1,S2,S3,Q1,Q2,XMIN
      EXTERNAL ZASREG
      CHARGE1 = (Q1 + Q2) / S2
      ZI = (0.D0,1D0)
C
      ACCUR = 1D-13
      STEP = 100.D0
      MINL = 0
      MAXL = 0
C
      DO I = 1 , NOPEN
C
        SQR = DSQRT(QR(I))
        ETA1 = CHARGE1 / QR(I)
        ARGM = ARGGAMMA(1,ETA1,1D-14)

        RHO1 = - QR(I) * ZMIN
        CALL RCWFNN(RHO1,ETA1,MINL,MAXL,FC1,FCP1,GC1,GCP1,ACCUR,STEP)
        PREGL(I,I) =   (GC1 (1) + ZI * FC1 (1)) / SQR
        DREGL(I,I) = - (GCP1(1) + ZI * FCP1(1)) * SQR
        PREGL(I,I) = PREGL(I,I) / CDEXP(ZI * ARGM)
        DREGL(I,I) = DREGL(I,I) / CDEXP(ZI * ARGM)
C
        RHO1 = QR(I) * ZMAX
        CALL RCWFNN(RHO1,ETA1,MINL,MAXL,FC1,FCP1,GC1,GCP1,ACCUR,STEP)
        PREGR(I,I) = (GC1 (1) - ZI * FC1 (1)) / SQR
        PIRRR(I,I) = (GC1 (1) + ZI * FC1 (1)) / SQR
        DREGR(I,I) = (GCP1(1) - ZI * FCP1(1)) * SQR
        DIRRR(I,I) = (GCP1(1) + ZI * FCP1(1)) * SQR
        PREGR(I,I) = PREGR(I,I) / CDEXP(-ZI * ARGM)
        PIRRR(I,I) = PIRRR(I,I) / CDEXP( ZI * ARGM)
        DREGR(I,I) = DREGR(I,I) / CDEXP(-ZI * ARGM)
        DIRRR(I,I) = DIRRR(I,I) / CDEXP( ZI * ARGM)
C
      END DO
C
      DO I = 1 + NOPEN , NDIM
        QK = DSQRT(THRSHL(I) - SHIFT)
        AA = (QK + CHARGE1) / QK
        BB = 2D0
        XX = - 2 * QK * ZMIN
        CALL CHGU(AA,BB,XX,HU,MD1)
        PREGL(I,I) = HU / DSQRT(QK) * XX
        PREGL(I,I) = PREGL(I,I) !* DEXP( - QK * XS)
C
        CALL CHGU(AA+1,BB+1,XX,HU1,MD2)
        HU1 = - HU1 * AA
        DREGL(I,I) = HU * (2 - XX) * DSQRT(QK)
     1             + HU1 * DSQRT(QK) * 2 * XX
        DREGL(I,I) = - DREGL(I,I) !* DEXP( - QK * XS)
      END DO
C
 180  IDIM = 1
      KMAX = 12
      MAXZ = 1
C
      CALL SLAS(ZMIN,SHIFT,THRSHL,IDIM,NDIM,NOPEN,NDIM,KMAX,
     ,                MAXZ,PREGL,DREGL,.FALSE.,ZASREG)
C
      CALL SLAS(ZMAX,SHIFT,THRSHL,IDIM,NDIM,NOPEN,NOPEN,KMAX,
     ,                MAXZ,PREGR,DREGR,.FALSE.,ZASREG)
C
      CALL SLAS(ZMAX,SHIFT,THRSHL,IDIM,NDIM,NOPEN,NOPEN,KMAX,
     ,                MAXZ,PIRRR,DIRRR,.FALSE.,ZASREG)

   12 FORMAT (6(E12.4))
      RETURN
      END
C
      SUBROUTINE ASYMSR(ZMIN,ZMAX,NDIM,NOPEN,QR,SHIFT,THRSHL,
     1                  PREGR,DREGR,PREGL,PIRRL,DREGL,DIRRL,IOUT)
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
C .                                                                   .
C .   P R O G R A M                                                   .
C .                  TO CALCULATE THE REGULAR, IRREGULAR              .
C .                  ASYMPTOTIC MATRIX SOLUTIONS PREGL, PIRRL         .
C .                  AND THEIR DERIVATIVES DREGL, DIRRL AT ZMIN,      .
C .                  THE REGULAR MATRIX SOLOTION PREGR AND ITS        .
C .                  DERIVATIVE DREGR AT ZMAX                         .
C .                                                                   .
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION  QR(NOPEN),THRSHL(NDIM),FC1(2),FCP1(2),GC1(2),GCP1(2)
      COMPLEX*16 PREGR(NDIM,NDIM),DREGR(NDIM,NDIM),
     1           PREGL(NDIM,NOPEN),PIRRL(NDIM,NOPEN),
     1           DREGL(NDIM,NOPEN),DIRRL(NDIM,NOPEN),ZI
      COMMON /CHARGE/ S1,S2,S3,Q1,Q2,XMIN
      EXTERNAL ZASREG
      CHARGE1 = (Q1 + Q2) / S2
      ZI = (0.D0,1D0)
C
      ACCUR = 1D-13
      STEP = 100.D0
      MINL = 0
      MAXL = 0
C
      DO I = 1 , NOPEN
C
        SQR = DSQRT(QR(I))
        ETA1 = CHARGE1 / QR(I)
        ARGM = ARGGAMMA(1,ETA1,1D-14)
C
        RHO1 =   QR(I) * ZMAX
        CALL RCWFNN(RHO1,ETA1,MINL,MAXL,FC1,FCP1,GC1,GCP1,ACCUR,STEP)
        PREGR(I,I) = (GC1 (1) + ZI * FC1 (1)) / SQR
        DREGR(I,I) = (GCP1(1) + ZI * FCP1(1)) * SQR
        PREGR(I,I) = PREGR(I,I) / CDEXP( ZI * ARGM)
        DREGR(I,I) = DREGR(I,I) / CDEXP( ZI * ARGM)
C
        RHO1 = - QR(I) * ZMIN
        CALL RCWFNN(RHO1,ETA1,MINL,MAXL,FC1,FCP1,GC1,GCP1,ACCUR,STEP)
        PREGL(I,I) =   (GC1 (1) - ZI * FC1 (1)) / SQR
        PIRRL(I,I) =   (GC1 (1) + ZI * FC1 (1)) / SQR
        DREGL(I,I) = - (GCP1(1) - ZI * FCP1(1)) * SQR
        DIRRL(I,I) = - (GCP1(1) + ZI * FCP1(1)) * SQR
        PREGL(I,I) = PREGL(I,I) / CDEXP(-ZI * ARGM)
        PIRRL(I,I) = PIRRL(I,I) / CDEXP( ZI * ARGM)
        DREGL(I,I) = DREGL(I,I) / CDEXP(-ZI * ARGM)
        DIRRL(I,I) = DIRRL(I,I) / CDEXP( ZI * ARGM)
C
      END DO
C
      DO I = 1 + NOPEN, NDIM
C
        QK = DSQRT(THRSHL(I) - SHIFT)
        AA = (QK + CHARGE1) / QK
        BB = 2D0
        XX = 2 * QK * ZMAX
        CALL CHGU(AA,BB,XX,HU,MD1)
        PREGR(I,I) = HU /  DSQRT(QK) * XX !* DEXP( - QK * ZMAX)
C
        CALL CHGU(AA+1,BB+1,XX,HU1,MD2)
        HU1 = - HU1 * AA
        DREGR(I,I) = HU * (2 - XX) * DSQRT(QK)
     1             + HU1 * DSQRT(QK) * 2 * XX
        DREGR(I,I) = DREGR(I,I) !* DEXP( - QK * ZMAX)
C
      END DO

 180  IDIM = 1
      KMAX = 12
      MAXZ = 1
C
      CALL SLAS(ZMAX,SHIFT,THRSHL,IDIM,NDIM,NOPEN,NDIM,KMAX,
     ,                MAXZ,PREGR,DREGR,.FALSE.,ZASREG)
C
      CALL SLAS(ZMIN,SHIFT,THRSHL,IDIM,NDIM,NOPEN,NOPEN,KMAX,
     ,                MAXZ,PREGL,DREGL,.FALSE.,ZASREG)
C
      CALL SLAS(ZMIN,SHIFT,THRSHL,IDIM,NDIM,NOPEN,NOPEN,KMAX,
     ,                MAXZ,PIRRL,DIRRL,.FALSE.,ZASREG)

   12 FORMAT (6(E12.4))
      RETURN
      END
C
      SUBROUTINE POTCAL(RHO,VV,QQ,MDIM,IOUT)
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
C .                                                                   .
C .   P R O G R A M                                                   .
C .                  TO CALCULATE THE POTENTIAL MATRIX ELEMENTS       .
C .                  VV AND QQ OF DIMENSION MDIM X MDIM IN POINT      .
C .                  RHO                                              .
C .                                                                   .
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION VV(MDIM,MDIM),QQ(MDIM,MDIM)
C
      RETURN
      END
C
      SUBROUTINE ODPEVP(TITLE,PARAM,HH,QQ,EIGV,NROOT,NPOL,RTOL,NITEM,
     1                  SHIFT,ICHK,IPRINT,IPRSTP,NMESH,RMESH,IBOUND,
     2                  FNOUT,IOUT,FMATR,IOUM,EVWFN,IOUF,TOT,ITOT,MTOT,
     3                  MITOT)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                                                                      C
C              #####   ######   ######   #######  #     #  ######      C
C             #     #  #     #  #     #  #        #     #  #     #     C
C             #     #  #     #  #     #  #        #     #  #     #     C
C             #     #  #     #  ######   #####    #     #  ######      C
C             #     #  #     #  #        #         #   #   #           C
C             #     #  #     #  #        #          # #    #           C
C              #####   ######   #        #######     #     #           C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                                                                      C
C                    version  1.0  from  05.01.2009                    C
C                                                                      C
C                                                                      C
C                              written  by                             C
C                                                                      C
C                                                                      C
C               O. Chuluunbaatar, A.A. Gusev, S.I. Vinitsky,           C
C                                                                      C
C                   Joint Institute for Nuclear Research,              C
C                    Dubna, 141980 Moscow region, Russia               C
C                                                                      C
C                           A.G. Abrashkevich                          C
C                                                                      C
C                   IBM Toronto Lab, 8200 Warden Avenue,               C
C                       Markham, ON L6G 1C7, Canada                    C
C                                                                      C
C----------------------------------------------------------------------C
C                                                                      C
C                                                                      C
C  Program ODPEVP calculates eigenvalues, eigenfunctions and their     C
C  first derivatives with respect to the parameter of the parametric   C
C  self-adjoined Sturm-Liouville problem with the parametric third     C
C  type boundary conditions on the finite interval. The program        C
C  calculates potential matrix elements -- integrals of the            C
C  eigenfunctions multiplied by their derivatives with respect         C
C  to the parameter.                                                   C
C                                                                      C
C----------------------------------------------------------------------C
C                                                                      C
C                                                                      C
C                        I N P U T  D A T A                            C
C                        ------------------                            C
C                                                                      C
C TITLE   CHARACTER  title of the run to be printed on the output      C
C                    listing. The title should be no longer than       C
C                    70 characters.                                    C
C PARAM   REAL*8     value of the parameter.                           C
C HH      REAL*8     array HH of dimension NROOT x NROOT containing    C
C                    values of the potential matrix H.                 C
C QQ      REAL*8     array QQ of dimension NROOT x NROOT containing    C
C                    values of the potential matrix Q.                 C
C EIGV    REAL*8     array EIGV of dimension NROOT containing values   C
C                    of the calculated eigenvalues.                    C
C NROOT   INTEGER    number of eigenvalues and eigenvectors required.  C
C NPOL    INTEGER    order of finite-element shape functions           C
C                    (interpolating Lagrange polynomials).             C
C                    Usually set to 6.                                 C
C RTOL    REAL*8     convergence tolerance on eigenvalues (1.D-06 or   C
C                    smaller). This value is not used for the          C
C                    scattering problem.                               C
C NITEM   INTEGER    maximum number of iterations permitted (usually   C
C                    set to 16).                                       C
C SHIFT   REAL*8     contains the lower bound of lowest eigenvalue.    C
C SHIFT   REAL*8     contains the lower bound of lowest eigenvalue.    C
C ICHK    INTEGER    key parameter. If ICHK .ne. 0 the SHIFT is        C
C                    determined automatically by the program with      C
C                    help of the algorithm considered in text.         C
C IPRINT  INTEGER    level of print:                                   C
C                    = 0 -- minimal level of print. The initial data,  C
C                    shortinformation about the numerical scheme       C
C                    parameters, main flags and keys, and eigenvalues  C
C                    calculated are printed out;                       C
C                    = 1 -- eigenfunctions calculated are printed out  C
C                    with step IPRSTP additionally;                    C
C                    = 2 -- information about nodal point distribution C
C                    is printed out;                                   C
C                    = 3 -- global matrices A and B are printed out    C
C                    additionally;                                     C
C                    = 4 -- the highest level of print. The local      C
C                    stiffness and mass matrices together with all     C
C                    current information about the course of the       C
C                    subspace iteration method solution of the         C
C                    generalized eigenvalue problem are printed out.   C
C IPRSTP  INTEGER    step with which eigenfunctions are printed out.   C
C NMESH   INTEGER    dimension of array RMESH. NMESH always should be  C
C                    odd and > = 3.                                    C
C RMESH   REAL*8     array RMESH contains information about            C
C                    subdivision of interval [z_min,z_max] of variable C
C                    z on subintervals. The whole interval             C
C                    [z_min,z_max] is divided as follows:              C
C                    RMESH(1) = z_min, RMESH(NMESH) = z_max, and the   C
C                    values of RMESH(I) set the number of elements     C
C                    for each subinterval [RMESH(I-1), RMESH(I+1)],    C
C                    where I=2, 4, ... , NMESH-1.                      C
C IBOUND  INTEGER    parameter defining the type of boundary           C
C                    conditions set in the boundary points z = z_min   C
C                    and z = z_max:                                    C
C                    = 1 -- the Dirichlet -- Dirichlet boundary        C
C                    conditions;                                       C
C                    = 2 -- the Dirichlet -- Neumann boundary          C
C                    conditions;                                       C
C                    = 3 -- the Neumann -- Dirichlet boundary          C
C                    conditions;                                       C
C                    =  4 -- the Neumann -- Neumann boundary           C
C                    conditions.                                       C
C                    If mu_1 lambda_1\neq0 the value of IBOUND equals  C
C                    3 or 4. mu_2 lambda_2\neq0 the value of IBOUND    C
C                    equals 2 or 4.                                    C
C FNOUT   CHARACTER  name of the output file (up to 55 characters)     C
C                    for printing out the results of the calculation.  C
C                    It is system specific and may include a complete  C
C                    path to the file location.                        C
C IOUT    INTEGER    number of the output logical device for printing  C
C                    out the results of the calculation (usually set   C
C                    to 7).                                            C
C FMATR   CHARACTER  name of the scratch file (up to 55 characters)    C
C                    for storing calculated matrices.                  C
C IOUM    INTEGER    number of the logical device for storing          C
C                    calculated matrices.                              C
C EVWFN   CHARACTER  name of the output file (up to 55 characters) for C
C                    storing the results of the calculation, namely,   C
C                    the eigenvalues and eigenfunctions, their first   C
C                    derivatives with respect to the parameter, and    C
C                    finite-element grid points. It is used only       C
C                    if IOUF > 0.                                      C
C IOUF    INTEGER    number of the logical device for storing data     C
C                    into file EVWFN.                                  C
C TOT     REAL*8     working vector of the DOUBLE PRECISION type.      C
C ITOT    INTEGER    working vector of the INTEGER type.               C
C MTOT    INTEGER    dimension of the DOUBLE PRECISION working array   C
C                    TOT. The last address ILAST of array TOT is       C
C                    calculated and then compared with the given value C
C                    of MTOT. If ILAST > MTOT the message about an     C
C                    error is printed and the execution of the program C
C                    is aborted. In the last case, in order to carry   C
C                    out the required calculation it is necessary to   C
C                    increase the dimension MTOT of array TOT to the   C
C                    quantity ILAST taken from the message.            C
C MITOT   INTEGER    dimension of the INTEGER working array ITOT. The  C
C                    last address ILAST of array ITOT is calculated    C
C                    and then compared with the given value of MITOT.  C
C                    If ILAST > MITOT the message about an error is    C
C                    printed and the execution of the program is       C
C                    aborted. In the last case, in order to carry out  C
C                    the required calculation it is necessary to       C
C                    increase the dimension MITOT of array ITOT to the C
C                    quantity ILAST taken from the message.            C
C                                                                      C
C----------------------------------------------------------------------C
C                                                                      C
C                                                                      C
C                        O U T P U T  D A T A                          C
C                        --------------------                          C
C                                                                      C
C The results of the calculation of eigenvalues and eigenfunctions     C
C are written using unformatted segmented records into file EVWFN,     C
C according to the following operator:                                 C
C       WRITE(IOUF) NN,NROOT,NGRID,(EIGV(I),I=1,NROOT),                C
C     1                            (BUP(I),I=1,NROOT),                 C
C     2                            (XGRID(I),I=1,NGRID),               C
C     3                            ((R(I,J),I=1,NN),J=1,NROOT),        C
C     4                            ((DR(I,J),I=1,NN),J=1,NROOT)        C
C In the above, parameters presented in the WRITE statement have the   C
C following meaning:                                                   C
C NGRID is the number of finite-element grid points.                   C
C NN is the number of nodes of eigenfunctions.                         C
C NROOT is the number of eigenvalues.                                  C
C Arrays EIGV and BUP contain the eigenvalues calculated and their     C
C       first derivative with respect to the parameter.                C
C Array XGRID contains the values of the finite-element                C
C       grid points.                                                   C
C Arrays R and DR contain NROOT eigenfunctions each per NN elements    C
C       and their first derivative with respect to parameter.          C
C                                                                      C
C----------------------------------------------------------------------C
C                                                                      C
C                                                                      C
C                         PUBLISHED PROGRAMS USED                      C
C                         -----------------------                      C
C                                                                      C
C          Program SSPACE to solve the generalized eigenvalue          C
C          problem by the subspace iteration method. Published in:     C
C          K.- J. Bathe, Finite ELement Procedures in Engineering      C
C          Analysis (Prentice-Hall, Englewood Cliffs, NY, 1982)        C
C                                                                      C
C          Program GAULEG to calculate nodes and weights of the        C
C          Gauss-Legendre quadrature. Published in: W.H. Press,        C
C          S.A. Teukolsky, W.T. Vetterling and B.P. Flannery,          C
C          Numerical Recipes: The Art of Scientific Computing          C
C          (Cambridge University Press, Cambridge, 1986)               C
C                                                                      C
C----------------------------------------------------------------------C
C                                                                      C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION TOT(MTOT),ITOT(MITOT),RMESH(NMESH)
      DIMENSION HH(NROOT,NROOT),QQ(NROOT,NROOT),EIGV(NROOT)
      CHARACTER*70 TITLE
      CHARACTER*55 FNOUT,FMATR,EVWFN
      DATA ZERO / 0.D0 /, ONE / 1.D0 /
C
C      *******************************************
C      ***                                     ***
C      ***    I N P U T  D A T A  P H A S E    ***
C      ***                                     ***
C      *******************************************
C
C      THE FOLLOWING FILES ARE USED
C
C          IOUT   =  OUTPUT LOGICAL DEVICE NUMBER FOR
C                    PRINTING OUT RESULTS OF THE CALCULATION
C          IOUM   =  OUTPUT STIFFNESS, MASS AND DERIVATIVE OF
C                    STIFFNESS MATRIX
C          IOUF   =  OUTPUT LOGICAL DEVICE FOR STORING
C                    EIGENFUNCTIONS AND THEIR DERIVATIVES
C
      OPEN (UNIT=IOUM,STATUS='UNKNOWN',FILE=FMATR,FORM='UNFORMATTED')
      OPEN (UNIT=IOUT,STATUS='UNKNOWN',FILE=FNOUT)
      IF (IOUF .GT. 0)
     1OPEN (UNIT=IOUF,STATUS='UNKNOWN',FILE=EVWFN,FORM='UNFORMATTED')

C
C      THE RELATIVE ERROR OF THE CALCULATION
C
      A = 4.D0/3.0D0
   11 B = A - ONE
      C = B + B + B
      EPSY = DABS(C - ONE)
      IF (EPSY .EQ. ZERO) GO TO 11
C
      DO I = 1 , MTOT
        TOT(I) = ZERO
      END DO
      DO I = 1 , MITOT
        ITOT(I) = 0
      END DO
C
      IF (NROOT .LT. 25) THEN
        NC = MIN0(2 * NROOT,NROOT + 8)
      ELSE
        NC = NROOT + 5
      END IF
      NNC  = NC * (NC + 1) / 2
C
      NNODE  = NPOL + 1
      NNODES = NNODE
      NGQ    = NNODE
      NSTF   = NNODES * (NNODES + 1) / 2
C
C      SET GAUSSIAN QUADRATURE NODES AND WEIGHTS
C
      IXG = 1
      IWG = IXG + NGQ
C
      CALL GAULEG(-ONE,ONE,TOT(IXG),TOT(IWG),NGQ,EPSY)
C
C      *****************************************************
C      ***                                               ***
C      ***   N O D A L  G E N E R A T I N G  P H A S E   ***
C      ***                                               ***
C      *****************************************************
C
      IGRID = IWG + NGQ
      NELEM = 0
C
      CALL FEGRID(RMESH,NMESH,TOT(IGRID),NGRID,NELEM,NPOL)
C
      IF (IPRINT .GE. 0) THEN
        WRITE(IOUT,1000) TITLE
        WRITE(IOUT,1010) NROOT,NELEM,NGRID,NPOL,NGQ,NC,
     1                   IBOUND,SHIFT,RTOL,PARAM
        WRITE(IOUT,1020)
        NO    = 0
        DO 20 I = 3 , NMESH , 2
           NO  = NO + 1
           NM  = IDINT(RMESH(I-1))
           XM  = (RMESH(I) - RMESH(I-2)) / NM
           XS  = XM / NPOL
           WRITE(IOUT,1030) NO,NM,RMESH(I-2),XM,XS,RMESH(I)
   20   CONTINUE
      END IF
C
      INODE  = 1
      INODES = INODE   +  NNODE  *  NELEM
C
C      GENERATE AND STORE NODAL DATA
C
      CALL NODGEN(ITOT(INODE),NNODE,ITOT(INODES),NNODES,1,NELEM,
     1            IPRINT,IOUT)
C
      NN    = NGRID
      NNE   = NN
      NNM   = NN + 1
C
      IMAXA = INODES +  NNODES * NELEM
      IMHT  = IMAXA  +  NNM
      INHT  = IMHT   +  NNM
      ILAST = INHT   +  NNM
C
      IF (IPRINT .GE. 1) WRITE(IOUT,1050) ILAST
C
      IF (ILAST .GT. MITOT) THEN
         CALL ERRDIM(ILAST - MITOT,1,IOUT)
         WRITE(IOUT,1050) ILAST
      END IF
C
C      SET THE DIRICHLET AND/OR NEUMANN BOUNDARY CONDITIONS
C
      CALL BOUNDC(ITOT(INODE),ITOT(INODES),ITOT(IMAXA),ITOT(IMHT),
     1            ITOT(INHT),IBOUND,NNODE,NNODES,NELEM,1,NN,NNE,
     2            IPRINT,IOUT)
C
C      CALCULATE ADDRESSES OF DIAGONAL ELEMENTS
C      IN BANDED STIFFNESS AND MASS MATRICES
C
      CALL MAXHT(ITOT(IMAXA),ITOT(IMHT),ITOT(INODES),NNODES,NELEM,
     1           NN,NNM,NWK,NWM,MK,IPRINT,IOUT)
C
      MMK  = NWK / NN
      IF (IPRINT .GE. 0) WRITE(IOUT,1040) NN,NWK,MK,MMK
C
C      **********************************************************
C      ***                                                    ***
C      ***    E L E M E N T  G E N E R A T I N G  P H A S E   ***
C      ***                                                    ***
C      **********************************************************
C
C      CALCULATE AND ASSEMBLE STIFFNESS AND MASS
C      ELEMENT MATRICES INTO THE GLOBAL ONES
C
      IPSI   = IGRID  +  NGRID
      IDPSI  = IPSI   +  NGQ    * NNODE
      IA     = IDPSI  +  NGQ    * NNODE
      IB     = IA     +  NWK
      IESTFA = IB     +  NWK
      IESTFB = IESTFA +  NSTF
      IESTF  = IESTFB +  NSTF
      IEMSS  = IESTF  +  NNODES * NNODES
      IEST1  = IEMSS  +  NNODES * NNODES
      IEMS1  = IEST1  +  NNODE  * NNODE
      IXNODE = IEMS1  +  NNODE  * NNODE
      ILAST  = IXNODE +  NNODE
C
      IF (IPRINT .GE. 1) WRITE(IOUT,1060) ILAST
C
      IF (ILAST .GT. MTOT) THEN
         CALL ERRDIM(ILAST - MTOT,2,IOUT)
         WRITE(IOUT,1060) ILAST
      END IF
C
C      CALCULATE AND ASSEMBLE STIFFNESS MATRIX
C
      CALL ASSMCY(PARAM,ITOT(IMAXA),TOT(IA),TOT(IB),TOT(IESTF),
     1            TOT(IEMSS),TOT(IESTFA),TOT(IESTFB),TOT(IEST1),
     2            TOT(IEMS1),TOT(IGRID),TOT(IXNODE),TOT(IPSI),
     3            TOT(IDPSI),TOT(IXG),TOT(IWG),ITOT(INODE),ITOT(INODES),
     4            NELEM,NNODE,NNODES,NGQ,NN,NNM,NWK,NWM,NGRID,NSTF,
     5            IPRINT,IPRSTP,IOUT,IOUM)
C
C           *****************************************
C           ***                                   ***
C           ***       EIGENVALUE PROBLEM          ***
C           ***                                   ***
C           *****************************************
C
      IB     = IA     +   NWK
      IR     = IB     +   NWK
      IDR    = IR     +   NC     * NN
      IW     = IDR    +   NROOT  * NN
      ITT    = IW     +   NN
      IEI    = ITT    +   NN
      ID     = IEI    +   NC
      IBUP   = ID     +   NC
      IBUPC  = IBUP   +   NC
      IRTOLV = IBUPC  +   NC
      IBLO   = IRTOLV +   NC
      IAR    = IBLO   +   NC
      IBR    = IAR    +   NNC
      IVEC   = IBR    +   NNC
      ILAST  = IVEC   +   NC     * NC
C
      IF (IPRINT .GE. 1) WRITE(IOUT,1060) ILAST
C
      IF (ILAST .GT. MTOT) THEN
         CALL ERRDIM(ILAST - MTOT,3,IOUT)
         WRITE(IOUT,1060) ILAST
      END IF
C
      CALL EVSOLN(ITOT(IMAXA),TOT(IR),TOT(IDR),TOT(IW),TOT(ITT),TOT(IA),
     1            TOT(IB),TOT(IEI),TOT(ID),TOT(IBUP),TOT(IBUPC),
     2            TOT(IRTOLV),TOT(IBLO),TOT(IAR),TOT(IBR),TOT(IVEC),
     3            TOT(IGRID),HH,QQ,EIGV,NGRID,MK,NN,NNM,NWK,NWM,NROOT,
     4            NC,NNC,NITEM,RTOL,SHIFT,IPRINT,IPRSTP,IOUT,IOUM,IOUF,
     5            PARAM,IBOUND,ICHK)
C
      RETURN
 1000 FORMAT(/1X,'PROBLEM: ',A70/1X,8('*')/)
 1010 FORMAT(/15X,'C O N T R O L  I N F O R M A T I O N'/
     *        15X,'------------------------------------'//5X,
     * 'NUMBER OF ENERGY LEVELS REQUIRED. . . . . (NROOT ) = ',I6/5X,
     * 'NUMBER OF FINITE ELEMENTS . . . . . . . . (NELEM ) = ',I6/5X,
     * 'NUMBER OF GRID POINTS . . . . . . . . . . (NGRID ) = ',I6/5X,
     * 'ORDER  OF SHAPE FUNCTIONS . . . . . . . . (NPOL  ) = ',I6/5X,
     * 'ORDER  OF GAUSS-LEGENDRE QUADRATURE . . . (NGQ   ) = ',I6/5X,
     * 'NUMBER OF SUBSPACE ITERATION VECTORS. . . (NC    ) = ',I6/5X,
     * 'BOUNDARY CONDITION CODE . . . . . . . . . (IBOUND) = ',I6/5X,
     * 'SHIFT OF DOUBLE ENERGY SPECTRUM . . . . . (SHIFT ) = ',G14.6/5X,
     * 'CONVERGENCE TOLERANCE . . . . . . . . . . (RTOL  ) = ',G14.6/5X,
     * 'VALUE OF PARAMETER. . . . . . . . . . . . (PARAM ) = ',G14.6)
 1020 FORMAT(/4X,
     * 'SUBDIVISION OF RHO-REGION ON THE FINITE-ELEMENT GROUPS:'/4X,
     * '****************************************************** ',//
     *2X,' NO OF  NUMBER OF  BEGIN OF  LENGTH OF    GRID     END OF  '/
     *2X,' GROUP  ELEMENTS   INTERVAL   ELEMENT     STEP    INTERVAL'/
     *2X,' -----  --------   --------   -------     ----    --------')
 1030 FORMAT(2X,I4,4X,I6,4X,F9.5,1X,F9.5,1X,F9.5,1X,F9.5)
 1040 FORMAT(//15X,'T O T A L  S Y S T E M  D A T A  '/
     *         15X,'-------------------------------  '//5X,
     * 'TOTAL NUMBER OF ALGEBRAIC EQUATIONS. . . . (NN ) =',I9/5X,
     * 'TOTAL NUMBER OF MATRIX ELEMENTS. . . . . . (NWK) =',I9/5X,
     * 'MAXIMUM HALF BANDWIDTH . . . . . . . . . . (MK ) =',I9/5X,
     * 'MEAN    HALF BANDWIDTH . . . . . . . . . . (MMK) =',I9/)
 1050 FORMAT(/5X,'LAST ADDRESS OF ARRAY ITOT USED = ',I10/)
 1060 FORMAT(/5X,'LAST ADDRESS OF ARRAY TOT USED = ',I10/)
      END
C
      SUBROUTINE EVSOLN(MAXA,R,DR,W,TT,A,B,EIG,D,BUP,BUPC,RTOLV,
     1                  BLO,AR,BR,VEC,XGRID,HH,QQ,EIGV,NGRID,MK,NN,
     2                  NNM,NWK,NWM,NROOT,NC,NNC,NITEM,RTOL,SHIFT,
     3                  IPRINT,IPRSTP,IOUT,IOUM,IOUF,PARAM,IBOUND,ICHK)
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
C .                                                                   .
C .   P R O G R A M                                                   .
C .                  TO CALCULATE EIGENSOLUTIONS AND THEIR DERIVATIVES.
C .                  WITH RESPECT TO THE PARAMETER, AND INTEGRALS OF  .
C .                  EIGENFUNCTIONS MULTIPLIED BY THEIR DERIVATIVES,  .
C .                  PRINT OUT THE EIGENSOLUTIONS CALCULATED AND      .
C .                  STORE THE SOLUTIONS AND THEIR DERIVATIVES        .
C .                  OBTAINED INTO THE IOUF FILE, IF NECESSARY        .
C .                                                                   .
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(NWK),B(NWK),XGRID(NGRID),MAXA(NNM),R(NN,NC),W(NN),
     1          AR(NNC),BR(NNC),VEC(NC,NC),RTOLV(NC),BUP(NC),BUPC(NC),
     2          BLO(NC),EIG(NC),EIGV(NROOT),D(NC),TT(NN),
     3          HH(NROOT,NROOT),QQ(NROOT,NROOT),DR(NN,NROOT)
      DATA ZERO / 0.D0 /, ONE / 1.D0 /
C
C
      IF (ICHK .NE. 0) CALL CHCHSH(A,B,MAXA,NWK,NN,NNM,IOUM,IOUT,SHIFT)
C
      REWIND IOUM
      READ(IOUM) (A(I),I=1,NWK)
      READ(IOUM) (B(I),I=1,NWK)
      DO I = 1 , NWK
        A(I) = A(I) - SHIFT * B(I)
      END DO
C
      IFSS = 0
      IFPR = 0
      IRRF = 0
      ISH  = 1
      CALL SSPACE(A,B,MAXA,R,EIG,TT,W,AR,BR,VEC,D,RTOLV,BUP,BLO,BUPC,
     1            NN,NNM,NWK,NWM,NROOT,RTOL,NC,NNC,NITEM,IFSS,IFPR,
     2            IRRF,IOUM,SHIFT,IOUT)
C
      DO 39 J=1 , NROOT
C
        EIGV(J) = EIG(J) + SHIFT
        BLO (J) = EIGV(J)
        I = NN + 1
  294   I = I - 1
        IF (I .GE. 1 .AND. DABS(R(I,J)) .LT. 1E-7) GO TO 294
C
        IF (R(I,J) .LT. ZERO) THEN
C
          DO 50 I = 1 , NN
            R(I,J) = - R(I,J)
   50     CONTINUE
C
        END IF
C
   39 CONTINUE
C
C***************************************************************
C
C     CALCULATION DERIVATIVES OF TERMS WITH RESPECT TO PARAMETER
C
C***************************************************************
C
      IFPR = -1
      REWIND IOUM
      READ(IOUM)
      READ(IOUM)
      READ(IOUM) (A(I),I=1,NWK)
C
      DO 801 J = 1 , NROOT
C
        CALL MULT(TT,A,R(1,J),MAXA,NN,NWK)
C
        EPRIM1 = ZERO
C
        DO I = 1 , NN
          EPRIM1 = EPRIM1 + TT(I) * R(I,J)
        END DO
C
        BUP(J) = EPRIM1
C
  801 CONTINUE
C
C      PRINT THE CALCULATED EIGENVALUES AND
C      THEIR DERIVATIVES WITH RESPECT TO PARAMETER
C
      IF (IPRINT .GE. 0) THEN
        WRITE(IOUT,1010)
        WRITE(IOUT,1070)
        DO I = 1 , NROOT
            WRITE(IOUT,1040) I,EIGV(I),BUP(I)
        END DO
        WRITE(IOUT,1010)
      END IF
C
C***************************************************************
C
C     CALCULATION OF DERIVATIVES OF WAVEFUNCTIONS
C
C     BLO(I)        CONSISTS THE EIGENVALUES
C     BUP(I)        CONSISTS THE DERIVATIVES WITH RESPECT TO PARAMETER
C
C***************************************************************
C
      DO 881 J = 1 , NROOT
C
        REWIND IOUM
        READ(IOUM)
        READ(IOUM) (B(I),I=1,NWK)
        READ(IOUM) (A(I),I=1,NWK)
C
C      TERM 1 + TERM 2
C
        CALL MULT(TT,A,R(1,J),MAXA,NN,NWK)
        CALL MULT(W ,B,R(1,J),MAXA,NN,NWK)
C
        DO I = 1 , NN
          TT(I) = - TT(I) + W(I) * BUP(J)
        END DO
C
        HC = ZERO
        DO 750 I = 1 , NN
C
          IF (HC .GE. DABS(W(I))) GOTO 750
          J0 = I
          HC = DABS(W(I))
C
 750    CONTINUE
C
        REWIND IOUM
        READ(IOUM) (A(I),I=1,NWK)
        READ(IOUM) (B(I),I=1,NWK)
C
        DO I = 1 , NWK
          A(I) = A(I) - BLO(J) * B(I)
        END DO
C
        DO I = 1 , NN
          B(I) = ZERO
        END DO
C
        L = 0
        LMK = MIN0(MK,NNM-J0-1)
C
        DO K = 1 , LMK
          LLJ  = MAXA(J0 + K) + K
          LLJJ = MAXA(J0 + K + 1)
          IF (LLJ .LT. LLJJ) L = L + 1
        END DO
C
        DO LI = 1 , L
          K1 = MAXA(J0 + LI) + LI
          B(J0 + LI) = A(K1)
          A(K1) = ZERO
        END DO
C
        LJ = MAXA(J0)
        A(LJ)  = ONE
        TT(J0) = ZERO
        B(J0)  = ZERO
        LJJ = MAXA(J0 + 1) - 1
        K = LJJ - LJ
C
        DO LI = 1 , K
          B(J0 - LI) = A(LJ + LI)
          A(LJ + LI) = ZERO
        END DO
C
        ISH=1
        CALL DECOMP(A,MAXA,NN,ISH,IFPR,IOUT)
        CALL REDBAK(A,TT,MAXA,NN)
        CALL REDBAK(A,B,MAXA,NN)
C
        REWIND IOUM
        READ(IOUM)
        READ(IOUM) (A(I),I=1,NWK)
        CALL MULT(W,A,R(1,J),MAXA,NN,NWK)
C
        CJ = W(J0)
        SUM1 = ZERO
        SUM2 = ZERO
C
        DO I = 1 , NN
          SUM2 = SUM2 + W(I) * B (I)
          SUM1 = SUM1 + W(I) * TT(I)
        END DO
C
        CONST =   - SUM1 / (- SUM2 + CJ)
C
        DO I = 1 , NN
          TT(I) = TT(I) - CONST * B(I)
        END DO
C
        TT(J0) =   CONST
C
        DO I = 1 , NN
          DR(I,J) =  TT(I)
        END DO
C
 881  CONTINUE
C
C      PRINT THE WAVEFUNCTIONS AND THEIR
C      DERIVATIVES WITH RESPECT TO PARAMETER
C
      IF (IPRINT .GE. 1) THEN
        IF (IBOUND .GE. 3) THEN
          KEY=0
        ELSE
          KEY=1
        END IF
        WRITE(IOUT,1050)
        DO 45 II = 1 , NN , IPRSTP
          IF (NROOT .LE. 5) THEN
             WRITE(IOUT,1020) XGRID(II+KEY),(R(II,JJ),JJ=1,NROOT)
          ELSE
             WRITE(IOUT,1030) XGRID(II+KEY),(R(II,JJ),JJ=1,NROOT)
          END IF
   45   CONTINUE
        WRITE(IOUT,1010)
        WRITE(IOUT,1060)
        DO 46 II = 1 , NN , IPRSTP
          IF (NROOT .LE. 5) THEN
             WRITE(IOUT,1020) XGRID(II+KEY),(DR(II,JJ),JJ=1,NROOT)
          ELSE
             WRITE(IOUT,1030) XGRID(II+KEY),(DR(II,JJ),JJ=1,NROOT)
          END IF
   46   CONTINUE
        WRITE(IOUT,1010)
      END IF
C
      IF(IOUF .NE. 0) THEN
        WRITE(IOUF) NN,NROOT,NGRID,(EIGV(I),I=1,NROOT),
     1                             (BUP(I),I=1,NROOT),
     2                             (XGRID(I),I=1,NGRID),
     3                             ((R(I,J),I=1,NN),J=1,NROOT),
     4                             ((DR(I,J),I=1,NN),J=1,NROOT)
      END IF
C
      REWIND IOUM
      READ(IOUM)
      READ(IOUM) (B(I),I=1,NWK)
C
C                 CALCULATION Q(I,J) AND H(I,J)
C
      DO J = 1 , NROOT
C
        CALL MULT(W,B,DR(1,J),MAXA,NN,NWK)
C
        DO I = 1 , NROOT
C
          HH(I,J) = ZERO
          QQ(I,J) = ZERO
C
          DO L = 1 , NN
C
            HH(I,J) = HH(I,J) + DR(L,I) * W(L)
            QQ(I,J) = QQ(I,J) -  R(L,I) * W(L)
C
          END DO
C
        END DO
C
      END DO
C
      RETURN
 1010 FORMAT(/80('*')/)
 1020 FORMAT(1X,E10.4,1X,9(1X,D10.4)/(11X,1X,9(1X,D10.4)))
 1030 FORMAT(1X,F10.4,1X,6(1X,D14.8)/(11X,1X,6(1X,D14.8)))
 1040 FORMAT(10X,I4,14X,2G25.16)
 1050 FORMAT(//8X,'R',8X,'       E I G E N F U N C T I O N        ',
     *        /8X,'-',8X,'----------------------------------------'/)
 1060 FORMAT(//8X,'R',8X,'       I T S  D E R I V A T I V E        ',
     *        /8X,'-',8X,'----------------------------------------'/)
 1070 FORMAT(3X,' R O O T   N U M B E R ',3X,' E I G E N V A L U E ',
     *       7X,' D E R I V A T I V E  ' /
     *       3X,'-----------------------',3X,'---------------------',
     *       7X,'---------------------')
      END
C
      SUBROUTINE CHCHSH(A,B,MAXA,NWK,NN,NNM,IOUM,IOUT,SHIFT)
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
C .                                                                   .
C .   P R O G R A M                                                   .
C .                  TO CALCULATE THE LOWER BOUND FOR THE LOWEST      .
C .                  EIGENVALUE OF THE GENERALIZED EIGENVALUE PROBLEM .
C .                                                                   .
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(NWK),B(NWK),MAXA(NNM)
      DATA ZERO / 0.D0 /
C
      IFSS = 0
      IFPR = -1
      IRRF = 0
      ISH  = 1
C
      REWIND IOUM
      READ(IOUM) (A(I),I=1,NWK)
      READ(IOUM) (B(I),I=1,NWK)
      DO I = 1 , NWK
        A(I) = A(I) - SHIFT * B(I)
      END DO
C
      CALL DECOMP(A,MAXA,NN,ISH,IFPR,IOUT)
C
      DO I = 1 , NN
        IF (A(MAXA(I)) .LE. ZERO) THEN
          SHIFT = SHIFT - 1D0
          GO TO 234
        END IF
      END DO
C
      GO TO 235
C
  234 REWIND IOUM
      READ(IOUM) (A(I),I=1,NWK)
      READ(IOUM) (B(I),I=1,NWK)
      DO I = 1 , NWK
        A(I) = A(I) - SHIFT * B(I)
      END DO
C
      CALL DECOMP(A,MAXA,NN,ISH,IFPR,IOUT)
C
      DO I = 1 , NN
        IF (A(MAXA(I)) .LE. ZERO) THEN
          SHIFT = SHIFT - 1D0
          GO TO 234
        END IF
      END DO
C
      SHIFT = SHIFT - 0.5D0
      RETURN
C
  235 SHIFT = SHIFT + 1D0
      REWIND IOUM
      READ(IOUM) (A(I),I=1,NWK)
      READ(IOUM) (B(I),I=1,NWK)
      DO I = 1 , NWK
        A(I) = A(I) - SHIFT * B(I)
      END DO
C
      CALL DECOMP(A,MAXA,NN,ISH,IFPR,IOUT)
C
      DO I = 1 , NN
        IF (A(MAXA(I)) .LT. ZERO) THEN
          GO TO 236
        END IF
      END DO
C
      GO TO 235
C
  236 SHIFT = SHIFT - 1.5D0
C
      RETURN
      END
C
      SUBROUTINE ASSMCY(PARAM,MAXA,A,B,ESTF,EMSS,ESTFA,ESTFB,EST1,EMS1,
     1                  XGRID,XNODE,PSI,DPSI,XG,WG,NODE,NODES,NELEM,
     2                  NNODE,NNODES,NGQ,NN,NNM,NWK,NWM,NGRID,NSTF,
     3                  IPRINT,IPRSTP,IOUT,IOUM)
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
C .                                                                   .
C .   P R O G R A M                                                   .
C .                  TO CALCULATE AND ASSEMBLE THE STIFFNESS, MASS    .
C .                  ELEMENT MATRICES, AND DERIVATIVE OF STIFFNESS    .
C .                  ELEMENT MATRIX WITH RESPECT TO PARAMETER         .
C .                  INTO THE GLOBAL STIFFNESS, MASS AND DERIVATIVE   .
C .                  OF STIFFNESS MATRICES                            .
C .                                                                   .
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION MAXA(NNM),A(NWK),B(NWK),ESTF(NNODES,NNODES),
     1          EMSS(NNODES,NNODES),ESTFA(NSTF),ESTFB(NSTF),
     2          EST1(NNODE,NNODE),EMS1(NNODE,NNODE),XGRID(NGRID),
     3          XNODE(NNODE),PSI(NNODE,NGQ),DPSI(NNODE,NGQ),XG(NGQ),
     4          WG(NGQ),NODE(NNODE,NELEM),NODES(NNODES,NELEM)
      DATA ZERO / 0.D0 /
      REWIND IOUM
C
      DO 15 IG = 1 , NGQ
C
          CALL SHAPEF(XG(IG),A,B,XNODE,NNODE)
C
          DO 14 IN = 1 , NNODE
             PSI (IN,IG) = A(IN)
             DPSI(IN,IG) = B(IN)
   14     CONTINUE
C
   15 CONTINUE
C
      IF (IPRINT .GE. 4) THEN
          WRITE(IOUT,1130)
          DO I = 1 , NGQ
             WRITE(IOUT,1140) (PSI(J,I),J=1,NNODE)
          END DO
          WRITE(IOUT,1150)
      END IF
C
C      CALCULATE MASS AND STIFFNESS MATRICES
C
C      INITIALIZE ARRAYS A(NWK), B(NWK)
C
      DO 10 I = 1 , NWK
         A(I) = ZERO
         B(I) = ZERO
   10 CONTINUE
C
      DO 220 NEL = 1 , NELEM
C
         DO 40 II = 1 , NNODES
         DO 40 JJ = 1 , NNODES
            ESTF(II,JJ) = ZERO
            EMSS(II,JJ) = ZERO
   40    CONTINUE
C
         DO 50 LL = 1 , NNODE
            NE           = NODE(LL,NEL)
            XNODE(LL)    = XGRID(NE)
   50    CONTINUE
C
         IF (IPRINT .GE. 4) THEN
              WRITE(IOUT,1110) NEL
              WRITE(IOUT,1120) (I,XNODE(I),I=1,NNODE)
              WRITE(IOUT,1150)
         END IF
C
C      CALCULATE ELEMENT MATRICES FOR ELEMENTS
C      OF MASS AND STIFFNESS MATRICES
C
           CALL EMASST(XNODE,XG,WG,NGQ,NNODE,EMS1,PSI)
C
           CALL ESTIF1(XNODE,XG,WG,NGQ,NNODE,EST1,PSI,DPSI,PARAM,1)
C
            DO 70 NI = 1  , NNODE
            DO 70 NJ = NI , NNODE
C
               NEI   = NI
               NEJ   = NJ
C
               ESTF(NEI,NEJ) = ESTF(NEI,NEJ) + EST1(NI,NJ)
               EMSS(NEI,NEJ) = EMSS(NEI,NEJ) + EMS1(NI,NJ)
C
   70       CONTINUE
C
            IF (IPRINT .GE. 4) THEN
               WRITE(IOUT,1030) NEL
               DO 80 IP = 1 , NNODE
   80          WRITE(IOUT,1040) (EST1(IP,JP),JP=1,NNODE),
     1                          (EMS1(IP,JP),JP=1,NNODE)
            END IF
C
         IF (IPRINT .GE. 4) THEN
            WRITE(IOUT,1050) NEL
            DO 110 IP = 1 , NNODES
  110       WRITE(IOUT,1020) (ESTF(IP,JP),JP=1,NNODES)
            WRITE(IOUT,1060) NEL
            DO 120 IP = 1 , NNODES
  120       WRITE(IOUT,1020) (EMSS(IP,JP),JP=1,NNODES)
         END IF
C
         NL  = 0
         DO 210 IL = 1  , NNODES
         DO 210 JL = IL , NNODES
            NL        = NL + 1
            ESTFA(NL) = ESTF(IL,JL)
            ESTFB(NL) = EMSS(IL,JL)
  210    CONTINUE
C
C      ASSEMBLE ELEMENT MATRICES INTO GLOBAL
C      STIFFNESS AND MASS MATRICES
C
         CALL ADDVEC(A,NWK,MAXA,NNM,ESTFA,NSTF,NODES(1,NEL),NNODES,1)
         CALL ADDVEC(B,NWK,MAXA,NNM,ESTFB,NSTF,NODES(1,NEL),NNODES,1)
C
  220 CONTINUE
C
      CALL BOUNCF(PARAM,DLMMN0,DLMMX0,DLMMN1,DLMMX1)
      A(MAXA(NN)) = A(MAXA(NN)) + DLMMX0
      A(MAXA(1 )) = A(MAXA(1 )) - DLMMN0
C
      WRITE(IOUM) (A(I),I=1,NWK)
      WRITE(IOUM) (B(I),I=1,NWK)
C
      IF (IPRINT .GE. 3) THEN
         WRITE(IOUT,1080) NN,NNM,NWK,NNODE,NNODES,NELEM,NGRID
         WRITE(IOUT,1090) NWK
         WRITE(IOUT,1020) (A(I),I=1,NWK)
         WRITE(IOUT,1100) NWK
         WRITE(IOUT,1020) (B(I),I=1,NWK)
      END IF
C
C      CALCULATE ELEMENT MATRIX FOR
C      ELEMENTS OF DERIVATIVE OF STIFFNESS MATRIX
C
      DO 11 I = 1 , NWK
         A(I) = ZERO
   11 CONTINUE
C
      DO 221 NEL = 1 , NELEM
C
         DO 41 II = 1 , NNODES
         DO 41 JJ = 1 , NNODES
            ESTF(II,JJ) = ZERO
   41    CONTINUE
C
         DO 51 LL = 1 , NNODE
            NE           = NODE(LL,NEL)
            XNODE(LL)    = XGRID(NE)
   51    CONTINUE
C
           CALL ESTIF1(XNODE,XG,WG,NGQ,NNODE,EST1,PSI,DPSI,PARAM,2)
C
            DO 71 NI = 1  , NNODE
            DO 71 NJ = NI , NNODE
C
               NEI   = NI
               NEJ   = NJ
C
               ESTF(NEI,NEJ) = ESTF(NEI,NEJ) + EST1(NI,NJ)
C
   71       CONTINUE
C
         NL  = 0
         DO 211 IL = 1  , NNODES
         DO 211 JL = IL , NNODES
            NL        = NL + 1
            ESTFA(NL) = ESTF(IL,JL)
  211    CONTINUE
C
C      ASSEMBLE ELEMENT MATRICES INTO GLOBAL
C      DERIVATIVE OF STIFFNESS MATRIX
C
         CALL ADDVEC(A,NWK,MAXA,NNM,ESTFA,NSTF,NODES(1,NEL),NNODES,1)
C
  221 CONTINUE
C
      A(MAXA(NN)) = A(MAXA(NN)) + DLMMX1
      A(MAXA(1 )) = A(MAXA(1 )) - DLMMN1
      WRITE(IOUM) (A(I),I=1,NWK)
C
      IF (IPRINT .GE. 3) THEN
         WRITE(IOUT,1160) NWK
         WRITE(IOUT,1020) (A(I),I=1,NWK)
      END IF
C
      RETURN
 1020 FORMAT(6(2X,D10.4))
 1030 FORMAT(/5X,'ELEMENT STIFFNESS AND MASS MATRICES EST1 & ',
     1            'EMS1 (ELEMENT NO ',I3,' ) :'/)
 1040 FORMAT(5(3X,D12.6))
 1050 FORMAT(/5X,
     * 'ELEMENT STIFFNESS MATRIX ESTF (ELEMENT NO ',I3,' ) :'/)
 1060 FORMAT(/5X,
     *      'ELEMENT MASS MATRIX EMSS (ELEMENT NO ',I3,' ) :'/)
 1080 FORMAT(//15X,'DIMENSIONS SET IN ASSMBY ARE : ',//5X,
     1 'NN     = ',I5,5X,'NNM    = ',I5,5X,
     2 'NWK    = ',I5,5X,'NNODE  = ',I5,5X/5X,
     3 'NNODES = ',I5,5X,'NELEM  = ',I5,/)
 1090 FORMAT(//20X,'S T I F F N E S S  M A T R I X  A(',I5,') :'/)
 1100 FORMAT(//20X,'M A S S  M A T R I X  B(',I5,') :'/)
 1160 FORMAT(//20X,'D I R E V A T I V E  M A T R I X  A(',I5,') :'/)
 1110 FORMAT(/10X,'ARRAY XNODE (NEL = ',I3,' )'/)
 1120 FORMAT(5(1X,I2,2X,D10.4))
 1130 FORMAT(/15X,'SHAPE FUNCTIONS PSI(NNODE,NGQ) :'/)
 1140 FORMAT(6(1X,D12.6))
 1150 FORMAT(/)
      END
C
      SUBROUTINE ESTIF1(XNODE,XG,WG,NGQ,NNODE,EST,PSI,DPSI,PARAM,L)
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
C .                                                                   .
C .   P R O G R A M                                                   .
C .                  TO CALCULATE AN ELEMENT STIFFNESS MATRIX         .
C .                  FOR DIAGONAL PART OF POTENTIAL MATRIX            .
C .                                                                   .
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION XNODE(NNODE),EST(NNODE,NNODE),XG(NGQ),WG(NGQ),
     1          PSI(NNODE,NGQ),DPSI(NNODE,NGQ)
      DATA ZERO / 0.D0 /, TWO / 2.D0 /
C
C      INITIALIZE ELEMENT ARRAY
C
      DO 10 I = 1 , NNODE
      DO 10 J = 1 , NNODE
C
         EST(I,J) = ZERO
C
   10 CONTINUE
C
C      FORM JACOBI DETERMINANT
C
      DETJ = (XNODE(NNODE) - XNODE(1)) / TWO
      DETI = (XNODE(NNODE) + XNODE(1)) / TWO
C
C      BEGIN INTEGRATION POINT LOOP
C
      DO 50 IG = 1 , NGQ
C
        RG = DETJ * XG(IG) + DETI
        R1 = F1FUNC(RG)
        R2 = F2FUNC(RG)
        IF (L .EQ. 1) THEN
          POT = POTCCL(PARAM,RG)
        ELSE
          POT = POTCC1(PARAM,RG)
        END IF
C
        DO 40 I = 1 , NNODE
        DO 40 J = I , NNODE
C
          IF (L .EQ. 1) THEN
C
            EST(I,J) = EST(I,J) + (PSI(I,IG) * PSI(J,IG) * POT * R1
     1               + DPSI(I,IG) * DPSI(J,IG) / DETJ / DETJ * R2)
     2               * WG(IG) * DETJ
            EST(J,I) = EST(I,J)
C
          ELSE
C
            EST(I,J) = EST(I,J) + PSI(I,IG) * PSI(J,IG) * POT
     1               * R1 * WG(IG) * DETJ
            EST(J,I) = EST(I,J)
C
          END IF
C
   40   CONTINUE
C
   50 CONTINUE
      RETURN
      END
C
      SUBROUTINE EMASST(XNODE,XG,WG,NGQ,NNODE,EMSS,PSI)
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
C .                                                                   .
C .   P R O G R A M                                                   .
C .                  TO CALCULATE AN ELEMENT MASS MATRIX              .
C .                                                                   .
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION XNODE(NNODE),EMSS(NNODE,NNODE),XG(NGQ),WG(NGQ),
     1          PSI(NNODE,NGQ)
      DATA ZERO / 0.D0 /, TWO / 2.D0 /
C
C      INITIALIZE ELEMENT ARRAY
C
      DO 10 I = 1 , NNODE
      DO 10 J = 1 , NNODE
C
         EMSS(I,J) = ZERO
C
   10 CONTINUE
C
C      FORM JACOBI DETERMINANT
C
      DETJ = (XNODE(NNODE) - XNODE(1)) / TWO
      DETI = (XNODE(NNODE) + XNODE(1)) / TWO
C
C      BEGIN INTEGRATION POINT LOOP
C
      DO 50 IG = 1 , NGQ
C
        RG = DETJ * XG(IG) + DETI
        RR = F1FUNC(RG)
C
        DO 40 I = 1 , NNODE
        DO 40 J = I , NNODE
C
          EMSS(I,J) = EMSS(I,J)
     1              + PSI(I,IG) * PSI(J,IG) * RR * WG(IG) * DETJ
          EMSS(J,I) = EMSS(I,J)
C
   40  CONTINUE
C
   50 CONTINUE
      RETURN
      END
C
C       USER-SUPPLIED PROGRAMS
C
      FUNCTION POTCCL(PARAM,RG)
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
C .                                                               .
C .   P R O G R A M                                               .
C .                  TO CALCULATE THE PARAMETRIC POTENTIAL        .
C .                  FUNCTION AT POINTS RG AND PARAM              .
C .                                                               .
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /CHARGE/ S1,S2,S3,Q1,Q2,XMIN
      X = RG
      Y = PARAM
      XYM = S2 * Y + S1 * X
      XYP = S2 * Y - S3 * X
      POTCCL = X ** 2 + 2 * (COULCUT(XYM) * Q1 + COULCUT(XYP) * Q2)
      RETURN
      END
C
      FUNCTION POTCC1(PARAM,RG)
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
C .                                                               .
C .   P R O G R A M                                               .
C .                  TO CALCULATE FIRST DERIVATIVE OF PARAMETRIC  .
C                    POTENTIAL FUNCTION WITH RESPECT TO PARAMETER .
C .                  AT POINTS RG AND PARAM                       .
C .                                                               .
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /CHARGE/ S1,S2,S3,Q1,Q2,XMIN
      X = RG
      Y = PARAM
      XYM = S2 * Y + S1 * X
      XYP = S2 * Y - S3 * X
      POTCC1 = 2 * S2 * (DCOULCUT(XYM) * Q1 + DCOULCUT(XYP) * Q2)
      RETURN
      END
C
      FUNCTION COULCUT (X)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /CHARGE/ S1,S2,S3,Q1,Q2,XMIN
      SDEG = 8
      SSDG = 1.D0 / SDEG
      XX = DABS(X)
      COULCUT = 1.D0 / (XX ** SDEG + XMIN ** SDEG) ** SSDG
      RETURN
      END
C
      FUNCTION DCOULCUT (X)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /CHARGE/ S1,S2,S3,Q1,Q2,XMIN
      SDEG = 8
      SSDG = 1.D0 / SDEG + 1.D0
      XX = DABS(X)
      DCOULCUT = -1.D0 / (XX ** SDEG + XMIN ** SDEG) ** SSDG
     *         * XX ** SDEG / X
      RETURN
      END
C
      FUNCTION F1FUNC(RG)
      IMPLICIT REAL*8 (A-H,O-Z)
      F1FUNC = 1.D0
      RETURN
      END
C
      FUNCTION F2FUNC(RG)
      IMPLICIT REAL*8 (A-H,O-Z)
      F2FUNC = 1.D0
      RETURN
      END
C
      SUBROUTINE BOUNCF(PARAM,DLMMN0,DLMMX0,DLMMN1,DLMMX1)
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
C .                                                               .
C .   P R O G R A M                                               .
C .                  TO CALCULATE DLMMN0, DLMMX0 AND THEIR        .
C .                  FIRST DERIVATIVES WITH RESPECT TO PARAMETER  .
C .                                                               .
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
      IMPLICIT REAL*8 (A-H,O-Z)
        DLMMN0 = 0.D0
        DLMMX0 = 0.D0
        DLMMN1 = 0.D0
        DLMMX1 = 0.D0
      RETURN
      END
C
      SUBROUTINE SLAS(XS,SHIFT,THRSHL,IDIM,NDIM,NOPEN,NMAX,KMAX,
     1                MAXZ,ZPREGR,ZDREGR,FXSAS,ZAS0)
      IMPLICIT REAL*8 (A-H,O-Y)
      IMPLICIT COMPLEX*16 (Z)
      DIMENSION ZAS(NDIM,MAXZ),ZPREGR(NDIM,NMAX),ZDREGR(NDIM,NMAX)
      DIMENSION ZPHAS(NDIM,NMAX,0:KMAX),ZCHAS(NDIM,NMAX,0:KMAX)
      DIMENSION HAS(NDIM,NDIM,2:12),QAS(NDIM,NDIM,12)
      DIMENSION THRSHL(NDIM)
      LOGICAL   FXSAS
      EXTERNAL ZAS0
C
      KMINH = 2
      KMINQ = 1
      ABSB = 1.D0
      IF (XS .LE. 0.D0) ABSB = -1.D0
      CALL ZAS0(ZAS,MAXZ,SHIFT,THRSHL,NDIM,NOPEN,ABSB)
      CALL VQAS0(HAS,QAS,KMAX,NDIM,ABSB)
C
      DO 801 I0 = 1 , NMAX
C
        AK2 = SHIFT - THRSHL(I0)
        AKT = DSQRT(DABS(AK2))
        DO J = 1 , NDIM
          ZPHAS(J, I0, 0) = 0.D0
          ZCHAS(J, I0, 0) = 0.D0
        END DO
        ZPHAS(I0, I0, 0) = 0.1D1
C
        DO 802 KT = 1 , KMAX
        DO 802 I0TEST = 0 , 1
C
          IF ((I0TEST+KT.EQ.1).OR.(I0TEST+KT.EQ.KMAX+1)) GOTO 802
C
          DO 803 I = 1 , NDIM

            IF  (((I.NE.I0) .AND. (I0TEST.EQ.1))
     .                      .OR. ((I.EQ.I0) .AND. (I0TEST.EQ.0))) THEN
C
              ZQRN = 0.D0
              ZQRD = 0.D0
C
              DO J = 1 , NDIM
C
                IF (I.NE.J) THEN
C
                  DO KDEG = KMINQ , KT
                    ZQRN = ZQRN
     +                   + 2 * AK2 * QAS(I,J,KDEG) * ZCHAS(J,I0,KT-KDEG)
                    ZQRD = ZQRD
     -                   - 2 * QAS(I,J,KDEG) * ZPHAS(J,I0,KT-KDEG)
                  END DO
                  DO KDEG = KMINQ , KT - 1
                    ZQRN = ZQRN
     +                   + (2 * KT - 1 - KDEG - IDIM)
     *                   * QAS(I,J,KDEG) * ZPHAS(J,I0,KT-KDEG-1)
                    ZQRD = ZQRD
     +                   + (2 * KT - 3 - KDEG + IDIM)
     *                   * QAS(I,J,KDEG) * ZCHAS(J,I0,KT-KDEG-1)
                  END DO
                  DO KZDEG = 1 , MAXZ
                    DO KDEG = KMINQ , KT - KZDEG
                      ZQRN = ZQRN
     -                     - 2 * ZAS(I0,KZDEG)
     *                     * QAS(I,J,KDEG) * ZCHAS(J,I0,KT-KDEG-KZDEG)
                    END DO
                  END DO
                  DO KDEG = KMINH , KT
                    ZQRN = ZQRN - HAS(I,J,KDEG) * ZPHAS(J,I0,KT-KDEG)
                    ZQRD = ZQRD - HAS(I,J,KDEG) * ZCHAS(J,I0,KT-KDEG)
                  END DO
C
                END IF
C
              END DO
C
              ZQMN = - ZQRN
              ZQMD = - ZQRD
C
              IF (KT.GT.1)  THEN
                ZQMN = ZQMN
     1               - (KT - 2) * (KT     - IDIM) * ZPHAS(I,I0,KT-2)
                ZQMD = ZQMD
     1               - (KT - 1) * (KT - 3 + IDIM) * ZCHAS(I,I0,KT-2)
              END IF
C
              DO KDEG = KMINH , KT
                ZQMN = ZQMN + HAS(I,I,KDEG) * ZPHAS(I,I0,KT-KDEG)
                ZQMD = ZQMD + HAS(I,I,KDEG) * ZCHAS(I,I0,KT-KDEG)
              END DO
C
              DO KZDEG = 2 , MIN(MAXZ,KT)
                ZQMN = ZQMN - ZAS(I0,KZDEG) * ZPHAS(I,I0,KT-KZDEG)
                ZQMD = ZQMD - ZAS(I0,KZDEG) * ZCHAS(I,I0,KT-KZDEG)
              END DO
C
              DO KZDEG = 1 , MIN(MAXZ,KT-1)
                ZQMN = ZQMN + ZAS(I0,KZDEG) * (2 * KT - 2 - KZDEG)
     *               * ZCHAS(I,I0,KT-KZDEG-1)
              END DO
C
              IF (I .NE. I0) THEN
                ZPHI = -(ZAS(I,1) - ZAS(I0,1)) * ZPHAS(I,I0,KT-1)
     -               + 2 * AK2 * (KT-1) *ZCHAS(I,I0,KT-1) - ZQMN
                ZPHAS(I,I0,KT) = ZPHI / (THRSHL(I) - THRSHL(I0))
                ZCHI = - (2 * KT - 2) * ZPHAS(I,I0,KT-1)
     +               - (ZAS(I,1) - ZAS(I0,1)) * ZCHAS(I,I0,KT-1) - ZQMD
                ZCHAS(I,I0,KT) = ZCHI / (THRSHL(I) - THRSHL(I0))
              ELSE
                ZPHAS(I0,I0,KT-1) = - ZQMD / (KT - 1) / 2
                ZCHAS(I0,I0,KT-1) = ZQMN / (KT - 1) / 2 / AK2
              END IF
C
            END IF
C
  803     CONTINUE
C
  802   CONTINUE
C
  801 CONTINUE
C
      IF (FXSAS) THEN
C
        DO I0 = 1 , NMAX
C
          WRITE(*,990) I0, SHIFT
          WRITE(*,995) 
          DO KTEK = 2 , KMAX - 1
            FMAX = 0.D0
            DO J = 1 , NDIM
C
              FMAX = DMAX1(FMAX,CDABS(ZPHAS(J,I0,KTEK)))
              FMAX = DMAX1(FMAX,CDABS(ZCHAS(J,I0,KTEK)))
C
            END DO
            EPS = 1D-10
            FMAX = (FMAX / EPS) ** (1.D0 / DBLE(KTEK))
            WRITE(*,999) EPS,KTEK,FMAX
          END DO
C
        END DO
C
      ELSE
C
        DO I0 = 1 , NMAX
C
           ZFUNC = ZPREGR(I0,I0)
          ZDFUNC = ZDREGR(I0,I0)
          ZSUM = - (SHIFT - THRSHL(I0))
          XSOR = 1
          DO I = 1 , MAXZ
            XSOR = XSOR * XS
            ZSUM = ZSUM + ZAS(I0,I) / XSOR
          END DO
          ZDDFUNC = ZSUM * ZFUNC - (IDIM - 1) / XS * ZDFUNC
C
          DO J = 1 , NDIM
            ZPREGR(J,I0) = 0D0
            ZDREGR(J,I0) = 0D0
          END DO
C
          DO J = 1 , NDIM
            XSOR = 1
            XSOR1 = XS
            DO KTEK = 0 , KMAX - 1
              ZPREGR(J,I0) =   ZPREGR(J,I0)
     +                     +   ZFUNC * ZPHAS(J,I0,KTEK) / XSOR
     +                     +  ZDFUNC * ZCHAS(J,I0,KTEK) / XSOR
              ZDREGR(J,I0) =  ZDREGR(J,I0)
     +                     +  ZDFUNC * ZPHAS(J,I0,KTEK) / XSOR
     +                     + ZDDFUNC * ZCHAS(J,I0,KTEK) / XSOR
     +                     - KTEK * ZFUNC * ZPHAS(J,I0,KTEK) / XSOR1
     +                     - KTEK * ZDFUNC * ZCHAS(J,I0,KTEK) / XSOR1
              XSOR = XSOR * XS
              XSOR1 = XSOR1 * XS
            END DO
C
          END DO
C
        END DO
C
      END IF
C
      RETURN
  990 FORMAT(10X,'I0, EE =',I4,F12.5)
  995 FORMAT(15X,'EPS',14X,'KTEK',10X,'RECOMENDED |XMAX|')
  999 FORMAT(10X,E10.3,10X,I4,10X,F14.6)
      END
C
      SUBROUTINE ZASREG(ZAS,MAXZ,SHIFT,THRSHL,NDIM,NOPEN,ABSB)
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
C .                                                                   .
C .   P R O G R A M                                                   .
C .                  TO CALCULATE THE COEFFICIENTS OF ETALON          .
C .                  EQUATION                                         .
C .                                                                   .
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 ZAS(NDIM,MAXZ),THRSHL(NDIM)
      COMMON /CHARGE/ S1,S2,S3,Q1,Q2,XMIN
      DO I = 1 , NDIM
        ZAS(I,1) =  ABSB * 2.D0 * (Q1 + Q2) / S2
      END DO
      RETURN
      END
C
      SUBROUTINE VQAS0(VAS,QAS,KMAX,NDIM,ABSB)
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
C .                                                                   .
C .   P R O G R A M                                                   .
C .                  TO CALCULATE THE COEFFICIENTS OF THE ASYMPTOTIC  .
C .                  MATRIX ELEMENTS V(z) and Q(z) WITH ORDER KMAX    .
C .                  AT LARGE |z|                                     .
C .                                                                   .
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION VAS(NDIM,NDIM,2:12),QAS(NDIM,NDIM,12)
      REAL*8 K
      COMMON /CHARGE/ S1,S2,S3,Q1,Q2,XMIN
      DO I = 1 , NDIM
        DO J = 1 , I
          DO L = 1 , KMAX
            QAS(I,J,L)=0.D0
          END DO
        END DO
      END DO
      DO I = 1 , NDIM
        DO J = 1 , I
          DO L = 2 , KMAX
            VAS(I,J,L)=0.D0
          END DO
        END DO
      END DO
C
C        V MATRIX
C
      DO 601 N1=1,NDIM
      K=DBLE(N1-1)
      T1 = S3**2
      T2 = Q2*T1
      T3 = S1**2
      T4 = Q1*T3
      T7 = 2.D0*K
      T8 = T7+1.D0
      T9 = S2**2
      T10 = T9*S2
      VAS(N1,N1,3) = ABSB*(T2+T4)*T8/T10
      T13 = Q1*S1
      T14 = Q2*S3
      T17 = (T13-1.D0*T14)**2
      T18 = T9**2
      VAS(N1,N1,4) = -1.D0*T17/T18
      T22 = K**2
      T26 = T1**2
      T27 = Q2*T26
      T28 = T3**2
      T29 = Q1*T28
      VAS(N1,N1,5) = 0.15D1*ABSB*(2.D0*T22+T7+1.D0)*(T27+T29)/T18/S2
      T35 = Q1**2
      T36 = T9*T35
      T37 = T36*T3
      T39 = T9*Q1
      T40 = S1*Q2
      T44 = Q2**2
      T45 = T9*T44
      T46 = T45*T1
      T48 = T35*T28
      T52 = T1*S3
      T53 = Q2*T52
      T56 = T3*S1
      T57 = Q1*T56
      T60 = T44*T26
      VAS(N1,N1,6) = -0.5D0*T8*(-4.D0*T37+8.D0*T39*T40*S3-4.D0*T46+7.D0*
     #T48+2.D0*T2*T4-6.D0*T53*T13-6.D0*T57*T14+7.D0*T60)/T18/T9
      T68 = T44*T52
      T71 = T28*T3
      T72 = Q1*T71
      T74 = T26*T1
      T75 = Q2*T74
      T77 = T35*Q1
      T80 = T35*T56
      T83 = T35*Q2
      T84 = T1*T3
      T87 = T44*T1
      T90 = T44*Q2
      T93 = T75*K
      T95 = T72*K
      T97 = T72*T22
      T99 = T75*T22
      T101 = T22*K
      T102 = T75*T101
      T104 = T72*T101
      T106 = -16.D0*T68*T13+15.D0*T72+15.D0*T75+8.D0*T77*T28-16.D0*T80*T
     #14+8.D0*T83*T84+8.D0*T87*T4+8.D0*T90*T26+40.D0*T93+40.D0*T95+30.D0
     #*T97+30.D0*T99+20.D0*T102+20.D0*T104
      VAS(N1,N1,7) = 0.25D0*ABSB*T106/T18/T10
      T111 = T35*T71
      T116 = T44*T74
      T125 = T9*T22
      T128 = T9*K
      T133 = T39*T56
      T134 = K*Q2
      T135 = T134*S3
      T139 = T1*Q1
      T140 = T139*T3
      T143 = T9*Q2
      T146 = T125*Q2
      T147 = S3*Q1
      T151 = T56*Q2
      T152 = T151*S3
      T157 = T39*S1
      T158 = T53*K
      T161 = T52*Q1
      T162 = T161*S1
      T165 = T125*Q1
      T169 = 228.D0*T111*K+228.D0*T111*T22+228.D0*T116*T22-105.D0*T45*T2
     #6-105.D0*T36*T28+228.D0*T116*K-201.D0*T125*T48-201.D0*T128*T48-201
     #.D0*T128*T60+192.D0*T133*T135-18.D0*T128*Q2*T140-18.D0*T143*T140+1
     #92.D0*T146*T147*T56+96.D0*T39*T152-18.D0*T146*T140+192.D0*T157*T15
     #8+96.D0*T143*T162+192.D0*T165*T40*T52
      T170 = T57*K
      T173 = T29*K
      T176 = T27*T22
      T179 = T27*K
      T182 = T26*S3
      T183 = Q2*T182
      T184 = T183*K
      T187 = T28*S1
      T188 = Q1*T187
      T189 = T188*T22
      T193 = T188*K
      T209 = T183*T22
      T212 = T57*T22
      T215 = T29*T22
      T218 = -120.D0*T53*T170+48.D0*T2*T173+48.D0*T4*T176+48.D0*T4*T179-
     #120.D0*T13*T184-120.D0*T14*T189+106.D0*T111-120.D0*T14*T193-201.D0
     #*T125*T60-60.D0*T14*T188-44.D0*T53*T57+24.D0*T4*T27+24.D0*T2*T29-6
     #0.D0*T13*T183+106.D0*T116-120.D0*T13*T209-120.D0*T53*T212+48.D0*T2
     #*T215
      T220 = T18**2
      VAS(N1,N1,8) = -0.125D0*(T169+T218)/T220
      T224 = T77*T71
      T227 = T28**2
      T228 = Q1*T227
      T229 = T228*T101
      T231 = T26**2
      T232 = Q2*T231
      T233 = T232*T101
      T235 = T90*T74
      T238 = T9*T90
      T242 = T9*T77
      T246 = T35*T3
      T251 = S3*T187
      T254 = T52*T56
      T259 = 248.D0*T224*K+140.D0*T229+140.D0*T233+248.D0*T235*K-288.D0*
     #T238*T26*K-288.D0*T242*T28*K+48.D0*T246*T27-72.D0*T68*T57-168.D0*T
     #83*T251-72.D0*T83*T254+48.D0*T87*T29
      T260 = T44*Q1
      T261 = T3*T26
      T264 = S1*T182
      T267 = T1*T28
      T272 = XMIN**2
      T273 = T272**2
      T274 = T273**2
      T278 = T232*K
      T280 = T228*T22
      T282 = T22**2
      T283 = T228*T282
      T285 = T232*T22
      T287 = T232*T282
      T289 = 84.D0*T260*T261-168.D0*T260*T264+84.D0*T83*T267+96.D0*T87*T
     #173-2.D0*Q2*T274+105.D0*T228+280.D0*T278+350.D0*T280+70.D0*T283+35
     #0.D0*T285+70.D0*T287
      T291 = T228*K
      T297 = T45*T52
      T298 = T13*K
      T304 = T36*Q2
      T308 = T261*K
      T313 = T264*K
      T318 = T4*K
      T321 = 280.D0*T291-144.D0*T238*T26-144.D0*T242*T28+576.D0*T297*T29
     #8-144.D0*T36*T2*T3-288.D0*T304*T84*K+168.D0*T260*T308-2.D0*Q1*T274
     #-336.D0*T260*T313-144.D0*T45*T140-288.D0*T46*T318
      T330 = T251*K
      T337 = T267*K
      T342 = T254*K
      T345 = 288.D0*T36*T152+288.D0*T45*T162+576.D0*T36*T56*T135+105.D0*
     #T232-336.D0*T83*T330+124.D0*T224+96.D0*T246*T179+124.D0*T235+168.D
     #0*T83*T337-144.D0*T68*T170-144.D0*T83*T342
      VAS(N1,N1,9) = 0.125D0*ABSB*(T259+T289+T321+T345)/T220/S2
      T352 = T74*K
      T355 = T71*K
      T361 = T44*T231
      T364 = T35*T227
      T370 = T44**2
      T371 = T370*T74
      T373 = T35**2
      T374 = T373*T71
      T376 = T26*T52
      T377 = Q2*T376
      T378 = T377*T101
      T383 = T101*Q2
      T384 = T383*T26
      T400 = -7313.D0*T45*T352-7313.D0*T36*T355-5613.D0*T36*T71*T22+3366
     #.D0*T361*T101+5931.D0*T364*K+5931.D0*T361*K+2124.D0*T361+216.D0*T3
     #71+216.D0*T374-1260.D0*T13*T378+1062.D0*T29*T179+612.D0*T29*T384+5
     #40.D0*T4*T102+3366.D0*T364*T101+5049.D0*T364*T22+5049.D0*T361*T22-
     #2721.D0*T45*T74-2721.D0*T71*T9*T35
      T402 = T28*T56
      T403 = Q1*T402
      T404 = T403*T101
      T409 = T39*T3
      T414 = T143*T1
      T417 = T22*Q1
      T418 = T417*T402
      T423 = T101*Q1
      T424 = T423*T187
      T427 = T22*Q2
      T428 = T427*T376
      T431 = T3*Q2
      T432 = T431*T26
      T435 = T161*T56
      T446 = T143*T52
      T447 = T57*T101
      T450 = T143*S3
      T453 = T183*T101
      T459 = 2124.D0*T364-1260.D0*T14*T404+4320.D0*T157*T184-945.D0*T409
     #*T179-405.D0*T409*T176-945.D0*T414*T173-1890.D0*T14*T418-1800.D0*T
     #57*T184-1260.D0*T53*T424-1890.D0*T13*T428-405.D0*T39*T432+1392.D0*
     #T143*T435+1620.D0*T143*T147*T187+3240.D0*T157*T209+1620.D0*T39*T40
     #*T182+2624.D0*T446*T447+2160.D0*T450*T424+2160.D0*T157*T453-270.D0
     #*T414*T29*T101
      T492 = T35*T44
      T497 = T90*Q1
      T500 = T77*Q2
      T505 = -270.D0*T409*T384-405.D0*T414*T215+3936.D0*T446*T212+4096.D
     #0*T446*T170-5613.D0*T45*T74*T22-3742.D0*T45*T74*T101-3742.D0*T36*T
     #71*T101-945.D0*T13*T377+405.D0*T2*T72-585.D0*T53*T188-945.D0*T14*T
     #403+378.D0*T29*T27+405.D0*T4*T75-585.D0*T57*T183+360.D0*T492*T261-
     #576.D0*T492*T254-504.D0*T497*T264+288.D0*T500*T267+360.D0*T492*T26
     #7
      T510 = T90*T52
      T519 = T139*T28
      T524 = T403*K
      T537 = T377*K
      T548 = -72.D0*T500*T254-504.D0*T500*T251-72.D0*T510*T57+288.D0*T49
     #7*T261+4320.D0*T450*T193+3240.D0*T450*T189-405.D0*T143*T519+1080.D
     #0*T4*T93-2520.D0*T14*T524+1080.D0*T2*T95+810.D0*T4*T99+918.D0*T29*
     #T176-1890.D0*T57*T209-1800.D0*T53*T193-2520.D0*T13*T537+810.D0*T2*
     #T97-1890.D0*T53*T189-1260.D0*T57*T453+540.D0*T2*T104
      VAS(N1,N1,10) = -0.2777777777777778D-1*(T400+T459+T505+T548)/T220/
     #T9
      T555 = T77*T227
      T558 = T227*T3
      T559 = Q1*T558
      T562 = T231*T1
      T563 = Q2*T562
      T568 = T282*K
      T573 = T90*T231
      T584 = 3600.D0*T555*K+2520.D0*T559*T101+630.D0*T563*T282-90.D0*T2*
     #T274+252.D0*T559*T568+3600.D0*T555*T22+3600.D0*T573*T22+2520.D0*T5
     #63*T101+2898.D0*T559*K+630.D0*T559*T282+3150.D0*T563*T22
      T585 = T44*T376
      T606 = T2*K
      T609 = -3648.D0*T585*T298+720.D0*T246*T99+252.D0*T563*T568+2898.D0
     #*T563*K+3150.D0*T559*T22+3600.D0*T573*K-90.D0*T4*T274-3264.D0*T242
     #*T71-3264.D0*T238*T74+1824.D0*T116*T318+1824.D0*T111*T606
      T623 = T274*K
      T630 = T35*T187
      T635 = 1608.D0*T573+1824.D0*T116*T417*T3-6336.D0*T125*T235-6336.D0
     #*T125*T224-6336.D0*T242*T355-6336.D0*T238*T352-180.D0*T4*T623-180.
     #D0*T2*T623+848.D0*T111*T2-848.D0*T630*T53+848.D0*T116*T4
      T640 = T44*T182
      T647 = T35*T402
      T658 = T427*T52
      T661 = -480.D0*T68*T188-480.D0*T80*T183-848.D0*T640*T57+592.D0*T29
     #*T60+592.D0*T27*T48-1696.D0*T647*T14+360.D0*T72*T87-1696.D0*T585*T
     #13+360.D0*T75*T246-2208.D0*T630*T158-2208.D0*T630*T658
      T674 = K*T35*T3
      T689 = -2208.D0*T640*T212-3648.D0*T647*T135-2208.D0*T640*T170-3648
     #.D0*T585*T417*S1+720.D0*T75*T674-3648.D0*T647*T427*S3-960.D0*T80*T
     #184+1824.D0*T111*T427*T1-960.D0*T68*T189+1608.D0*T555+945.D0*T563
      T697 = T125*T44
      T700 = T45*Q1
      T708 = T3*T44*T26
      T711 = T125*T35
      T712 = T151*T52
      T719 = 945.D0*T559+1440.D0*T29*T22*T44*T26-960.D0*T68*T193+3768.D0
     #*T697*T435-3984.D0*T700*T308+8760.D0*T700*T313-960.D0*T80*T209-398
     #4.D0*T165*T708+3768.D0*T711*T712+8760.D0*T304*T330-2496.D0*T697*T5
     #19
      T731 = T2*T28
      T736 = T13*T182
      T739 = T4*T26
      T748 = -2496.D0*T37*T179+3768.D0*T297*T170-3984.D0*T146*T1*T35*T28
     #-3984.D0*T304*T337-2160.D0*T36*T731+3768.D0*T304*T342+4440.D0*T45*
     #T736-2160.D0*T45*T739-1248.D0*T45*T519+1944.D0*T36*T712-1248.D0*T3
     #6*T432
      T751 = T14*T187
      T765 = T48*K
      T778 = 1944.D0*T45*T435+4440.D0*T36*T751+8760.D0*T697*T736-2496.D0
     #*T46*T173+8760.D0*T711*T751-2496.D0*T711*T432+1440.D0*T29*T60*K+14
     #40.D0*T27*T765+720.D0*T87*T97+1440.D0*T27*T22*T35*T28+720.D0*T72*K
     #*T44*T1
      VAS(N1,N1,11) = 0.625D-1*ABSB*(T584+T609+T635+T661+T689+T719+T748+
     #T778)/T220/T10
      T786 = T35*T558
      T789 = T44*T562
      T792 = T370*T231
      T805 = T373*T227
      T829 = 339360.D0*T786*K+444240.D0*T789*T22+58848.D0*T792*K+444240.
     #D0*T786*T22+339360.D0*T789*K-864.D0*T87*T274+209760.D0*T789*T101-8
     #64.D0*T246*T274+58848.D0*T805*K+104880.D0*T789*T282+209760.D0*T786
     #*T101+104880.D0*T786*T282-174540.D0*T36*T227-51840.D0*T9*T370*T74-
     #51840.D0*T9*T373*T71-174540.D0*T45*T231+29424.D0*T792+31680.D0*T27
     #*T104+66240.D0*T27*T97
      T830 = T28*T26
      T831 = T830*K
      T836 = T231*S3
      T840 = T77*T402
      T845 = T227*S1
      T846 = Q1*T845
      T857 = Q2*T836
      T868 = T77*T187
      T871 = T77*T56
      T876 = T90*T182
      T881 = 23040.D0*T497*T831+17280.D0*T29*T75-120960.D0*T13*T134*T836
     #-107136.D0*T840*T135+31680.D0*T29*T102-45360.D0*T14*T846-21552.D0*
     #T188*T183-25200.D0*T377*T57-25200.D0*T403*T53+17280.D0*T27*T72-453
     #60.D0*T13*T857+20160.D0*T4*T232+20160.D0*T2*T228+28224.D0*T116*T24
     #6+29760.D0*T235*T4-19008.D0*T868*T53-3840.D0*T871*T183+39456.D0*T6
     #0*T48-19008.D0*T876*T57+11520.D0*T500*T830
      T907 = T56*T182
      T925 = 29760.D0*T224*T2-53568.D0*T840*T14-3840.D0*T510*T188+11520.
     #D0*T497*T830+29424.D0*T805+13440.D0*T2*T283-60480.D0*T14*T423*T845
     #-151200.D0*T14*T846*T22-60480.D0*T188*T453+1728.D0*T13*T14*T274+53
     #760.D0*T2*T291-80640.D0*T492*T907*K+50400.D0*T29*T93+118776.D0*T78
     #9-38016.D0*T876*T170+13440.D0*T4*T287-7680.D0*T871*T184+50400.D0*T
     #27*T95+56448.D0*T116*T674+118776.D0*T786
      T932 = T282*Q2
      T942 = T187*T52
      T945 = T71*T1
      T948 = T90*T376
      T964 = T9*T282
      T980 = -7680.D0*T510*T193+67200.D0*T4*T285+66240.D0*T29*T99-30240.
     #D0*T13*T932*T836-151200.D0*T13*T857*T22-30240.D0*T188*T932*T182-40
     #320.D0*T492*T942+28224.D0*T492*T945-53568.D0*T948*T13-40320.D0*T49
     #2*T907-103680.D0*T128*T371-273190.D0*T45*T231*T101-489050.D0*T36*T
     #227*K-489050.D0*T45*T231*K-136595.D0*T964*T361-273190.D0*T36*T227*
     #T101-103680.D0*T128*T374-625645.D0*T36*T227*T22-136595.D0*T964*T36
     #4-625645.D0*T45*T231*T22
      T1034 = -110880.D0*T403*T658-110880.D0*T377*T212-80640.D0*T403*T15
     #8-60480.D0*T377*T447-60480.D0*T403*T383*T52-80640.D0*T377*T170-604
     #80.D0*T13*T383*T836-97440.D0*T188*T209-67200.D0*T188*T184-120960.D
     #0*T14*K*Q1*T845-30240.D0*T403*T932*T52+53760.D0*T4*T278-30240.D0*T
     #57*T932*T376-30240.D0*T14*T846*T282+15840.D0*T27*T282*Q1*T71+15840
     #.D0*T29*T932*T74-38016.D0*T868*T158+59520.D0*T224*T606-80640.D0*T4
     #92*T942*K+59520.D0*T235*T318
      T1067 = T128*T90
      T1070 = T128*T77
      T1073 = T964*Q1
      T1078 = T964*Q2
      T1087 = T39*T28
      T1090 = 56448.D0*T492*T945*K+23040.D0*T500*T831+78912.D0*T60*T765+
     #26880.D0*T2*T229+26880.D0*T4*T233+67200.D0*T2*T280+215040.D0*T157*
     #T537+189440.D0*T446*T193-60480.D0*T414*T97+259840.D0*T446*T189+140
     #800.D0*T133*T453-107136.D0*T948*T298+140800.D0*T446*T424-168192.D0
     #*T128*T44*T26*T35*T3+32256.D0*T1067*T435+32256.D0*T1070*T712-7560.
     #D0*T1073*T71*Q2*T1-9750.D0*T1078*T26*Q1*T28+70400.D0*T1073*T187*Q2
     #*T52-73050.D0*T1087*T176
      T1092 = T40*T376
      T1129 = T87*T28
      T1142 = 53760.D0*T1073*T1092+53760.D0*T1073*T402*Q2*S3+259840.D0*T
     #133*T209-23400.D0*T39*T28*Q2*T26-22680.D0*T39*T431*T74+59520.D0*T1
     #43*T161*T187+80640.D0*T143*T147*T402-22680.D0*T143*T139*T71+80640.
     #D0*T39*T1092+107520.D0*T450*T404+268800.D0*T450*T418-142848.D0*T10
     #70*T731+268800.D0*T157*T428+189440.D0*T133*T184-84096.D0*T36*T1129
     #+16128.D0*T242*T712+119808.D0*T242*T751+16128.D0*T238*T435-71424.D
     #0*T242*T731+119808.D0*T238*T736
      T1143 = T68*T56
      T1151 = T128*T35
      T1193 = 142848.D0*T36*T1143+59520.D0*T39*T151*T182-84096.D0*T36*T7
     #08+285696.D0*T1151*T1143-142848.D0*T128*Q1*T3*T90*T26+239616.D0*T1
     #070*T751+239616.D0*T1067*T736-168192.D0*T1151*T1129-15120.D0*T414*
     #T104+107520.D0*T157*T378+215040.D0*T450*T524-52920.D0*T409*T93-604
     #80.D0*T409*T99-71424.D0*T238*T739-52920.D0*T414*T95+70400.D0*T1078
     #*T182*Q1*T56-19500.D0*T1087*T384-7560.D0*T1078*T74*Q1*T3-63300.D0*
     #T1087*T179-15120.D0*T409*T102
      VAS(N1,N1,12) = -0.2604166666666667D-2*(T829+T881+T925+T980+T1034+
     #T1090+T1142+T1193)/T220/T18
 601  CONTINUE
C
      DO 602 N1=2,NDIM
      K=DBLE(N1-1)
      T1 = DSQRT(K)
      T2 = T1*K
      T3 = Q1*S1
      T4 = Q2*S3
      T6 = T3-1.D0*T4
      T8 = S3**2
      T9 = Q2*T8
      T10 = S1**2
      T11 = Q1*T10
      T13 = S2**2
      T14 = T13**2
      VAS(N1,N1-1,7) = -0.2121320343559642D1*T2*T6*(T9+T11)/T14/S2
      VAS(N1,N1-1,8) = 0.D0
      T20 = T8*S3
      T21 = Q2*T20
      T24 = K**2
      T25 = T24*Q1
      T26 = T10*S1
      T31 = Q2**2
      T32 = T8**2
      T33 = T32*S3
      T34 = T31*T33
      T36 = Q1**2
      T37 = T24*T36
      T38 = T10**2
      T39 = T38*S1
      T42 = Q2*T32
      T45 = T24*T31
      T48 = Q1*T38
      T51 = T24*Q2
      T52 = T32*Q1
      T56 = Q1*T26
      T59 = T38*Q2
      T67 = T36*T39
      T69 = -11.D0*T11*T21+10.D0*T25*T26*Q2*T8-16.D0*T34+20.D0*T37*T39+5
     #.D0*T42*T3-20.D0*T45*T33-5.D0*T48*T4+10.D0*T51*T52*S1+11.D0*T9*T56
     #-10.D0*T25*T59*S3-10.D0*T51*T20*Q1*T10+16.D0*T67
      VAS(N1,N1-1,9) = -0.7071067811865475D0*T1*T69/T14/T13/S2
      T77 = T31*T32
      T85 = T36*T38
      T89 = T14**2
      VAS(N1,N1-1,10) = 0.3535533905932738D0*ABSB*T2*T6*(59.D0*T77-20.D0
     #*T21*T3+78.D0*T9*T11-20.D0*T56*T4+59.D0*T85)/T89
      T93 = T32*T8
      T95 = T93*Q1*S1
      T98 = T38*T26
      T101 = T38*T10
      T103 = T101*Q2*S3
      T112 = T59*T20
      T115 = Q1*T39
      T125 = Q2*T33
      T128 = T26*T52
      T131 = T32*T20
      T143 = 7.D0*T51*T95+23.D0*T37*T98-7.D0*T25*T103-23.D0*T48*T21+63.D
     #0*T36*T98+23.D0*T42*T56-9.D0*T25*T112+26.D0*T115*T9+7.D0*T51*T8*Q1
     #*T39-14.D0*Q1*T101*T4-26.D0*T125*T11+9.D0*T51*T128-23.D0*T45*T131+
     #14.D0*Q2*T93*T3-63.D0*T31*T131-7.D0*T25*T10*Q2*T33
      VAS(N1,N1-1,11) = -0.2651650429449553D1*T2*T143/T89/S2
      T150 = T36*Q1
      T178 = T31*Q2
      T189 = 3977.D0*T24*T150*T98-3441.D0*T45*T33*Q1*T10+1996.D0*T77*T56
     #+3825.D0*T45*T95-640.D0*T51*T33*T36*T10+320.D0*T115*T31*T8+2589.D0
     #*T31*T93*T3+640.D0*T25*T39*T31*T8-3825.D0*T37*T103-3977.D0*T24*T17
     #8*T131-2589.D0*T36*T101*T4+3441.D0*T51*T8*T36*T39
      T196 = T36*T26
      T200 = T31*T20
      T219 = 3097.D0*T150*T98-3021.D0*T34*T11+2168.D0*T45*T128+1857.D0*T
     #196*T42*T24-1365.D0*T48*T200+3021.D0*T67*T9-1857.D0*T200*T48*T24-3
     #20.D0*T125*T36*T10+1365.D0*T42*T196-2168.D0*T37*T112-3097.D0*T178*
     #T131-1996.D0*T21*T85
      VAS(N1,N1-1,12) = 0.5892556509887896D-1*ABSB*T1*(T189+T219)/T89/T1
     #3
 602  CONTINUE
C
      DO 603 N1=3,NDIM
      K=DBLE(N1-1)
      T1 = DSQRT(K)
      T3 = DSQRT(K-1.D0)
      T4 = T1*T3
      T5 = Q1*S1
      T6 = Q2*S3
      T8 = T5-1.D0*T6
      T9 = T8**2
      T10 = S2**2
      T11 = T10**2
      VAS(N1,N1-2,6) = -2.D0*T4*T9/T11
      VAS(N1,N1-2,7) = 0.D0
      T16 = S1**2
      T17 = T16*S1
      T18 = Q1*T17
      T19 = S3**2
      T20 = T19*S3
      T21 = Q2*T20
      T26 = 2.D0*K-1.D0
      VAS(N1,N1-2,8) = -0.5333333333333333D1*T4*(T18-1.D0*T21)*T8*T26/T1
     #1/T10
      T34 = ABSB*T1*T3
      T35 = Q2*T19
      T36 = Q1*T16
      VAS(N1,N1-2,9) = 18.D0*T34*(T35+T36)*T9/T11/T10/S2
      T47 = Q1**2
      T48 = T16**2
      T49 = T48*T16
      T50 = T47*T49
      T52 = T19**2
      T53 = T52*S3
      T54 = Q2*T53
      T55 = T54*K
      T58 = K**2
      T59 = T54*T58
      T62 = T48*S1
      T63 = Q1*T62
      T64 = T63*T58
      T67 = T63*K
      T70 = Q2*T52
      T71 = T70*K
      T79 = Q2**2
      T80 = T52*T19
      T81 = T79*T80
      T92 = Q1*T48
      T107 = T70*T58
      T110 = -1233.D0*T50*K-60.D0*T36*T70+420.D0*T81+1233.D0*T50*T58-15.
     #D0*T35*T92*T58-60.D0*T35*T92-800.D0*T6*T63+1233.D0*T81*T58+15.D0*T
     #35*T92*K-800.D0*T5*T54-15.D0*T36*T107
      T112 = T11**2
      VAS(N1,N1-2,10) = -0.3125D-1*T4*(896.D0*T21*T18*K+420.D0*T50+800.D
     #0*T5*T55-800.D0*T5*T59-800.D0*T6*T64+800.D0*T6*T67+15.D0*T36*T71+6
     #40.D0*T21*T18-896.D0*T21*T18*T58-1233.D0*T81*K+T110)/T112
      VAS(N1,N1-2,11) = 0.8333333333333333D0*T34*T8*(-107.D0*T79*T53+43.
     #D0*T70*T5-64.D0*T36*T21+64.D0*T35*T18-43.D0*T92*T6+107.D0*T47*T62)
     #*T26/T112/S2
      T136 = T52**2
      T137 = T79*T136
      T140 = T48**2
      T141 = T47*T140
      T144 = T58*K
      T153 = T47*T79
      T154 = T20*T17
      T157 = T16*T52
      T167 = -56289.D0*T137*T58-56289.D0*T141*T58+37526.D0*T141*T144+315
     #31.D0*T137*K+31531.D0*T141*K+37526.D0*T137*T144-119040.D0*T153*T15
     #4+70080.D0*T153*T157-14976.D0*T18*T54+2520.D0*T36*Q2*T80+6000.D0*T
     #92*T70
      T168 = T48*T17
      T169 = Q1*T168
      T177 = T52*T20
      T178 = Q2*T177
      T181 = T79*Q2
      T182 = T181*Q1
      T189 = T47*Q1*Q2
      T195 = T19*T48
      T204 = 26880.D0*T6*T169-14976.D0*T21*T63+2520.D0*T35*Q1*T49+26880.
     #D0*T5*T178+59520.D0*T182*T157-13440.D0*T181*T20*T18-99840.D0*T189*
     #S3*T62-13440.D0*T189*T154+70080.D0*T153*T195+59520.D0*T189*T195-99
     #840.D0*T182*S1*T53-6384.D0*T141
      T208 = T144*Q2
      T212 = T79**2
      T219 = T58*Q1
      T223 = T47**2
      T228 = T58*Q2
      T232 = T144*Q1
      T242 = -12500.D0*T92*T71-630.D0*T36*T208*T80+43200.D0*T212*T80-638
     #4.D0*T137-17920.D0*T6*T169*T144+26880.D0*T6*T219*T168+43200.D0*T22
     #3*T49+19584.D0*T18*T55+26880.D0*T5*T228*T177-20736.D0*T21*T232*T62
     #-17920.D0*T5*T178*T144-1000.D0*T92*T208*T52
      T277 = -62720.D0*T5*T178*K+19584.D0*T21*T67+945.D0*T35*T219*T49+31
     #104.D0*T21*T64-20736.D0*T18*T208*T53-630.D0*T35*T232*T49-62720.D0*
     #T6*T169*K-5355.D0*T36*K*Q2*T80+945.D0*T36*T228*T80-5355.D0*T35*K*Q
     #1*T49+1500.D0*T92*T107+31104.D0*T18*T59
      VAS(N1,N1-2,12) = -0.3125D-2*T4*(T167+T204+T242+T277)/T112/T10
 603  CONTINUE
C
      DO 604 N1=4,NDIM
      K=DBLE(N1-1)
      T1 = DSQRT(K)
      T2 = K-1.D0
      T3 = DSQRT(T2)
      T4 = T1*T3
      T6 = DSQRT(K-2.D0)
      T8 = Q1*S1
      T9 = Q2*S3
      T11 = T8-1.D0*T9
      T12 = S3**2
      T13 = Q2*T12
      T14 = S1**2
      T15 = Q1*T14
      T18 = S2**2
      T19 = T18**2
      VAS(N1,N1-3,7) = 0.2121320343559642D1*T4*T6*T11*(T13+T15)/T19/S2
      VAS(N1,N1-3,8) = 0.D0
      T24 = T3*T2
      T26 = T14*S1
      T27 = Q1*T26
      T30 = T12**2
      T31 = Q2*T30
      T34 = Q1**2
      T35 = T14**2
      T36 = T35*S1
      T37 = T34*T36
      T39 = Q1*T35
      T42 = Q2**2
      T43 = T30*S3
      T44 = T42*T43
      T46 = T12*S3
      T47 = Q2*T46
      VAS(N1,N1-3,9) = 0.1767766952966369D0*T1*T24*T6*(36.D0*T13*T27+35.
     #D0*T31*T8+71.D0*T37-35.D0*T39*T9-71.D0*T44-36.D0*T15*T47)/T19/T18/
     #S2
      T57 = ABSB*T1
      T60 = T42*T30
      T68 = T34*T35
      T71 = T19**2
      VAS(N1,N1-3,10) = -0.3535533905932738D0*T57*T3*T6*T11*(59.D0*T60-2
     #0.D0*T47*T8+78.D0*T13*T15-20.D0*T27*T9+59.D0*T68)/T71
      T77 = K**2
      T78 = T77*Q2
      T80 = T30*Q1*T26
      T83 = T77*Q1
      T85 = T35*Q2*T46
      T88 = T35*T14
      T90 = T88*Q2*S3
      T93 = K*Q1
      T96 = T30*T12
      T103 = T35*T26
      T110 = K*Q2
      T113 = T30*T46
      T117 = T96*Q1*S1
      T120 = 175.D0*T78*T80-175.D0*T83*T85-140.D0*T83*T90+280.D0*T93*T90
     #+280.D0*Q2*T96*T8+350.D0*T93*T85-924.D0*K*T34*T103-25.D0*T31*T27+2
     #5.D0*T39*T47-350.D0*T110*T80-609.D0*T42*T113+140.D0*T78*T117
      T124 = Q2*T43
      T132 = Q1*T36
      T139 = T14*Q2*T43
      T143 = T12*Q1*T36
      T155 = 924.D0*K*T42*T113-354.D0*T124*T15-280.D0*T110*T117-280.D0*Q
     #1*T88*T9+354.D0*T132*T13+462.D0*T77*T34*T103+294.D0*T93*T139+147.D
     #0*T78*T143-462.D0*T77*T42*T113-147.D0*T83*T139-294.D0*T110*T143+60
     #9.D0*T34*T103
      VAS(N1,N1-3,11) = 0.1060660171779821D0*T4*T6*(T120+T155)/T71/S2
      T195 = -2459.D0*T42*Q2*T113+2323.D0*T42*T96*T8-2323.D0*T34*T88*T9+
     #368.D0*T132*T42*T12-1131.D0*T39*T42*T46-1416.D0*T47*T68-2139.D0*T4
     #4*T15-368.D0*T124*T34*T14+2139.D0*T37*T13+2459.D0*T34*Q1*T103+1416
     #.D0*T60*T27+1131.D0*T31*T34*T26
      VAS(N1,N1-3,12) = -0.8838834764831844D-1*T57*T24*T6*T195/T71/T18
 604  CONTINUE
C
      DO 605 N1=5,NDIM
      K=DBLE(N1-1)
      T1 = DSQRT(K)
      T3 = DSQRT(K-1.D0)
      T6 = DSQRT(K-2.D0)
      T7 = T1*T3*T6
      T9 = DSQRT(K-3.D0)
      T10 = Q1**2
      T11 = S1**2
      T12 = T11**2
      T15 = T11*S1
      T16 = Q1*T15
      T17 = Q2*S3
      T20 = Q2**2
      T21 = S3**2
      T22 = T21**2
      T25 = Q2*T21
      T26 = Q1*T11
      T29 = T21*S3
      T30 = Q2*T29
      T31 = Q1*S1
      T36 = S2**2
      T37 = T36**2
      VAS(N1,N1-4,8) = -0.2083333333333333D-1*T7*T9*(91.D0*T10*T12-64.D0
     #*T16*T17+91.D0*T20*T22+54.D0*T25*T26-64.D0*T30*T31)/T37/T36
      VAS(N1,N1-4,9) = 0.D0
      T43 = T12*T11
      T48 = T12*S1
      T49 = Q1*T48
      T52 = Q2*T22
      T55 = T22*S3
      T56 = Q2*T55
      T59 = T22*T21
      T62 = Q1*T12
      T69 = T37**2
      VAS(N1,N1-4,10) = -0.25D-1*T7*T9*(243.D0*T10*T43-160.D0*T30*T16-88
     #.D0*T17*T49+75.D0*T26*T52-88.D0*T31*T56+243.D0*T20*T59+75.D0*T25*T
     #62)*(2.D0*K-3.D0)/T69
      T87 = T10*Q2
      T91 = T20*Q1
      VAS(N1,N1-4,11) = 0.8333333333333333D-1*ABSB*T1*T3*T6*T9*(236.D0*T
     #10*Q1*T43+236.D0*T20*Q2*T59+76.D0*T10*T11*T52-285.D0*T87*S3*T48-28
     #5.D0*T91*S1*T55+76.D0*T20*T21*T62-133.D0*T20*T29*T16+214.D0*T91*T1
     #1*T22-133.D0*T87*T29*T15+214.D0*T87*T21*T12)/T69/S2
      T116 = T12**2
      T117 = T10*T116
      T120 = K**2
      T123 = T22**2
      T124 = T20*T123
      T134 = K*Q2
      T141 = T22*T29
      T142 = Q2*T141
      T146 = T120*Q1
      T147 = T12*T15
      T154 = -24132.D0*T117*K+8044.D0*T117*T120-24132.D0*T124*K+5915.D0*
     #T26*Q2*T59+2500.D0*T62*T52-9152.D0*T16*T56-6000.D0*T62*T134*T22+80
     #44.D0*T124*T120+22589.D0*T117-6272.D0*T31*T142+22589.D0*T124-1792.
     #D0*T17*T146*T147+5915.D0*T25*Q1*T43
      T160 = T120*Q2
      T164 = Q1*T147
      T182 = K*Q1
      T198 = 11136.D0*T16*T134*T55-9152.D0*T30*T49-1792.D0*T31*T160*T141
     #-6272.D0*T17*T164+1540.D0*T26*T160*T59-4620.D0*T26*T134*T59+5376.D
     #0*T17*T164*K-3712.D0*T30*T146*T48+1540.D0*T25*T146*T43+11136.D0*T3
     #0*T182*T48-4620.D0*T25*T182*T43-3712.D0*T16*T160*T55+5376.D0*T31*T
     #142*K+2000.D0*T62*T160*T22
      VAS(N1,N1-4,12) = -0.625D-2*T7*T9*(T154+T198)/T69/T36
 605  CONTINUE
C
      DO 606 N1=6,NDIM
      K=DBLE(N1-1)
      T1 = DSQRT(K)
      T3 = DSQRT(K-1.D0)
      T4 = T1*T3
      T5 = K-2.D0
      T6 = DSQRT(T5)
      T9 = DSQRT(K-3.D0)
      T11 = DSQRT(K-4.D0)
      T12 = T9*T11
      T13 = S1**2
      T14 = T13**2
      T15 = Q1*T14
      T16 = Q2*S3
      T19 = Q1*T13
      T20 = S3**2
      T21 = T20*S3
      T22 = Q2*T21
      T25 = Q1**2
      T26 = T14*S1
      T27 = T25*T26
      T29 = Q2*T20
      T30 = T13*S1
      T31 = Q1*T30
      T34 = T20**2
      T35 = Q2*T34
      T36 = Q1*S1
      T39 = Q2**2
      T40 = T34*S3
      T41 = T39*T40
      T44 = S2**2
      T46 = T44**2
      VAS(N1,N1-5,9) = 0.1767766952966369D0*T4*T6*T12*(-5.D0*T15*T16-4.D
     #0*T19*T22+9.D0*T27+4.D0*T29*T31+5.D0*T35*T36-9.D0*T41)/T46/T44/S2
      VAS(N1,N1-5,10) = 0.D0
      T54 = T14*T30
      T57 = T14*T13
      T65 = T34*T20
      T69 = T34*T21
      T72 = Q2*T40
      T75 = Q1*T26
      T79 = T46**2
      VAS(N1,N1-5,11) = 0.5892556509887896D-1*T4*T6*T5*T12*(186.D0*T25*T
     #54-56.D0*Q1*T57*T16+85.D0*T35*T31-85.D0*T15*T22+56.D0*Q2*T65*T36-1
     #86.D0*T39*T69-45.D0*T72*T19+45.D0*T75*T29)/T79/S2
      T122 = 577.D0*T25*Q1*T54+176.D0*T75*T39*T20+321.D0*T35*T25*T30+681
     #.D0*T39*T65*T36-577.D0*T39*Q2*T69-321.D0*T15*T39*T21-88.D0*T22*T25
     #*T14+88.D0*T39*T34*T31+465.D0*T27*T29-465.D0*T41*T19-176.D0*T72*T2
     #5*T13-681.D0*T25*T57*T16
      VAS(N1,N1-5,12) = -0.2946278254943947D-1*ABSB*T1*T3*T6*T12*T122/T7
     #9/T44
 606  CONTINUE
C
      DO 607 N1=7,NDIM
      K=DBLE(N1-1)
      VAS(N1,N1-6,2) = 0.D0
      VAS(N1,N1-6,3) = 0.D0
      VAS(N1,N1-6,4) = 0.D0
      VAS(N1,N1-6,5) = 0.D0
      VAS(N1,N1-6,6) = 0.D0
      VAS(N1,N1-6,7) = 0.D0
      VAS(N1,N1-6,8) = 0.D0
      VAS(N1,N1-6,9) = 0.D0
      T1 = DSQRT(K)
      T3 = DSQRT(K-1.D0)
      T6 = DSQRT(K-2.D0)
      T8 = DSQRT(K-3.D0)
      T10 = T1*T3*T6*T8
      T12 = DSQRT(K-5.D0)
      T14 = DSQRT(K-4.D0)
      T15 = T12*T14
      T16 = S1**2
      T17 = Q1*T16
      T18 = S3**2
      T19 = T18**2
      T20 = Q2*T19
      T23 = Q2*T18
      T24 = T16**2
      T25 = Q1*T24
      T28 = T18*S3
      T29 = Q2*T28
      T30 = T16*S1
      T31 = Q1*T30
      T34 = Q1*S1
      T36 = Q2*T19*S3
      T39 = Q2**2
      T40 = T19*T18
      T43 = Q1**2
      T44 = T24*T16
      T47 = Q2*S3
      T49 = Q1*T24*S1
      T53 = S2**2
      T54 = T53**2
      T55 = T54**2
      VAS(N1,N1-6,10) = -0.6944444444444444D-3*T10*T15*(675.D0*T17*T20+6
     #75.D0*T23*T25-640.D0*T29*T31-864.D0*T34*T36+1859.D0*T39*T40+1859.D
     #0*T43*T44-864.D0*T47*T49)/T55
      VAS(N1,N1-6,11) = 0.D0
      T69 = T19**2
      T84 = T24**2
      VAS(N1,N1-6,12) = -0.1488095238095238D-3*T10*T15*(-8448.D0*T34*Q2*
     #T19*T28-8448.D0*T47*Q1*T24*T30+31961.D0*T39*T69+6615.D0*T23*Q1*T44
     #+6615.D0*T17*Q2*T40+10500.D0*T25*T20-11648.D0*T29*T49-11648.D0*T31
     #*T36+31961.D0*T43*T84)*(2.D0*K-5.D0)/T55/T53
 607  CONTINUE
C
      DO 608 N1=8,NDIM
      K=DBLE(N1-1)
      T1 = DSQRT(K)
      T3 = DSQRT(K-1.D0)
      T6 = DSQRT(K-2.D0)
      T8 = DSQRT(K-3.D0)
      T12 = DSQRT(K-4.D0)
      T14 = DSQRT(K-6.D0)
      T17 = DSQRT(K-5.D0)
      T18 = S1**2
      T19 = T18**2
      T22 = S3**2
      T26 = Q2**2
      T27 = T22*S3
      T28 = T22**2
      T38 = T18*S1
      T42 = Q1**2
      T62 = S2**2
      T63 = T62**2
      T64 = T63**2
      VAS(N1,N1-7,11) = 0.1178511301977579D-1*T1*T3*T6*T8*T12*T14*T17*(2
     #7.D0*Q1*T19*S1*Q2*T22-87.D0*T26*T28*T27+35.D0*Q2*T28*T22*Q1*S1+25.
     #D0*Q2*T28*Q1*T38+87.D0*T42*T19*T38-35.D0*Q1*T19*T18*Q2*S3-25.D0*Q1
     #*T19*Q2*T27-27.D0*Q2*T28*S3*Q1*T18)/T64/S2
      VAS(N1,N1-7,12) = 0.D0
 608  CONTINUE
C
      DO 609 N1=9,NDIM
      K=DBLE(N1-1)
      T1 = DSQRT(K)
      T3 = DSQRT(K-1.D0)
      T6 = DSQRT(K-2.D0)
      T8 = DSQRT(K-3.D0)
      T11 = DSQRT(K-4.D0)
      T15 = DSQRT(K-5.D0)
      T17 = DSQRT(K-7.D0)
      T20 = DSQRT(K-6.D0)
      T21 = S1**2
      T23 = S3**2
      T24 = T23**2
      T29 = Q2**2
      T30 = T24**2
      T33 = T23*S3
      T35 = T21**2
      T45 = T21*S1
      T51 = Q1**2
      T52 = T35**2
      T71 = S2**2
      T72 = T71**2
      T73 = T72**2
      VAS(N1,N1-8,12) = -0.1116071428571429D-3*T1*T3*T6*T8*T11*T15*T17*T
     #20*(1960.D0*Q1*T21*Q2*T24*T23+7187.D0*T29*T30-1792.D0*Q2*T33*Q1*T3
     #5*S1-2560.D0*Q1*S1*Q2*T24*T33-1792.D0*Q1*T45*Q2*T24*S3+7187.D0*T51
     #*T52+1750.D0*Q1*T35*Q2*T24+1960.D0*Q2*T23*Q1*T35*T21-2560.D0*Q2*S3
     #*Q1*T35*T45)/T73/T71
609   CONTINUE
C
      DO N1=2,NDIM
        DO N2=1,N1-1
          DO KTEK=2,KMAX
            VAS(N2,N1,KTEK)=VAS(N1,N2,KTEK)
          ENDDO
        ENDDO
      ENDDO
C
C        Q MATRIX
C
      DO 702 N1=2,NDIM
      K=DBLE(N1-1)
      T1 = DSQRT(K)
      T2 = ABSB*T1
      T3 = Q1*S1
      T4 = Q2*S3
      T6 = T3-1.D0*T4
      T7 = S2**2
      QAS(N1,N1-1,3) = 0.1414213562373095D1*T2*T6/T7
      QAS(N1,N1-1,4) = 0.D0
      T11 = T1*K
      T13 = S1**2
      T14 = T13*S1
      T15 = Q1*T14
      T16 = S3**2
      T17 = T16*S3
      T18 = Q2*T17
      T21 = T7**2
      QAS(N1,N1-1,5) = 0.4242640687119285D1*ABSB*T11*(T15-1.D0*T18)/T21
      T26 = Q2*T16
      T27 = Q1*T13
      QAS(N1,N1-1,6) = -0.6363961030678928D1*T1*T6*(T26+T27)/T21/S2
      T34 = K**2
      T37 = T16**2
      T38 = T37*S3
      T39 = Q2*T38
      T41 = T13**2
      T42 = T41*S1
      T43 = Q1*T42
      QAS(N1,N1-1,7) = 0.5303300858899106D1*T2*(2.D0*T34+1.D0)*(-1.D0*T3
     #9+T43)/T21/T7
      T50 = Q1*T41
      T53 = Q2*T37
      T58 = Q2**2
      T59 = T58*T38
      T61 = Q1**2
      T62 = T61*T42
      T68 = T7*S2
      QAS(N1,N1-1,8) = -0.2121320343559642D1*T11*(-13.D0*T50*T4+13.D0*T5
     #3*T3-10.D0*T27*T18-23.D0*T59+23.D0*T62+10.D0*T26*T15)/T21/T68
      T73 = T61*T41
      T76 = T58*T37
      T79 = T61*T14
      T82 = T58*Q2
      T83 = T82*T38
      T85 = T58*T16
      T88 = K*Q2
      T89 = T37*T17
      T92 = T34*K
      T93 = T92*Q2
      T96 = T61*Q1
      T97 = T96*T42
      T99 = T58*T17
      T102 = K*Q1
      T103 = T41*T14
      T106 = T61*T13
      T109 = T92*Q1
      T112 = -39.D0*T73*T4+39.D0*T3*T76+30.D0*T79*T26-27.D0*T83+12.D0*T8
     #5*T15-40.D0*T88*T89-20.D0*T93*T89+27.D0*T97-30.D0*T99*T27+40.D0*T1
     #02*T103-12.D0*T106*T18+20.D0*T109*T103
      T113 = T21**2
      QAS(N1,N1-1,9) = 0.1237436867076458D1*T2*T112/T113
      T117 = T34*Q1
      T118 = T41*Q2
      T122 = T34*Q2
      T123 = T37*T16
      T124 = T123*Q1
      T125 = T124*S1
      T134 = T41*T13
      T140 = T13*Q2
      T141 = T140*T38
      T144 = T37*Q1
      T145 = T144*T14
      T149 = T16*Q1*T42
      T152 = T134*Q2
      T153 = T152*S3
      T169 = -454.D0*T117*T118*T17+510.D0*T122*T125+255.D0*Q2*T123*T3+13
     #14.D0*T34*T61*T103-255.D0*Q1*T134*T4-102.D0*T50*T18-350.D0*T117*T1
     #41+454.D0*T122*T145+350.D0*T122*T149-510.D0*T117*T153-532.D0*T58*T
     #89-175.D0*T39*T27-1314.D0*T34*T58*T89+175.D0*T43*T26+102.D0*T53*T1
     #5+532.D0*T61*T103
      QAS(N1,N1-1,10) = -0.1767766952966369D0*T1*T169/T113/S2
      T175 = XMIN**2
      T176 = T175**2
      T177 = T176**2
      T183 = T37**2
      T184 = T183*S3
      T187 = T34**2
      T189 = T41**2
      T190 = T189*S1
      T196 = K*T61
      T201 = K*T58
      T237 = -90.D0*T3*T177+4994.D0*K*T96*T103-945.D0*Q2*T184+630.D0*T18
     #7*Q1*T190-4994.D0*K*T82*T89-1080.D0*T196*T141-5264.D0*T196*T153+52
     #64.D0*T201*T125+90.D0*T4*T177+3150.D0*T117*T190+3720.D0*T196*T42*Q
     #2*T16-2100.D0*T99*T50*K+945.D0*Q1*T190-2818.D0*T88*T17*T61*T41-630
     #.D0*T187*Q2*T184+2100.D0*T79*T53*K+1080.D0*T201*T149-3720.D0*T201*
     #T38*Q1*T13+2818.D0*T201*T145-3150.D0*T122*T184
      QAS(N1,N1-1,11) = 0.8838834764831844D-1*T2*T237/T113/T7
      T242 = T144*T42
      T245 = T118*T38
      T252 = T189*Q2*S3
      T287 = 2445.D0*T93*T242-2445.D0*T109*T245-1890.D0*T109*T140*T89-29
     #40.D0*T109*T252-4019.D0*T96*T134*T4-4185.D0*T99*T73+2901.D0*T26*T9
     #7+4185.D0*T79*T76-2196.D0*T59*T106+2196.D0*T62*T85-1284.D0*T96*T41
     #*T18-304.D0*T50*T82*T17+304.D0*T53*T96*T14+1284.D0*T82*T37*T15+401
     #9.D0*T82*T123*T3-2901.D0*T83*T27-15620.D0*T201*T184
      T296 = T58**2
      T299 = T152*T17
      T303 = T103*Q2*T16
      T309 = T183*Q1*S1
      T316 = T61**2
      T329 = T124*T14
      T334 = 10020.D0*T92*T61*T190+15620.D0*T196*T190-10020.D0*T92*T58*T
     #184-2127.D0*T296*T89-3135.D0*T102*T299+1890.D0*T109*T303-2825.D0*T
     #102*T245+5880.D0*T88*T309+2825.D0*T88*T242+2940.D0*T93*T309+2127.D
     #0*T316*T103-5880.D0*T102*T252-3780.D0*T88*T89*Q1*T13+3780.D0*T102*
     #T303-2745.D0*T109*T299+3135.D0*T88*T329+2745.D0*T93*T329
      QAS(N1,N1-1,12) = -0.8838834764831844D-1*T1*(T287+T334)/T113/T68
 702  CONTINUE
C
      DO 703 N1=3,NDIM
      K=DBLE(N1-1)
      T2 = DSQRT(K-1.D0)
      T3 = ABSB*T2
      T4 = DSQRT(K)
      T5 = S3**2
      T6 = Q2*T5
      T7 = S1**2
      T8 = Q1*T7
      T11 = S2**2
      T12 = T11*S2
      QAS(N1,N1-2,4) = -0.75D0*T3*T4*(T6+T8)/T12
      QAS(N1,N1-2,5) = 0.D0
      T17 = T3*T4
      T18 = T5**2
      T19 = Q2*T18
      T20 = T7**2
      T21 = Q1*T20
      T24 = 2.D0*K-1.D0
      T26 = T11**2
      QAS(N1,N1-2,6) = -0.125D1*T17*(T19+T21)*T24/T26/S2
      T32 = T2*T4
      T35 = T5*S3
      T36 = Q2*T35
      T37 = Q1*S1
      T40 = Q2**2
      T41 = T40*T18
      T43 = T7*S1
      T44 = Q1*T43
      T45 = Q2*S3
      T48 = Q1**2
      T49 = T48*T20
      QAS(N1,N1-2,7) = 0.5D0*T32*(6.D0*T6*T8-5.D0*T36*T37+8.D0*T41-5.D0*
     #T44*T45+8.D0*T49)/T26/T11
      T56 = K**2
      T59 = T18*T5
      T60 = Q2*T59
      T61 = T20*T7
      T62 = Q1*T61
      QAS(N1,N1-2,8) = -0.65625D1*T17*(1.D0+T56-1.D0*K)*(T60+T62)/T26/T1
     #2
      T72 = T20*S1
      T73 = Q1*T72
      T78 = T48*T61
      T82 = T18*S3
      T83 = Q2*T82
      T86 = T40*T59
      T90 = T26**2
      QAS(N1,N1-2,9) = 0.2083333333333333D-1*T32*(279.D0*T8*T19-320.D0*T
     #45*T73+279.D0*T6*T21+743.D0*T78-288.D0*T36*T44-320.D0*T37*T83+743.
     #D0*T86)*T24/T90
      T94 = T48*Q1
      T97 = T20**2
      T98 = Q1*T97
      T101 = T40*T35
      T104 = T48*Q2
      T111 = T40*Q2
      T114 = T40*Q1
      T118 = T18**2
      T119 = Q2*T118
      T124 = T48*T7
      T131 = T56*K
      T141 = T40*T5
      T145 = 172.D0*T94*T61-189.D0*T98*T56-104.D0*T101*T44-192.D0*T104*S
     #3*T72+176.D0*T104*T5*T20+172.D0*T111*T59-192.D0*T114*S1*T82+441.D0
     #*T119*K+441.D0*T98*K+44.D0*T124*T19-189.D0*T119+176.D0*T114*T7*T18
     #+126.D0*T98*T131-104.D0*T104*T35*T43+126.D0*T119*T131-189.D0*T119*
     #T56+44.D0*T141*T21-189.D0*T98
      QAS(N1,N1-2,10) = -0.125D0*T3*T4*T145/T90/S2
      T152 = T56*Q2
      T156 = K*Q1
      T162 = K*Q2
      T168 = T56*Q1
      T175 = T20*T43
      T176 = Q1*T175
      T183 = T18*T35
      T184 = Q2*T183
      T188 = T156*T72
      T196 = 1155.D0*T8*T152*T59-1155.D0*T6*T156*T61-1124.D0*T44*T83-115
     #5.D0*T8*T162*T59+1155.D0*T8*T60+1155.D0*T6*T168*T61-1412.D0*T36*T1
     #68*T72+1540.D0*T45*T176*K-1412.D0*T44*T152*T82+1540.D0*T37*T184*K+
     #1412.D0*T36*T188+1320.D0*T21*T152*T18-1540.D0*T37*T184
      T205 = T48*T97
      T208 = T40*T118
      T211 = T162*T82
      T229 = 1155.D0*T6*T62-1124.D0*T36*T73-1540.D0*T45*T176+780.D0*T21*
     #T19-4767.D0*T205*K-4767.D0*T208*K+1412.D0*T44*T211-1540.D0*T45*T16
     #8*T175-1540.D0*T37*T152*T183-1320.D0*T21*T162*T18+4767.D0*T205*T56
     #+4767.D0*T208*T56+4209.D0*T205+4209.D0*T208
      QAS(N1,N1-2,11) = 0.3125D-1*T32*(T196+T229)/T90/T11
      T237 = XMIN**2
      T238 = T237**2
      T239 = T238**2
      T242 = T111*T118
      T246 = Q1*T97*T7
      T250 = Q2*T118*T5
      T255 = T56**2
      T268 = T94*T97
      T271 = T40*T183
      T276 = T48*T175
      T281 = T48*T72
      T289 = -11676.D0*T19*T49-2970.D0*T8*T239+54188.D0*T242*K+55440.D0*
     #T246*T56-48510.D0*T250*K+55440.D0*T250*T56+6930.D0*T246*T255-48510
     #.D0*T246*K-13860.D0*T250*T131-2970.D0*T6*T239+6930.D0*T250*T255-13
     #860.D0*T246*T131+54188.D0*T268*K+23956.D0*T271*T37-4080.D0*T62*T14
     #1+23956.D0*T276*T45-18898.D0*T86*T8+14772.D0*T281*T36-18898.D0*T78
     #*T6+23352.D0*T19*T49*K
      T313 = T48*T43
      T321 = T40*T82
      T339 = 8160.D0*T62*K*T40*T5-4080.D0*T60*T124+23352.D0*T21*T41*K+37
     #796.D0*T78*T6*K-27094.D0*T242+37796.D0*T86*T156*T7-47912.D0*T271*T
     #37*K-15800.D0*T101*T188-27094.D0*T268+31185.D0*T250-15800.D0*T313*
     #T211+8160.D0*T60*K*T48*T7+31185.D0*T246-29544.D0*T321*T44*K-47912.
     #D0*T276*T45*K-29544.D0*T281*T36*K+7900.D0*T101*T73+7900.D0*T313*T8
     #3-11676.D0*T21*T41+14772.D0*T321*T44
      QAS(N1,N1-2,12) = -0.5208333333333333D-2*T3*T4*(T289+T339)/T90/T12
 703  CONTINUE
C
      DO 704 N1=4,NDIM
      K=DBLE(N1-1)
      T2 = DSQRT(K-2.D0)
      T3 = ABSB*T2
      T4 = K-1.D0
      T5 = DSQRT(T4)
      T6 = T3*T5
      T7 = DSQRT(K)
      T8 = S1**2
      T9 = T8*S1
      T10 = Q1*T9
      T11 = S3**2
      T12 = T11*S3
      T13 = Q2*T12
      T17 = S2**2
      T18 = T17**2
      QAS(N1,N1-3,5) = 0.4714045207910316D0*T6*T7*(T10-1.D0*T13)/T18
      QAS(N1,N1-3,6) = 0.D0
      T22 = T5*T4
      T24 = T11**2
      T25 = T24*S3
      T26 = Q2*T25
      T28 = T8**2
      T29 = T28*S1
      T30 = Q1*T29
      QAS(N1,N1-3,7) = 0.1767766952966369D1*T3*T22*T7*(-1.D0*T26+T30)/T1
     #8/T17
      T37 = T7*T5
      T38 = Q1*T28
      T39 = Q2*S3
      T42 = Q1*T8
      T45 = Q2*T11
      T48 = Q2*T24
      T49 = Q1*S1
      T52 = Q1**2
      T53 = T52*T29
      T55 = Q2**2
      T56 = T55*T25
      T60 = T17*S2
      QAS(N1,N1-3,8) = -0.1178511301977579D0*T37*T2*(-19.D0*T38*T39-4.D0
     #*T42*T13+4.D0*T45*T10+19.D0*T48*T49+23.D0*T53-23.D0*T56)/T18/T60
      T66 = K**2
      T70 = T24*T12
      T71 = Q2*T70
      T73 = T28*T9
      T74 = Q1*T73
      T76 = T18**2
      QAS(N1,N1-3,9) = 0.4949747468305832D1*T6*T7*(2.D0+T66-2.D0*K)*(-1.
     #D0*T71+T74)/T76
      T84 = T24*T11
      T85 = Q2*T84
      T96 = T28*T8
      T97 = Q1*T96
      QAS(N1,N1-3,10) = -0.2651650429449553D0*T7*T22*T2*(83.D0*T52*T73+4
     #5.D0*T85*T49-14.D0*T26*T42+14.D0*T30*T45-83.D0*T55*T70-24.D0*T38*T
     #13-45.D0*T97*T39+24.D0*T48*T10)/T76/S2
      T114 = T66*K
      T116 = T24**2
      T117 = T116*S3
      T120 = T66*Q2
      T135 = T28**2
      T136 = T135*S1
      T148 = K*Q2
      T151 = K*Q1
      T162 = T66*Q1
      T170 = -99.D0*T56*T42+233.D0*T52*Q1*T73-210.D0*T114*Q2*T117+630.D0
     #*T120*T117-21.D0*T13*T52*T28+21.D0*T55*T24*T10-352.D0*T52*T96*T39+
     #110.D0*T30*T55*T11-945.D0*Q1*T136+117.D0*T48*T52*T9-110.D0*T26*T52
     #*T8-233.D0*T55*Q2*T70-1365.D0*T148*T117+1365.D0*T151*T136+99.D0*T5
     #3*T45-117.D0*T38*T55*T12+352.D0*T55*T84*T49-630.D0*T162*T136+210.D
     #0*T114*Q1*T136+945.D0*Q2*T117
      QAS(N1,N1-3,11) = 0.5892556509887896D-1*T6*T7*T170/T76/T17
      T207 = T116*Q1*S1
      T216 = 37242.D0*K*T55*T117+18621.D0*T66*T52*T136-37242.D0*K*T52*T1
     #36-18621.D0*T66*T55*T117+14700.D0*Q2*T116*T49-5292.D0*T71*T42+5292
     #.D0*T74*T45+7625.D0*T85*T10-7625.D0*T97*T13-8025.D0*T26*T38+8025.D
     #0*T30*T48-14700.D0*Q1*T135*T39-14700.D0*T148*T207+7200.D0*T151*T28
     #*Q2*T25+7350.D0*T120*T207
      T218 = T135*Q2*S3
      T226 = T70*Q1*T8
      T232 = T96*Q2*T12
      T240 = T84*Q1*T9
      T244 = T73*Q2*T11
      T263 = 14700.D0*T151*T218-7200.D0*T148*T24*Q1*T29-2646.D0*T120*T22
     #6+5292.D0*T148*T226-5025.D0*T162*T232-7350.D0*T162*T218-35642.D0*T
     #55*T117+5025.D0*T120*T240+2646.D0*T162*T244-5292.D0*T151*T244-3600
     #.D0*T120*T25*Q1*T28+10050.D0*T151*T232+35642.D0*T52*T136-10050.D0*
     #T148*T240+3600.D0*T162*T29*Q2*T24
      QAS(N1,N1-3,12) = -0.5892556509887896D-2*T37*T2*(T216+T263)/T76/T6
     #0
 704  CONTINUE
C
      DO 705 N1=5,NDIM
      K=DBLE(N1-1)
      T2 = DSQRT(K-3.D0)
      T3 = ABSB*T2
      T5 = DSQRT(K-2.D0)
      T6 = T3*T5
      T8 = DSQRT(K-1.D0)
      T9 = DSQRT(K)
      T10 = T8*T9
      T11 = S3**2
      T12 = T11**2
      T13 = Q2*T12
      T14 = S1**2
      T15 = T14**2
      T16 = Q1*T15
      T18 = S2**2
      T19 = T18**2
      QAS(N1,N1-4,6) = -0.3125D0*T6*T10*(T13+T16)/T19/S2
      QAS(N1,N1-4,7) = 0.D0
      T27 = T3*T5*T8
      T28 = T12*T11
      T29 = Q2*T28
      T30 = T15*T14
      T31 = Q1*T30
      T35 = 2.D0*K-3.D0
      T36 = T18*S2
      QAS(N1,N1-4,8) = -0.65625D0*T27*T9*(T29+T31)*T35/T19/T36
      T43 = T10*T2
      T44 = Q1*T14
      T47 = Q2*T11
      T50 = Q2**2
      T51 = T50*T28
      T53 = Q1**2
      T54 = T53*T30
      T56 = T11*S3
      T57 = Q2*T56
      T58 = T14*S1
      T59 = Q1*T58
      T62 = Q2*S3
      T63 = T15*S1
      T64 = Q1*T63
      T67 = Q1*S1
      T68 = T12*S3
      T69 = Q2*T68
      T74 = T19**2
      QAS(N1,N1-4,9) = 0.8333333333333333D-1*T43*T5*(9.D0*T44*T13+9.D0*T
     #47*T16+22.D0*T51+22.D0*T54+18.D0*T57*T59-22.D0*T62*T64-22.D0*T67*T
     #69)/T74
      T79 = K**2
      T83 = T12**2
      T85 = T15**2
      QAS(N1,N1-4,10) = -0.196875D1*T27*T9*(-6.D0*K+7.D0+2.D0*T79)*(Q2*T
     #83+Q1*T85)/T74/S2
      T94 = T12*T56
      T98 = T15*T58
      QAS(N1,N1-4,11) = 0.125D-1*T43*T5*(-413.D0*T67*Q2*T94-413.D0*T62*Q
     #1*T98+150.D0*T16*T13+633.D0*T50*T83+35.D0*T59*T69+180.D0*T47*T31+1
     #80.D0*T44*T29+633.D0*T53*T85+35.D0*T57*T64)*T35/T74/T18
      T154 = -606.D0*T16*T50*T12+1532.D0*T50*Q2*T83+1212.D0*T31*T50*T11+
     #1466.D0*T51*T44+1212.D0*T29*T53*T14-1556.D0*T50*T56*T64-1556.D0*T5
     #3*T58*T69+2136.D0*T50*T68*T59-606.D0*T13*T53*T15+1466.D0*T54*T47+2
     #136.D0*T53*T63*T57
      T162 = Q2*T83*T11
      T171 = Q1*T85*T14
      T172 = T79*K
      T183 = -3104.D0*T53*T98*T62+1532.D0*T53*Q1*T85-8910.D0*T162*T79+21
     #780.D0*T162*K-3104.D0*T50*T94*T67+1980.D0*T171*T172-8910.D0*T171*T
     #79-19305.D0*T171+1980.D0*T162*T172-19305.D0*T162+21780.D0*T171*K
      QAS(N1,N1-4,12) = -0.5208333333333333D-2*T6*T10*(T154+T183)/T74/T3
     #6
705   CONTINUE
C
      DO 706 N1=6,NDIM
      K=DBLE(N1-1)
      T2 = DSQRT(K-4.D0)
      T3 = ABSB*T2
      T5 = DSQRT(K-3.D0)
      T6 = K-2.D0
      T7 = DSQRT(T6)
      T9 = T3*T5*T7
      T11 = DSQRT(K-1.D0)
      T12 = DSQRT(K)
      T13 = T12*T11
      T14 = S3**2
      T15 = T14**2
      T17 = Q2*T15*S3
      T19 = S1**2
      T20 = T19**2
      T22 = Q1*T20*S1
      T24 = S2**2
      T25 = T24**2
      QAS(N1,N1-5,7) = 0.2121320343559642D0*T9*T13*(-1.D0*T17+T22)/T25/T
     #24
      QAS(N1,N1-5,8) = 0.D0
      T31 = T7*T6
      T34 = T14*S3
      T35 = T15*T34
      T36 = Q2*T35
      T38 = T19*S1
      T39 = T20*T38
      T40 = Q1*T39
      T42 = T25**2
      QAS(N1,N1-5,9) = 0.9899494936611665D0*T3*T5*T31*T13*(-1.D0*T36+T40
     #)/T42
      T48 = T5*T2
      T50 = Q2*T15*T14
      T51 = Q1*S1
      T54 = Q2**2
      T57 = Q2*T15
      T58 = Q1*T38
      T61 = Q2*T14
      T64 = Q1**2
      T67 = Q1*T20
      T68 = Q2*T34
      T72 = Q1*T20*T19
      T73 = Q2*S3
      T76 = Q1*T19
      QAS(N1,N1-5,10) = -0.1767766952966369D-1*T13*T7*T48*(83.D0*T50*T51
     #-69.D0*T54*T35-52.D0*T57*T58+38.D0*T22*T61+69.D0*T64*T39+52.D0*T67
     #*T68-83.D0*T72*T73-38.D0*T17*T76)/T42/S2
      T87 = K**2
      T90 = T20**2
      T91 = T90*S1
      T93 = T15**2
      T94 = T93*S3
      QAS(N1,N1-5,11) = 0.1590990257669732D1*T9*T13*(-8.D0*K+2.D0*T87+11
     #.D0)*(Q1*T91-1.D0*Q2*T94)/T42/T24
      QAS(N1,N1-5,12) = -0.5892556509887896D-2*T13*T31*T48*(-1498.D0*Q1*
     #T90*T73+1911.D0*T64*T91+262.D0*T17*T67-262.D0*T22*T57+27.D0*T72*T6
     #8-27.D0*T50*T58+702.D0*T40*T61-702.D0*T36*T76-1911.D0*T54*T94+1498
     #.D0*Q2*T93*T51)/T42/T24/S2
 706  CONTINUE
C
      DO 707 N1=7,NDIM
      K=DBLE(N1-1)
      T2 = DSQRT(K-5.D0)
      T3 = ABSB*T2
      T5 = DSQRT(K-4.D0)
      T7 = DSQRT(K-3.D0)
      T8 = T5*T7
      T11 = DSQRT(K-2.D0)
      T13 = DSQRT(K-1.D0)
      T15 = DSQRT(K)
      T16 = S3**2
      T17 = T16**2
      T19 = Q2*T17*T16
      T20 = S1**2
      T21 = T20**2
      T23 = Q1*T21*T20
      T26 = S2**2
      T27 = T26*S2
      T28 = T26**2
      QAS(N1,N1-6,8) = -0.1458333333333333D0*T3*T8*T11*T13*T15*(T19+T23)
     #/T28/T27
      QAS(N1,N1-6,9) = 0.D0
      T36 = T3*T8*T11
      T37 = T13*T15
      T38 = T17**2
      T40 = T21**2
      T46 = T28**2
      QAS(N1,N1-6,10) = -0.375D0*T36*T37*(Q2*T38+Q1*T40)*(2.D0*K-5.D0)/T
     #46/S2
      T59 = Q2**2
      T62 = T20*S1
      T68 = T16*S3
      T87 = Q1**2
      QAS(N1,N1-6,11) = 0.2083333333333333D-2*T37*T11*T7*T2*T5*(265.D0*Q
     #1*T20*T19+381.D0*T59*T38+340.D0*Q1*T62*Q2*T17*S3+340.D0*Q2*T68*Q1*
     #T21*S1+265.D0*Q2*T16*T23-556.D0*Q2*S3*Q1*T21*T62-556.D0*Q1*S1*Q2*T
     #17*T68+381.D0*T87*T40-200.D0*Q1*T21*Q2*T17)/T46/T26
      T101 = K**2
      QAS(N1,N1-6,12) = -0.2578125D1*T36*T37*(8.D0-5.D0*K+T101)*(Q1*T40*
     #T20+Q2*T38*T16)/T46/T27
707   CONTINUE
C
      DO 708 N1=8,NDIM
      K=DBLE(N1-1)
      T2 = DSQRT(K-6.D0)
      T3 = ABSB*T2
      T5 = DSQRT(K-5.D0)
      T7 = DSQRT(K-4.D0)
      T8 = T5*T7
      T9 = K-3.D0
      T10 = DSQRT(T9)
      T14 = DSQRT(K-2.D0)
      T16 = DSQRT(K-1.D0)
      T17 = T14*T16
      T18 = DSQRT(K)
      T19 = S3**2
      T20 = T19*S3
      T21 = T19**2
      T23 = Q2*T21*T20
      T25 = S1**2
      T26 = T25*S1
      T27 = T25**2
      T29 = Q1*T27*T26
      T32 = S2**2
      T33 = T32**2
      T34 = T33**2
      QAS(N1,N1-7,9) = 0.1010152544552211D0*T3*T8*T10*T17*T18*(-1.D0*T23
     #+T29)/T34
      QAS(N1,N1-7,10) = 0.D0
      T42 = T27**2
      T43 = T42*S1
      T45 = T21**2
      T46 = T45*S3
      QAS(N1,N1-7,11) = 0.5682108063106185D0*T3*T8*T10*T9*T17*T18*(Q1*T4
     #3-1.D0*Q2*T46)/T34/T32
      T75 = Q2**2
      T81 = Q1**2
      QAS(N1,N1-7,12) = -0.8417937871268422D-3*T18*T16*T14*T10*T8*T2*(-1
     #075.D0*Q1*T42*Q2*S3+1075.D0*Q2*T45*Q1*S1-675.D0*Q2*T21*T19*Q1*T26-
     #522.D0*T23*Q1*T25-597.D0*T75*T46+522.D0*T29*Q2*T19+597.D0*T81*T43+
     #675.D0*Q1*T27*T25*Q2*T20+325.D0*Q2*T21*S3*Q1*T27-325.D0*Q1*T27*S1*
     #Q2*T21)/T34/T32/S2
 708  CONTINUE
C
      DO 709 N1=9,NDIM
      K=DBLE(N1-1)
      T2 = DSQRT(K-7.D0)
      T3 = ABSB*T2
      T5 = DSQRT(K-6.D0)
      T7 = DSQRT(K-5.D0)
      T10 = DSQRT(K-4.D0)
      T14 = DSQRT(K-3.D0)
      T16 = DSQRT(K-2.D0)
      T19 = DSQRT(K-1.D0)
      T21 = DSQRT(K)
      T22 = S3**2
      T23 = T22**2
      T24 = T23**2
      T26 = S1**2
      T27 = T26**2
      T28 = T27**2
      T32 = S2**2
      T33 = T32**2
      T34 = T33**2
      QAS(N1,N1-8,10) = -0.703125D-1*T3*T5*T7*T10*T14*T16*T19*T21*(Q2*T2
     #4+Q1*T28)/T34/S2
      QAS(N1,N1-8,11) = 0.D0
      QAS(N1,N1-8,12) = -0.21484375D0*T3*T5*T7*T10*T14*T16*T19*T21*(Q1*T
     #28*T26+Q2*T24*T22)*(2.D0*K-7.D0)/T34/T32/S2
 709  CONTINUE
C
      DO 710 N1=10,NDIM
      K=DBLE(N1-1)
      T2 = DSQRT(K-8.D0)
      T5 = DSQRT(K-7.D0)
      T8 = DSQRT(K-6.D0)
      T10 = DSQRT(K-5.D0)
      T13 = DSQRT(K-4.D0)
      T17 = DSQRT(K-3.D0)
      T19 = DSQRT(K-2.D0)
      T22 = DSQRT(K-1.D0)
      T24 = DSQRT(K)
      T25 = S1**2
      T26 = T25**2
      T27 = T26**2
      T30 = S3**2
      T31 = T30**2
      T32 = T31**2
      T38 = S2**2
      T39 = T38**2
      T40 = T39**2
      QAS(N1,N1-9,11) = 0.4910463758239913D-1*ABSB*T2*T5*T8*T10*T13*T17*
     #T19*T22*T24*(Q1*T27*S1-1.D0*Q2*T32*S3)/T40/T38
      QAS(N1,N1-9,12) = 0.D0
 710  CONTINUE
C
      DO 711 N1=11,NDIM
      K=DBLE(N1-1)
      T2 = DSQRT(K-9.D0)
      T5 = DSQRT(K-8.D0)
      T8 = DSQRT(K-7.D0)
      T10 = DSQRT(K-6.D0)
      T13 = DSQRT(K-5.D0)
      T17 = DSQRT(K-4.D0)
      T19 = DSQRT(K-3.D0)
      T22 = DSQRT(K-2.D0)
      T25 = DSQRT(K-1.D0)
      T26 = DSQRT(K)
      T28 = S1**2
      T29 = T28**2
      T30 = T29**2
      T33 = S3**2
      T34 = T33**2
      T35 = T34**2
      T39 = S2**2
      T41 = T39**2
      T42 = T41**2
      QAS(N1,N1-10,12) = -0.34375D-1*ABSB*T2*T5*T8*T10*T13*T17*T19*T22*T
     #25*T26*(Q1*T30*T28+Q2*T35*T33)/T42/T39/S2
 711  CONTINUE
C
      DO N1=2,NDIM
        DO N2=1,N1-1
          DO KTEK=1,KMAX
            QAS(N2,N1,KTEK)=-QAS(N1,N2,KTEK)
          ENDDO
        ENDDO
      ENDDO
      RETURN
      END
C
      SUBROUTINE VQAS0W(XS,KMAX,NDIM,VV,QQ,FXSAS,EPS,RMATCH)
      IMPLICIT REAL*8 (A-H,O-Z)
      LOGICAL   FXSAS
      DIMENSION VAS(NDIM,NDIM,2:12),VV(NDIM,NDIM)
      DIMENSION QAS(NDIM,NDIM,1:12),QQ(NDIM,NDIM)
      COMMON /CHARGE/ S1,S2,S3,Q1,Q2,XMIN
      ABSB=1.D0
      IF (XS.LE.0.D0) ABSB=-1.D0
      CALL VQAS0(VAS,QAS,KMAX,NDIM,ABSB)
C
      IF(FXSAS) THEN
C
          KTEK = KMAX
          FMAX=0.D0
          DO J=1,NDIM
            DO J1=J,NDIM
              FMAX=DMAX1(FMAX,DABS(VAS(J,J1,KTEK)))
              FMAX=DMAX1(FMAX,DABS(QAS(J,J1,KTEK)))
            ENDDO
          ENDDO
          RMATCH=(FMAX/EPS)**(1.D0/DBLE(KTEK))
C
      ELSE
C
        DO N1=1,NDIM
          DO N2=1,NDIM
            VV(N1,N2)=0D0
            QQ(N1,N2)=0D0
          ENDDO
        ENDDO
        XSTEK = XS ** 2
        DO KTEK=2,KMAX
          DO N1=1,NDIM
            DO N2=N1,NDIM
              VV(N1,N2)=VV(N1,N2)+VAS(N1,N2,KTEK)/XSTEK
            ENDDO
          ENDDO
          XSTEK = XSTEK * XS
        ENDDO
        DO N1=1,NDIM
          VV(N1,N1)=VV(N1,N1)+2*ABSB*(Q1+Q2)/S2/XS+2*N1-1
        ENDDO
        DO N1=1,NDIM
          DO N2=N1,NDIM
            VV(N2,N1)=VV(N1,N2)
          ENDDO
        ENDDO
C
        XSTEK = XS
        DO KTEK=1,KMAX
          DO N1=1,NDIM
            DO N2=N1,NDIM
              QQ(N1,N2)=QQ(N1,N2)+QAS(N1,N2,KTEK)/XSTEK
            ENDDO
          ENDDO
          XSTEK = XSTEK * XS
        ENDDO
        DO N1=1,NDIM
          DO N2=N1,NDIM
            QQ(N2,N1)= - QQ(N1,N2)
          ENDDO
        ENDDO
C
      ENDIF
      RETURN
      END
C
      SUBROUTINE RCWFNN(RHO,ETA,MINL,MAXL,FC,FCP,GC,GCP,ACCUR,STEP)
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
C .                                                                   .
C .   P R O G R A M                                                   .
C .                  RCWFNN TO CALCULATE THE COULOMB REGULAR AND      .
C .                  IRREGULAR SOLUTIONS AND THEIR DERIVATIVES.       .
C .                  THIS PROGRAM IS THE MODIFIED VERSION OF THE      .
C .                  PROGRAM RCWFN FOR DOUBLE PRECISION TYPE.         .
C .                  PUBLISHED IN: A.R. BARNETT, ET AL, COMPUTER      .
C .                  PHYSICS COMMUNICATIONS 8 (1974) 377--395.        .
C .                                                                   .
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
      IMPLICIT  REAL*8   (A-H,O-Z)
      REAL*8   K,K1,K2,K3,K4,M1,M2,M3,M4
      DIMENSION FC(1),FCP(1),GC(1),GCP(1)
C *** COULOMB WAVEFUNCTIONS CALCULATED AT R = RHO BY THE
C *** CONTINUED-FRACTION METHOD OF STEED   MINL,MAXL ARE ACTUAL L-VALUES
C *** SEE BARNETT FENG STEED AND GOLDFARB COMPUTER PHYSICS COMMUN 1974
      PACE = STEP
      ACC  = ACCUR
      IF(PACE.LT.100.0D0) PACE = 100.0D0
      IF(ACC.LT.1.0D-15.OR.ACC.GT.1.0D-6) ACC = 1.0D-6
      R    = RHO
      KTR  = 1
      LMAX = MAXL
      LMIN1= MINL + 1
      XLL1 = FLOAT(MINL*LMIN1)
      ETA2 = ETA*ETA
      TURN = ETA + SQRT(ETA2 + XLL1)
      IF(R.LT.TURN.AND.ABS(ETA).GE.1.0D-6) KTR = -1
      KTRP = KTR
      GO TO 2
1     R    = TURN
      TF   = F
      TFP  = FP
      LMAX = MINL
      KTRP = 1
2     ETAR = ETA*R
      RHO2 =   R*R
      PL   = FLOAT(LMAX + 1)
      PMX  = PL + 0.5D0
C *** CONTINUED FRACTION FOR FP(MAXL)/F(MAXL)  XL IS F  XLPRIME IS FP **
      FP  = ETA/PL + PL/R
      DK  = ETAR*2.0D0
      DEL = 0.0D0
      D   = 0.0D0
      F   = 1.0D0
      K   = (PL*PL - PL + ETAR)*(2.0D0*PL - 1.0D0)
      IF(PL*PL+PL+ETAR.NE.0.0D0) GO TO 3
      R   = R + 1.0D-6
      GO TO 2
3     H   = (PL*PL + ETA2)*(1.0D0 - PL*PL)*RHO2
      K   = K + DK + PL*PL*6.0D0
      D   =  1.0D0/(D*H + K)
      DEL =  DEL*(D*K - 1.0D0)
      IF(PL.LT.PMX) DEL = -R*(PL*PL + ETA2)*(PL + 1.0D0)*D/PL
      PL  = PL + 1.0D0
      FP  = FP + DEL
      IF(D.LT.0.0D0) F = -F
      IF(PL.GT.20000.D0) GO TO 11
      IF(ABS(DEL/FP).GE.ACC) GO TO 3
      FP  = F*FP
      IF( LMAX.EQ.MINL) GO TO 5
      FC (LMAX+1) = F
      FCP(LMAX+1) = FP
C *** DOWNWARD RECURSION TO MINL FOR F AND FP, ARRAYS GC,GCP ARE STORAGE
      L  = LMAX
      DO 4 LP  = LMIN1,LMAX
      PL = FLOAT(L)
      GC (L+1) = ETA/PL + PL/R
      GCP(L+1) = SQRT(ETA2 + PL*PL)/PL
      FC (L)   = (GC(L+1)*FC(L+1) + FCP(L+1))/GCP(L+1)
      FCP(L)   =  GC(L+1)*FC(L)   - GCP(L+1)*FC(L+1)
4     L  = L - 1
      F  = FC (LMIN1)
      FP = FCP(LMIN1)
5     IF(KTRP.EQ.-1) GO TO 1
C *** REPEAT FOR R = TURN IF RHO LT TURN
C *** NOW OBTAIN P + I.Q FOR MINL FROM CONTINUED FRACTION (32)
C *** REAL ARITHMETIC TO FACILITATE CONVERSION TO IBM USING REAL*8
      P  = 0.0D0
      Q  = R - ETA
      PL = 0.0D0
      AR = -(ETA2 + XLL1)
      AI =   ETA
      BR = 2.0D0*Q
      BI = 2.0D0
      WI = 2.0D0*ETA
      DR =   BR/(BR*BR + BI*BI)
      DI =  -BI/(BR*BR + BI*BI)
      DP = -(AR*DI + AI*DR)
      DQ =  (AR*DR - AI*DI)
6     P  =  P + DP
      Q  =  Q + DQ
      PL = PL + 2.0D0
      AR = AR + PL
      AI = AI + WI
      BI = BI + 2.0D0
      D  = AR*DR - AI*DI + BR
      DI = AI*DR + AR*DI + BI
      T  = 1.0D0/(D*D + DI*DI)
      DR =  T*D
      DI = -T*DI
      H  = BR*DR - BI*DI - 1.0D0
      K  = BI*DR + BR*DI
      T  = DP*H  - DQ*K
      DQ = DP*K  + DQ*H
      DP = T
      IF(PL.GT.46000.D0) GO TO 11
      IF(ABS(DP)+ABS(DQ).GE.(ABS(P)+ABS(Q))*ACC) GO TO 6
      P  = P/R
      Q  = Q/R
C *** SOLVE FOR FP,G,GP AND NORMALISE F  AT L=MINL
      G  = (FP - P*F)/Q
      GP = P*G - Q*F
      W  = 1.0D0/SQRT(FP*G - F*GP)
      G  = W*G
      GP = W*GP
      IF(KTR.EQ.1) GO TO 8
      F  = TF
      FP = TFP
      LMAX = MAXL
C *** RUNGE-KUTTA INTEGRATION OF G(MINL) AND GP(MINL) INWARDS FROM TURN
C ***             SEE FOX AND MAYERS 1968 PG 202
      I2=IDINT(PACE*ABS(RHO-TURN)+0.001D0)
      R3=1.D0/3.D0
      H=(RHO-TURN)/(1.0D0+DFLOAT(I2))
      H2=0.5D0*H
      ETAH=ETA*H
      H2LL=H2*XLL1
      S=(ETAH+H2LL/R)/R-H2
7     RH2= R + H2
      T  = (ETAH + H2LL/RH2)/RH2 - H2
      K1 = H2*GP
      M1 =  S*G
      K2 = H2*(GP + M1)
      M2 =  T*(G  + K1)
      K3 =  H*(GP + M2)
      M3 =  T*(G  + K2)
      M3 =     M3 + M3
      K4 = H2*(GP + M3)
      RH = R + H
      S  = (ETAH + H2LL/RH )/RH  - H2
      M4 =  S*(G + K3)
      G  = G  + (K1 + K2 + K2 + K3 + K4)*R3
      GP = GP + (M1 + M2 + M2 + M3 + M4)*R3
      R  = RH
      I2 = I2 - 1
      IF(ABS(GP).GT.1.0D300) GO TO 11
      IF(I2.GE.0) GO TO 7
      W  = 1.0D0/(FP*G - F*GP)
C *** UPWARD RECURSION FROM GC(MINL) AND GCP(MINL),STORED VALUES ARE R,S
C *** RENORMALISE FC,FCP FOR EACH L-VALUE
8     GC (LMIN1) = G
      GCP(LMIN1) = GP
      IF(LMAX.EQ.MINL) GO TO 10
      DO  9  L = LMIN1,LMAX
      T        = GC(L+1)
      GC (L+1) = (GC(L)*GC (L+1) - GCP(L))/GCP(L+1)
      GCP(L+1) =  GC(L)*GCP(L+1) - GC(L+1)*T
      FC (L+1) = W*FC (L+1)
9     FCP(L+1) = W*FCP(L+1)
      FC (LMIN1) = FC (LMIN1)*W
      FCP(LMIN1) = FCP(LMIN1)*W
      RETURN
10    FC (LMIN1) = W*F
      FCP(LMIN1) = W*FP
      RETURN
11    W  = 0.0D0
      G  = 0.0D0
      GP = 0.0D0
      GO TO 8
      END
C
      SUBROUTINE GAMMA(X,GA)
C
C     ==================================================
C     Purpose: Compute gamma function (x)
C     Input :  x  --- Argument of (x)
C                     ( x is not equal to 0,-1,-2,)
C     Output:  GA --- (x)
C     ==================================================
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION G(26)
      PI=3.141592653589793D0
      IF (X.EQ.INT(X)) THEN
         IF (X.GT.0.0D0) THEN
            GA=1.0D0
            M1=X-1
            DO 10 K=2,M1
10             GA=GA*K
         ELSE
            GA=1.0D+300
         ENDIF
      ELSE
         IF (DABS(X).GT.1.0D0) THEN
            Z=DABS(X)
            M=INT(Z)
            R=1.0D0
            DO 15 K=1,M
15             R=R*(Z-K)
            Z=Z-M
         ELSE
            Z=X
         ENDIF
         DATA G/1.0D0,0.5772156649015329D0,
     &        -0.6558780715202538D0, -0.420026350340952D-1,
     &        0.1665386113822915D0,-.421977345555443D-1,
     &        -.96219715278770D-2, .72189432466630D-2,
     &        -.11651675918591D-2, -.2152416741149D-3,
     &        .1280502823882D-3, -.201348547807D-4,
     &        -.12504934821D-5, .11330272320D-5,
     &        -.2056338417D-6, .61160950D-8,
     &        .50020075D-8, -.11812746D-8,
     &        .1043427D-9, .77823D-11,
     &        -.36968D-11, .51D-12,
     &        -.206D-13, -.54D-14, .14D-14, .1D-15/
         GR=G(26)
         DO 20 K=25,1,-1
20          GR=GR*Z+G(K)
         GA=1.0D0/(GR*Z)
         IF (DABS(X).GT.1.0D0) THEN
            GA=GA*R
            IF (X.LT.0.0D0) GA=-PI/(X*GA*DSIN(PI*X))
         ENDIF
      ENDIF
      RETURN
      END
C
      SUBROUTINE CHGU(A,B,X,HU,MD)
C
C     =======================================================
C     Purpose: Compute the confluent hypergeometric function
C              U(a,b,x)
C     Input  : a  --- Parameter
C              b  --- Parameter
C              x  --- Argument  ( x > 0 )
C     Output:  HU --- U(a,b,x)
C              MD --- Method code
C     Routines called:
C          (1) CHGUS for small x ( MD=1 )
C          (2) CHGUL for large x ( MD=2 )
C          (3) CHGUBI for integer b ( MD=3 )
C          (4) CHGUIT for numerical integration ( MD=4 )
C     =======================================================
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      LOGICAL IL1,IL2,IL3,BL1,BL2,BL3,BN
      AA=A-B+1.0D0
      IL1=A.EQ.INT(A).AND.A.LE.0.0
      IL2=AA.EQ.INT(AA).AND.AA.LE.0.0
      IL3=ABS(A*(A-B+1.0))/X.LE.2.0
      BL1=X.LE.5.0.OR.(X.LE.10.0.AND.A.LE.2.0)
      BL2=(X.GT.5.0.AND.X.LE.12.5).AND.(A.GE.1.0.AND.B.GE.A+4.0)
      BL3=X.GT.12.5.AND.A.GE.5.0.AND.B.GE.A+5.0
      BN=B.EQ.INT(B).AND.B.NE.0.0
      ID1=-100
      IF (B.NE.INT(B)) THEN
         CALL CHGUS(A,B,X,HU,ID1)
         MD=1
         IF (ID1.GE.6) RETURN
         HU1=HU
      ENDIF
      IF (IL1.OR.IL2.OR.IL3) THEN
         CALL CHGUL(A,B,X,HU,ID)
         MD=2
         IF (ID.GE.6) RETURN
         IF (ID1.GT.ID) THEN
            MD=1
            ID=ID1
            HU=HU1
         ENDIF
      ENDIF
      IF (A.GE.0.0) THEN
         IF (BN.AND.(BL1.OR.BL2.OR.BL3)) THEN
            CALL CHGUBI(A,B,X,HU,ID)
            MD=3
         ELSE
            CALL CHGUIT(A,B,X,HU,ID)
            MD=4
         ENDIF
      ELSE
         IF (B.LE.A) THEN
            A00=A
            B00=B
            A=A-B+1.0D0
            B=2.0D0-B
            CALL CHGUIT(A,B,X,HU,ID)
            HU=X**(1.0D0-B00)*HU
            A=A00
            B=B00
            MD=4
         ELSE IF (BN.AND.(.NOT.IL1)) THEN
            CALL CHGUBI(A,B,X,HU,ID)
            MD=3
         ENDIF
      ENDIF
      IF (ID.LT.6) WRITE(*,*)'No accurate result obtained'
      RETURN
      END
C
      SUBROUTINE CHGUS(A,B,X,HU,ID)
C
C     ======================================================
C     Purpose: Compute confluent hypergeometric function
C              U(a,b,x) for small argument x
C     Input  : a  --- Parameter
C              b  --- Parameter ( b <> 0,-1,-2,...)
C              x  --- Argument
C     Output:  HU --- U(a,b,x)
C              ID --- Estimated number of significant digits
C     Routine called: GAMMA for computing gamma function
C     ======================================================
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      ID=-100
      PI=3.141592653589793D0
      CALL GAMMA(A,GA)
      CALL GAMMA(B,GB)
      XG1=1.0D0+A-B
      CALL GAMMA(XG1,GAB)
      XG2=2.0D0-B
      CALL GAMMA(XG2,GB2)
      HU0=PI/DSIN(PI*B)
      R1=HU0/(GAB*GB)
      R2=HU0*X**(1.0D0-B)/(GA*GB2)
      HU=R1-R2
      HMAX=0.0D0
      HMIN=1.0D+300
      DO 10 J=1,150
         R1=R1*(A+J-1.0D0)/(J*(B+J-1.0D0))*X
         R2=R2*(A-B+J)/(J*(1.0D0-B+J))*X
         HU=HU+R1-R2
         HUA=DABS(HU)
         IF (HUA.GT.HMAX) HMAX=HUA
         IF (HUA.LT.HMIN) HMIN=HUA
         IF (DABS(HU-H0).LT.DABS(HU)*1.0D-15) GO TO 15
10       H0=HU
15    D1=LOG10(HMAX)
      IF (HMIN.NE.0.0) D2=LOG10(HMIN)
      ID=15-ABS(D1-D2)
      RETURN
      END
C
      SUBROUTINE CHGUL(A,B,X,HU,ID)
C
C     =======================================================
C     Purpose: Compute the confluent hypergeometric function
C              U(a,b,x) for large argument x
C     Input  : a  --- Parameter
C              b  --- Parameter
C              x  --- Argument
C     Output:  HU --- U(a,b,x)
C              ID --- Estimated number of significant digits
C     =======================================================
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      LOGICAL IL1,IL2
      ID=-100
      AA=A-B+1.0D0
      IL1=A.EQ.INT(A).AND.A.LE.0.0
      IL2=AA.EQ.INT(AA).AND.AA.LE.0.0
      IF (IL1) NM=ABS(A)
      IF (IL2) NM=ABS(AA)
      IF (IL1.OR.IL2) THEN
         HU=1.0D0
         R=1.0D0
         DO 10 K=1,NM
            R=-R*(A+K-1.0D0)*(A-B+K)/(K*X)
            HU=HU+R
10       CONTINUE
         HU=X**(-A)*HU
         ID=10
      ELSE
         HU=1.0D0
         R=1.0D0
         DO 15 K=1,25
            R=-R*(A+K-1.0D0)*(A-B+K)/(K*X)
            RA=DABS(R)
            IF (K.GT.5.AND.RA.GE.R0.OR.RA.LT.1.0D-15) GO TO 20
            R0=RA
15          HU=HU+R
20       ID=ABS(LOG10(RA))
         HU=X**(-A)*HU
      ENDIF
      RETURN
      END
C
      SUBROUTINE CHGUBI(A,B,X,HU,ID)
C
C     ======================================================
C     Purpose: Compute confluent hypergeometric function
C              U(a,b,x) with integer b ( b = 1,2,... )
C     Input  : a  --- Parameter
C              b  --- Parameter
C              x  --- Argument
C     Output:  HU --- U(a,b,x)
C              ID --- Estimated number of significant digits
C     Routines called:
C          (1) GAMMA for computing gamma function (x)
C          (2) PSI for computing psi function
C     ======================================================
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      ID=-100
      EL=0.5772156649015329D0
      N=ABS(B-1)
      RN1=1.0D0
      RN=1.0D0
      DO 10 J=1,N
         RN=RN*J
         IF (J.EQ.N-1) RN1=RN
10    CONTINUE
      CALL PSI(A,PS)
      CALL GAMMA(A,GA)
      IF (B.GT.0.0) THEN
         A0=A
         A1=A-N
         A2=A1
         CALL GAMMA(A1,GA1)
         UA=(-1)**(N-1)/(RN*GA1)
         UB=RN1/GA*X**(-N)
      ELSE
         A0=A+N
         A1=A0
         A2=A
         CALL GAMMA(A1,GA1)
         UA=(-1)**(N-1)/(RN*GA)*X**N
         UB=RN1/GA1
      ENDIF
      HM1=1.0D0
      R=1.0D0
      HMAX=0.0D0
      HMIN=1.0D+300
      DO 15 K=1,150
         R=R*(A0+K-1.0D0)*X/((N+K)*K)
         HM1=HM1+R
         HU1=DABS(HM1)
         IF (HU1.GT.HMAX) HMAX=HU1
         IF (HU1.LT.HMIN) HMIN=HU1
         IF (DABS(HM1-H0).LT.DABS(HM1)*1.0D-15) GO TO 20
15       H0=HM1
20    DA1=LOG10(HMAX)
      IF (HMIN.NE.0.0) DA2=LOG10(HMIN)
      ID=15-ABS(DA1-DA2)
      HM1=HM1*DLOG(X)
      S0=0.0D0
      DO 25 M=1,N
         IF (B.GE.0.0) S0=S0-1.0D0/M
25       IF (B.LT.0.0) S0=S0+(1.0D0-A)/(M*(A+M-1.0D0))
      HM2=PS+2.0D0*EL+S0
      R=1.0D0
      HMAX=0.0D0
      HMIN=1.0D+300
      DO 50 K=1,150
         S1=0.0D0
         S2=0.0D0
         IF (B.GT.0.0) THEN
            DO 30 M=1,K
30             S1=S1-(M+2.0D0*A-2.0D0)/(M*(M+A-1.0D0))
            DO 35 M=1,N
35             S2=S2+1.0D0/(K+M)
         ELSE
            DO 40 M=1,K+N
40             S1=S1+(1.0D0-A)/(M*(M+A-1.0D0))
            DO 45 M=1,K
45             S2=S2+1.0D0/M
         ENDIF
         HW=2.0D0*EL+PS+S1-S2
         R=R*(A0+K-1.0D0)*X/((N+K)*K)
         HM2=HM2+R*HW
         HU2=DABS(HM2)
         IF (HU2.GT.HMAX) HMAX=HU2
         IF (HU2.LT.HMIN) HMIN=HU2
         IF (DABS((HM2-H0)/HM2).LT.1.0D-15) GO TO 55
50       H0=HM2
55    DB1=LOG10(HMAX)
      IF (HMIN.NE.0.0) DB2=LOG10(HMIN)
      ID1=15-ABS(DB1-DB2)
      IF (ID1.LT.ID) ID=ID1
      HM3=1.0D0
      IF (N.EQ.0) HM3=0.0D0
      R=1.0D0
      DO 60 K=1,N-1
         R=R*(A2+K-1.0D0)/((K-N)*K)*X
60       HM3=HM3+R
      SA=UA*(HM1+HM2)
      SB=UB*HM3
      HU=SA+SB
      IF (SA.NE.0.0) ID1=INT(LOG10(ABS(SA)))
      IF (HU.NE.0.0) ID2=INT(LOG10(ABS(HU)))
      IF (SA*SB.LT.0.0) ID=ID-ABS(ID1-ID2)
      RETURN
      END
C
      SUBROUTINE CHGUIT(A,B,X,HU,ID)
C
C     ======================================================
C     Purpose: Compute hypergeometric function U(a,b,x) by
C              using Gaussian-Legendre integration (n=60)
C     Input  : a  --- Parameter ( a > 0 )
C              b  --- Parameter
C              x  --- Argument ( x > 0 )
C     Output:  HU --- U(a,b,z)
C              ID --- Estimated number of significant digits
C     Routine called: GAMMA for computing (x)
C     ======================================================
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION T(30),W(30)
      DATA T/ .259597723012478D-01, .778093339495366D-01,
     &        .129449135396945D+00, .180739964873425D+00,
     &        .231543551376029D+00, .281722937423262D+00,
     &        .331142848268448D+00, .379670056576798D+00,
     &        .427173741583078D+00, .473525841761707D+00,
     &        .518601400058570D+00, .562278900753945D+00,
     &        .604440597048510D+00, .644972828489477D+00,
     &        .683766327381356D+00, .720716513355730D+00,
     &        .755723775306586D+00, .788693739932264D+00,
     &        .819537526162146D+00, .848171984785930D+00,
     &        .874519922646898D+00, .898510310810046D+00,
     &        .920078476177628D+00, .939166276116423D+00,
     &        .955722255839996D+00, .969701788765053D+00,
     &        .981067201752598D+00, .989787895222222D+00,
     &        .995840525118838D+00, .999210123227436D+00/
      DATA W/ .519078776312206D-01, .517679431749102D-01,
     &        .514884515009810D-01, .510701560698557D-01,
     &        .505141845325094D-01, .498220356905502D-01,
     &        .489955754557568D-01, .480370318199712D-01,
     &        .469489888489122D-01, .457343797161145D-01,
     &        .443964787957872D-01, .429388928359356D-01,
     &        .413655512355848D-01, .396806954523808D-01,
     &        .378888675692434D-01, .359948980510845D-01,
     &        .340038927249464D-01, .319212190192963D-01,
     &        .297524915007890D-01, .275035567499248D-01,
     &        .251804776215213D-01, .227895169439978D-01,
     &        .203371207294572D-01, .178299010142074D-01,
     &        .152746185967848D-01, .126781664768159D-01,
     &        .100475571822880D-01, .738993116334531D-02,
     &        .471272992695363D-02, .202681196887362D-02/
      ID=7
      A1=A-1.0D0
      B1=B-A-1.0D0
      C=12.0/X
      DO 20 M=10,100,5
         HU1=0.0D0
         G=0.5D0*C/M
         D=G
         DO 15 J=1,M
            S=0.0D0
            DO 10 K=1,30
               T1=D+G*T(K)
               T2=D-G*T(K)
               F1=DEXP(-X*T1)*T1**A1*(1.0D0+T1)**B1
               F2=DEXP(-X*T2)*T2**A1*(1.0D0+T2)**B1
               S=S+W(K)*(F1+F2)
10          CONTINUE
            HU1=HU1+S*G
            D=D+2.0D0*G
15       CONTINUE
         IF (DABS(1.0D0-HU0/HU1).LT.1.0D-7) GO TO 25
         HU0=HU1
20    CONTINUE
25    CALL GAMMA(A,GA)
      HU1=HU1/GA
      DO 40 M=2,10,2
         HU2=0.0D0
         G=0.5D0/M
         D=G
         DO 35 J=1,M
            S=0.0D0
            DO 30 K=1,30
               T1=D+G*T(K)
               T2=D-G*T(K)
               T3=C/(1.0D0-T1)
               T4=C/(1.0D0-T2)
               F1=T3*T3/C*DEXP(-X*T3)*T3**A1*(1.0D0+T3)**B1
               F2=T4*T4/C*DEXP(-X*T4)*T4**A1*(1.0D0+T4)**B1
               S=S+W(K)*(F1+F2)
30          CONTINUE
            HU2=HU2+S*G
            D=D+2.0D0*G
35       CONTINUE
         IF (DABS(1.0D0-HU0/HU2).LT.1.0D-7) GO TO 45
         HU0=HU2
40    CONTINUE
45    CALL GAMMA(A,GA)
      HU2=HU2/GA
      HU=HU1+HU2
      RETURN
      END
C
      SUBROUTINE PSI(X,PS)
C
C     ======================================
C     Purpose: Compute Psi function
C     Input :  x  --- Argument of psi(x)
C     Output:  PS --- psi(x)
C     ======================================
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      XA=DABS(X)
      PI=3.141592653589793D0
      EL=.5772156649015329D0
      S=0.0D0
      IF (X.EQ.INT(X).AND.X.LE.0.0) THEN
         PS=1.0D+300
         RETURN
      ELSE IF (XA.EQ.INT(XA)) THEN
         N=XA
         DO 10 K=1 ,N-1
10          S=S+1.0D0/K
         PS=-EL+S
      ELSE IF (XA+.5D0.EQ.INT(XA+.5)) THEN
         N=XA-.5D0
         DO 20 K=1,N
20          S=S+1.0D0/(2.0D0*K-1.0D0)
         PS=-EL+2.0D0*S-1.386294361119891D0
      ELSE
         IF (XA.LT.10.0D0) THEN
            N=10-INT(XA)
            DO 30 K=0,N-1
30             S=S+1.0D0/(XA+K)
            XA=XA+N
         ENDIF
         X2=1.0D0/(XA*XA)
         A1=-.8333333333333D-01
         A2=.83333333333333333D-02
         A3=-.39682539682539683D-02
         A4=.41666666666666667D-02
         A5=-.75757575757575758D-02
         A6=.21092796092796093D-01
         A7=-.83333333333333333D-01
         A8=.4432598039215686D0
         PS=DLOG(XA)-.5D0/XA+X2*(((((((A8*X2+A7)*X2+
     &      A6)*X2+A5)*X2+A4)*X2+A3)*X2+A2)*X2+A1)
         PS=PS-S
      ENDIF
      IF (X.LT.0.0) PS=PS-PI*DCOS(PI*X)/DSIN(PI*X)-1.0D0/X
      RETURN
      END
C
      DOUBLE PRECISION FUNCTION ARGGAMMA(LX,Y,POGR)
      IMPLICIT REAL*8 ( A-H,O-Z )
C CALCULATION PSI(X) BY FORMULAS [6.3.2, 6.3.3]
      PSI = -0.57721566490153286061D0
      PI = DACOS(-1D0)
      DO J = 1 , LX-1
        PSI = PSI + 1.D0 / J
      ENDDO
C CALCULATION OF SECOND MONOM
      XN = 0.D0
      VTORSLAG = 0.D0
 20   SLAG=(Y/(LX+XN)) - DATAN(Y/(LX+XN))
      XN = XN + 1.D0
      VTORSLAG = VTORSLAG + SLAG
      SLAG = DABS(SLAG)
      IF (SLAG .GT. POGR) GOTO 20
C  CALCULATION ARGGAMMA
      SLAG = Y * PSI + VTORSLAG
C  MOVE TO INTERVAL 0..PI
 21   IF (SLAG .LT. 0D0) SLAG = SLAG + PI
      IF (SLAG .LT. 0D0) GOTO 21
 22   IF (SLAG .GT. PI)  SLAG = SLAG - PI
      IF (SLAG .GT. PI)  GOTO 22
      ARGGAMMA = SLAG
      RETURN
      END